package com.polytechnik.algorithms;
import com.polytechnik.utils.OrthogonalPolynomialsChebyshevBasis;

/** Histogram distribution.
  * @version $Id: HistogramDirect.java,v 1.2 2020/09/27 08:44:34 mal Exp $
  * @author Vladislav Malyshkin mal@gromco.com
  */
public class HistogramDirect {


    static double countF(final double minF,final double maxF,final java.util.ArrayList<ObservationXF> data,final boolean xcol_is_weight)
    {
	double n=0;
	for(ObservationXF o: data)
	{
	    if(minF<=o.f && o.f<maxF){
		if(xcol_is_weight) n+=o.x;
		else n++;
	    }
	}
	//System.err.println("minF="+minF+" maxF="+maxF+" n="+n);
	return n;
    }

    public static void main(String [] args) throws java.io.IOException
    {
	if(args.length!=2)
	{
	    System.err.println("HistogramDirect inputfile_from_HistogramDistribution file_data_in_second_col \n");
	    System.exit(1);
	}
	final String fbins=args[0],fdata=args[1];

	final java.util.ArrayList<ObservationXF> hist_bins=
	    DataReadObservationXF.getObservations(fbins,2,1,0);
	final java.util.ArrayList<ObservationXF> observations=
	    DataReadObservationXF.getObservations(fdata,8,0,1);
	System.err.println("bin="+hist_bins.size()+" observations="+observations.size()+" N Years="+(1+observations.get(observations.size()-1).x-observations.get(0).x));
	double prevx=0;
	for(int k=0;k<observations.size();k++){
	    double xcur=observations.get(k).x;
	    if(xcur!=prevx+1){
		System.err.println("k="+k+"xcur="+xcur+"prevx="+prevx);
	    }
	    prevx=xcur;
	}

	double minF=hist_bins.get(0).f,dF=hist_bins.get(1).f-minF;
	final int nb=hist_bins.size();
	for(int j=-nb-5;j<2*nb+5;j++)
	{
	    final double f=minF+j*dF,c=countF(f-dF/2,f+dF/2,observations,false);
	    System.out.println(String.valueOf(f)+"\t"+c);
	}


    }

}
