package com.polytechnik.algorithms;


class MatrFMatr {


    static void printMatr(final String txt,final double [][] m)
    {
	System.err.println(txt+" n="+m.length);
	final int n=m.length;
	for(int i=0;i<n;i++)
	{
	    System.err.print(String.valueOf(i)+":");
	    final double [] r=m[i];
	    for(int j=0;j<r.length;j++)
	    {
		System.err.print("\t"+r[j]);
	    }
	    System.err.println();
	}
    }



    static double [][] getProd(final double [][] m1,final double [][] m2)
    {
	final int ne=m1.length;
	final double [][] m=new double [ne][ne];
	for(int i=0;i<ne;i++)
	{
	    for(int j=0;j<ne;j++)
	    {
		double s=0;
		for(int k=0;k<ne;k++)
		{
		    s+=m1[i][k]*m2[k][j];
		}
		m[i][j]=s;
	    }
	}
	return m;
    }

    static double [][] getF(final int neq_p,final int nf)
    {
	final int ne=neq_p+nf;
	final double [][] f=new double [ne][ne];
	for(int i=0;i<ne;i++)
	{
	    if(i>=nf)
	    {
		f[i][i-nf]=1;
	    }
	}
	return f;
    }

    static double [][] getMLSym(final java.util.Random r,
				final int neq_p,final int nf)
    {
	final int ne=neq_p+nf,nne=ne-1;
	final double [][] m=new double [ne][ne];
	for(int i=0;i<ne;i++)
	{
	    for(int j=0;j<=i;j++)
	    {
		if(j<=nne-i)
		{
		    m[i][j]=r.nextDouble();
		}
		else
		{
		    m[i][j]=m[nne-j][nne-i];
		}
	    }
	}
	return m;
    }


    static double [][] getMLRand(final java.util.Random r,
				 final int neq_p,final int nf)
    {
final int ne=neq_p+nf,nne=ne-1;
	final double [][] m=new double [ne][ne];
	for(int i=0;i<ne;i++)
	{
	    for(int j=0;j<=i;j++)
	    {
		m[i][j]=r.nextDouble();
	    }
	}
	return m;
    }

    static void printResM(final String txt,
			  final double [][] m,
			  final double [][] f)
    {
	System.err.println(txt+"-----------");
	printMatr(txt+"M",m);
	printMatr(txt+"F",m);
	printMatr(txt+"MF",getProd(m,f));
	printMatr(txt+"FM",getProd(f,m));

    }





    public static void main(String [] args)
    {
	final java.util.Random r=new java.util.Random(123);
	final int neq_p=2,nf=2;
	final double [][] f=getF(neq_p,nf);
	printResM("RAND:",getMLRand(r,neq_p,nf),f);
	printResM("RSYM:",getMLSym(r,neq_p,nf),f);

	printMatr("Cinv:",com.polytechnik.utils.Linsystems.getInvertedMatrix(new double [][]{
		    {1,0,0,0},
		    {1,1,0,0},
		    {1,2,1,0},
		    {1,3,3,1}
		}));
    }


}
