package com.polytechnik.algorithms;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.*;

/** A class to print test function: linear dependence with a breakage.
 * @version $Id: PrintFunTwoLinearStages.java,v 1.6 2018/11/17 16:26:30 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public class PrintFunTwoLinearStages {
	public static void main(final String [] args) throws java.io.IOException
	{
	    if(args.length!=7)
	    {
		System.err.println("Usage: PrintFunTwoLinearStages filename n_points intervallength edge slope_1 slope_2 randomness");
		System.exit(1);
	    }
	    final String filename=args[0];
	    final int npoints=Integer.valueOf(args[1]);
	    final double
		intervallength=Double.valueOf(args[2]),edge=Integer.valueOf(args[3]),
		slope_1=Double.valueOf(args[4]),slope_2=Double.valueOf(args[5]),
		randomness=Double.valueOf(args[6]);

	    final java.util.Random r=new java.util.Random(12345);
	    System.err.print("Writing points to "+filename);
	    final java.io.PrintWriter out=new java.io.PrintWriter(filename);
	    out.println("| npoints="+npoints+" edge="+edge+" slope_1="+slope_1+" slope_2="+slope_2+" randomness="+randomness);
	    double C=1,x=0;
	    final double dx=intervallength/npoints;
	    for(int k=0;k<=npoints;k++)
	    {
		out.println(String.valueOf(x)+"\t"+(C+randomness*r.nextDouble()));
		x+=dx;
		if(x>=edge) C-=slope_2*dx;
		else C-=slope_1*dx;
	    }
	    out.close();
	    System.err.println(" DONE");
	}
    } // END OF class PrintFunTwoLinearStages
