package com.polytechnik.algorithms;
/*
 * (C) Vladislav Malyshkin 2018
 * This file is under GPL version 3.
 *
 */
/** Run all scala code we have.
  * Any PROGRAM.main(Array("a1","a2")) can be run from a command line as
  *  scala com.polytechnik.algorithms.PROGRAM "a1" "a2"
  * here we call them all at once.
  * To compile and run (remove the spaces by slash and star when run the three commans below):
  *#  javac -g com/polytechnik / * / *java
  *#  scalac com/polytechnik/ * / *scala
  *#  scala com.polytechnik.algorithms.RunAllScalaPrograms
  * @version $Id: RunAllScalaPrograms.scala,v 1.35 2022/07/14 09:17:49 mal Exp $
  * @author Vladislav Malyshkin mal@gromco.com
  */
object RunAllScalaPrograms {


  def main(args:Array[String]):Unit={

    // A small part of https://arxiv.org/abs/1510.05510
    SkewnessNG.main(Array()); // Appendix C.
    ExampleRungeFunction.main(Array("10")); // Appendix D.

    // https://arxiv.org/abs/1511.07085
    ExampleDistributionDependence.main(Array());
    // https://arxiv.org/abs/1511.09058
    ExampleDistribution1Stage.main(Array());
    // https://arxiv.org/abs/1512.03219
    ExampleInterpolationVectorML.main(Array());
    // https://arxiv.org/abs/1511.01887
    ExampleImageInterpolation.main(Array("file:dataexamples/lena512.bmp","20","20","chebyshev"))

    // https://arxiv.org/abs/1602.04423 . I=dV/dt not V is the source of market dynamics.
    ExampleNoSupplyDemand.main(Array("dataexamples/aapl_old.csv.gz"));

  }
}
