package com.polytechnik.algorithms;


/** Calculate R(gamma_1,gamma_2) for our solar paper.
 */
class with_V_M_Makarov_PrintRgammasQ0 {

    static final int N=20;
    static double sumExp(final double r)
    {
	double s=0;
	for(int t=1;t<=N;t++) s+=Math.exp(-r*t);
	return s;
    }
    static double getG2(final double g1,final double r)
    {
	return -(1-g1*sumExp(r))/N;
    }


    public static void main(String [] args)
    {
	final double [] rs=new double []{0.00000001,0.01,0.02,0.05,0.1,0.15,0.3};
	System.out.print("|Generated by:$Id: with_V_M_Makarov_PrintRgammasQ0.java,v 1.5 2018/08/16 08:56:37 mal Exp $");
	System.out.print("|gamma1");
	for(double r:rs) System.out.print("\t|r_"+r);
	System.out.println();

	for(double gamma1=0;gamma1<=0.2;gamma1+=0.001)
	{
	    System.out.print(""+gamma1);
	    for(double r:rs)
	    {
		final double gamma2=getG2(gamma1,r);
		System.out.print("\t"+gamma2);
	    }
	    System.out.println();
	}
    }
}

