package com.polytechnik.broker;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** An interface for a program to a broker to add/remove trades.
 *  @version $Id: BrokerInterface.java,v 1.34 2009/10/14 09:40:08 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public interface BrokerInterface {

    void init();

    void hookForDebugging(final Object data,final long currenttime);

    long addNewOrder(final AOrder o,final TraderContainer s);

    long cancelReplaceOrder(final long ordertocancel,final AOrder o,final TraderContainer s);

    long cancelOrder(final long ordertocancel,final TraderContainer s);

    int cancelPerTickerOrders(final long [] orderstocancel,final TraderContainer s);

    void readInitialPosition(final TraderContainer s);
}
