package com.polytechnik.broker;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** A class to store some information for a stock.
 *  @version $Id: TraderContainer.java,v 1.10 2009/11/03 16:09:33 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public abstract class TraderContainer
{
    public final String ticker;
    public final Positions positions;
    public final MoneyManager moneymanager;
    public final boolean flag_realtime;

    public TraderContainer(final String ticker,
			   final boolean flag_realtime,
			   final MoneyManager moneymanager)
    {
	this.ticker=ticker;
	this.positions=new Positions(ticker);
	this.flag_realtime=flag_realtime;
	this.moneymanager=moneymanager;
	this.moneymanager.setTraderContainer(this);
    }


    public abstract void notifyTrader();


    /*
    public static TraderContainer getDummyForTesting(final String ticker)
    {
	return new TraderContainer(ticker,false,new MoneyManager(this)){
	    public void notifyTrader(){}
	    public long getTraderCurrentTime(){return 0;}
	};
    }
    */

    public abstract long getTraderCurrentTime();
}
