package com.polytechnik.freemoney;
/*
 * (C) Vladislav Malyshkin 2022
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;

/** An integrator with interal state {@link WIntegratorLegendreShifted} 
 * to calculate commonly used  moments in shifted Legendre basis.
 * @version $Id: CommonlyUsedMomentsLegendreShifted.java,v 1.17 2022/09/05 02:14:06 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public class CommonlyUsedMomentsLegendreShifted extends CommonlyUsedMoments {

    public CommonlyUsedMomentsLegendreShifted(final int n,final double atau){
	super(n,atau);
    }

    /** An adapter to {@link WIntegratorLegendreShifted#getDtMoments}.
     */
    @Override public double [] getdtMoments(final int nmoms){
	return WIntegratorLegendreShifted.getDtMoments(nmoms);
    }
    /** Calculate \( \psi/2+x*d\psi/dx \),
     * an adapter to {@link WIntegratorLegendreShifted#getEDPsi}.
     */
    @Override public double [] getEDPsi(final double [] psi){
	return WIntegratorLegendreShifted.getEDPsi(psi);
    }
    /** Calculate \( \frac{1}{x}\int_0^x P(x)dx \), 
     * an adapter to {@link WIntegratorLegendreShifted#getPolynomialWIntegratedDt}.
     */
    @Override public double [] getPolynomialWIntegratedDt(final double [] polynomial){
	return WIntegratorLegendreShifted.getPolynomialWIntegratedDt(polynomial);
    }

    @Override public OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}


    @Override public WIntegratorLegendreShifted getEmptyWIntegrator(final int ntm,final double atau,final int nobservables){
	return new WIntegratorLegendreShifted(ntm,atau,nobservables);
    }

    @Override public double [] getDFMomentsFromF(final double [] Fmoments){
	return WIntegratorLegendreShifted.B.getXPnprimeplusPnMomentsFromPnMoments(Fmoments);
    }

}
