package com.polytechnik.kgo;
/*
 * (C) Vladislav Malyshkin 2024
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.TMatr;

/** Apply a function to a Hermitian matrix.
 * @version $Id: ApplyFunToMatrix.java,v 1.9 2024/04/11 04:17:30 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
class ApplyFunToMatrix {
    final int nC;
    final double [] m;
    final double [] ev_m;
    ApplyFunToMatrix(final int nC,final double [] m){
	this.nC=nC;
	this.m=m;
	if(nC*nC!=m.length) throw new IllegalArgumentException();
	this.ev_m=KGOSolutionVectorXVectorF.EV.getEV(nC,m,true);
    }

    double [] applyFun(java.util.function.ToDoubleBiFunction<Integer,Double> fun){
	// calculate f(m)
	final double [] m_fun=new double [nC*nC];
	for(int i=0;i<nC;i++){
	    final double evfun=fun.applyAsDouble(i,ev_m[i]);
	    for(int j=0;j<nC;j++){
	    for(int jp=0;jp<nC;jp++){
		m_fun[j*nC+jp] += ev_m[i*nC+j+nC]*ev_m[i*nC+jp+nC]*evfun;
	    }}
	}
	return m_fun;
    }
}
