package com.polytechnik.kgo;
/*
 * (C) Vladislav Malyshkin 2022
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.UnitTests;

/** Find contributing subspace from Christoffel function moments.
 * @version $Id: ContributingSubspaceMaxCoverage.java,v 1.4 2024/04/02 01:29:09 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
class ContributingSubspaceMaxCoverage {
    final double [] CX;
    final double mSum,totalSum;
    /** For unit tests.
     */
    final double [] ev_X_Kf_X;
    ContributingSubspaceMaxCoverage(final int nC,final int nX,
				    final double [] X_Kf_X){
	if(nC>nX) throw new IllegalArgumentException("nC="+nC+">nX="+nX+" is not supported");
	ev_X_Kf_X=KGOSolutionVectorXVectorF.EV.getEV(nX,X_Kf_X,true);
	// save nC eigenvectors
	CX=new double [nC*nX];
	double sumC=0;
	for(int j=0;j<nC;j++){
	    final int i=nX-nC+j;
	    System.arraycopy(ev_X_Kf_X,nX+i*nX,CX,j*nX,nX);
	    sumC+=ev_X_Kf_X[i];
	}
	mSum=sumC;
	totalSum=TMatr.sumElements(java.util.Arrays.copyOf(ev_X_Kf_X,nX));
    }
}
