package com.polytechnik.kgo;
/*
 * (C) Vladislav Malyshkin 2022
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.EVXData;

/**
 * A Knowledge Generalized Operator iteration optimization.
 * Not Working !!!
 * @version $Id: KGOIterationalContractionMapping.java,v 1.9 2024/04/02 01:29:09 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public class KGOIterationalContractionMapping {
    private static final int N_iterations=8;

    public final KGOEVSelection evSelected;
    public final UAdjustment aep;
    public KGOIterationalContractionMapping(final int nC,final int nX,
					    final double [] SK,
					    final double eps)
{
    final int n=nC*nX;
    if(SK.length!=n*n) throw new IllegalArgumentException();
    //if(true) throw new RuntimeException();


    double [] SKtransformed=SK,SKforEV=SK,
	basisTransform=TMatr.getUnitMatrix(n);
    KGOEVSelection res_evsel=null;
    AdjustedStateToUnitaryWithEigenproblem res_aep=null;
    for(int it=0;it<N_iterations;it++){
	res_evsel=null;res_aep=null; // FIXME for now to catch incorrect usage

	// solve regular eigenproblem
	final double [] ev_SKforEV=KGOSolutionVectorXVectorF.EV.getEV(
	    n,SKforEV,true);
	// new basis
	final double [] thisTransform=java.util.Arrays.copyOfRange(ev_SKforEV,n,ev_SKforEV.length);
	// to new basis:
	basisTransform=TMatr.mul_MA_x_MB(n,thisTransform,n,basisTransform,n);
	// The SK in new basis
	final var prev_SKtransformed=SKtransformed;
	SKtransformed=TMatr.mul_MA_x_MB(n,basisTransform,n,TMatr.mul_MA_x_MBTrans(n,SK,n,basisTransform,n),n);
	//System.err.println("SKtransformed="+java.util.Arrays.toString(SKtransformed));
	// calculate adjusted basis.
	// Take initial, transform to oginal basis, adjust, then transfrom back.
	final double [] adjustedStates=new double [n*n];
	double maxSKadj=0;
	KGOEVSelection evsel=null;
	AdjustedStateToUnitaryWithEigenproblem aepsel=null;
	for(int ie=0;ie<n;ie++){
	    final var e=new KGOEVSelection(ie,
					   // take initial state
					   java.util.Arrays.copyOfRange(basisTransform,ie*n,ie*n+n),
					   SKtransformed[n*ie+ie],
					   nC,nX);
	    final var s=e.getEVAdjustedTo1();
	    final double curSKadj=TMatr.getAMatrA(s.getUAdj(),SK,n);
	    if(evsel==null|| !Double.isFinite(maxSKadj) || curSKadj>=maxSKadj){
		evsel=e;
		aepsel=s;
		maxSKadj=curSKadj;
	    }
	    // save adjustment result
	    System.arraycopy(s.getUAdj(),0,adjustedStates,ie*n,n); // adjust in original basis
	    if(eps>0){
		final double [] ie_ev=EVXData.getPsiFromBasis(ie,ev_SKforEV,n);
		final double [] Bu_adj=TMatr.mul_MA_x_MB(n,basisTransform,n,s.getUAdj(),1);

		final double Forig=nC*TMatr.getAMatrA(e.eVector,SK,n),
		    _Forig=TMatr.getAMatrA(s.getUOrig(),SK,n),
		    __Forig=nC*TMatr.getAMatrA(ie_ev,prev_SKtransformed,n),
		    ___Forig=nC*SKtransformed[n*ie+ie],
		    Fadj=TMatr.getAMatrA(s.getUAdj(),SK,n),
		    _Fadj=TMatr.getAMatrA(Bu_adj,SKtransformed,n);

		UnitTests.checkDoubleRel1(__Forig,"__Forig",___Forig,"___Forig",eps);
		UnitTests.checkDoubleRel1(Forig,"Forig",_Forig,"_Forig",eps);
		UnitTests.checkDoubleRel1(Forig,"Forig",__Forig,"__Forig",eps);
		UnitTests.checkDoubleRel1(Forig,"Forig",___Forig,"___Forig",eps);
		UnitTests.checkDoubleRel1(Fadj,"Fadj",_Fadj,"_Fadj",eps);
		System.err.println("it="+it+" e.ind="+e.ind+" Forig="+Forig+" Fadj="+Fadj+" nC*EV["+e.ind+"]="+(nC*ev_SKforEV[ie]));
	    }
	}
	// transform back with adjustedStates
	SKforEV=TMatr.mul_MA_x_MB(n,adjustedStates,n,TMatr.mul_MA_x_MBTrans(n,SK,n,adjustedStates,n),n);
	// common normalizing
	TMatr.scaleVectorInPlace(SKforEV,1.0/nC);
	if(eps>0){
	    UnitTests.checkDoubleRel1(nC*SKforEV[evsel.ind*n+evsel.ind],"nC*diag SKforEV",TMatr.getAMatrA(aepsel.getUAdj(),SK,n),"Fadj ind",eps);
	    System.err.println("KGOIterationalContractionMapping: it="+it+" evsel.ind="+evsel.ind+" Forig="+(nC*SKtransformed[evsel.ind*n+evsel.ind])+" Fadj="+(nC*SKforEV[evsel.ind*n+evsel.ind]));
	}

	res_evsel=evsel;
	res_aep=aepsel;
    }
    evSelected=res_evsel;
    aep=evSelected.getSVDAdjustedTo1();
    //aep=evSelected.getScaleOnlyAdjustement_NotUnitary();
}



}
