package com.polytechnik.kgo;
/*
 * (C) Vladislav Malyshkin 2022
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;

/** A class for unit test.
  * @version $Id: TestKGOAll.java,v 1.7 2024/05/12 22:45:04 mal Exp $
  * @author Vladislav Malyshkin mal@gromco.com
 */
public class TestKGOAll {


    public static void main(String [] args){
	final long t0=System.currentTimeMillis();
	System.err.println("UnitTests::main(): starting ALL tests; ver=$Id: TestKGOAll.java,v 1.7 2024/05/12 22:45:04 mal Exp $");
	final double eps=1e-5;

	// force a selftest
	//TestKGO.EPS_selftest=eps;
	// the methods below set EPS_selftest inside

	// run the selftest
	TestDirectProjection.main(args);
	TestKGO.main(args);
	KGOSubspaceSolutionVectorXVectorF.main(args);
	KGOSolutionVectorXVectorF.main(new String []{});

	// disable selftest
	//TestKGO.EPS_selftest=0;

	final long t1=System.currentTimeMillis();
	System.err.println("Finished="+new java.util.Date(t1)+" Started="+new java.util.Date(t0));
	System.err.println("UnitTests::main(): ALL tests OK done in "+(t1-t0)+" milliseconds. ver=$Id: TestKGOAll.java,v 1.7 2024/05/12 22:45:04 mal Exp $");
    }

}
