#!/bin/bash -x

# Check lapack files diff
# $Id: check_lapack_source_diff.sh,v 1.3 2012/12/25 14:26:48 mal Exp $

if [ $# -ne 3 ]; then
 echo "usage: $0 java_dir lapack_old_dir lapack_new_dir" >&2
 exit 1
fi

diff_opts="-I ^\s*[\*|C|\!]"
dirs=("SRC/" "BLAS/SRC/" "INSTALL/" )
java_dir="$1"
lapack_old_dir="$2"
lapack_new_dir="$3"

for x in "${java_dir}"/*.java ; do
    f="${x##*/}"
    f="${f%%.*}"
    f="${f,*}.f"
    for d in "${dirs[@]}" ; do
	fno="${lapack_old_dir}/${d}/${f}"
	fnn="${lapack_new_dir}/${d}/${f}"
	if [ -r "$fno" ]; then
	    diff $diff_opts -u "$fno" "$fnn"
	fi
    done
done

