/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dlaed0.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Dlaed0 {

// *> \brief \b DLAED0 used by DSTEDC. Computes all eigenvalues and corresp
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *> \htmlonly
// *> Download DLAED0 + dependencies
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE DLAED0( ICOMPQ, QSIZ, N, D, E, Q, LDQ, QSTORE, LDQS,

// *                          WORK, IWORK, INFO )
// *
// *       .. Scalar Arguments ..
// *       INTEGER            ICOMPQ, INFO, LDQ, LDQS, N, QSIZ
// *       ..
// *       .. Array Arguments ..
// *       INTEGER            IWORK( * )
// *       DOUBLE PRECISION   D( * ), E( * ), Q( LDQ, * ), QSTORE( LDQS, *
// *      $                   WORK( * )
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DLAED0 computes all eigenvalues and corresponding eigenvectors of a
// *> symmetric tridiagonal matrix using the divide and conquer method.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] ICOMPQ
// *> \verbatim
// *>          ICOMPQ is INTEGER
// *>          = 0:  Compute eigenvalues only.
// *>          = 1:  Compute eigenvectors of original dense symmetric matri
// *>                also.  On entry, Q contains the orthogonal matrix used
// *>                to reduce the original matrix to tridiagonal form.
// *>          = 2:  Compute eigenvalues and eigenvectors of tridiagonal
// *>                matrix.
// *> \endverbatim
// *>
// *> \param[in] QSIZ
// *> \verbatim
// *>          QSIZ is INTEGER
// *>         The dimension of the orthogonal matrix used to reduce
// *>         the full matrix to tridiagonal form.  QSIZ >= N if ICOMPQ = 1
// *> \endverbatim
// *>
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>         The dimension of the symmetric tridiagonal matrix.  N >= 0.
// *> \endverbatim
// *>
// *> \param[in,out] D
// *> \verbatim
// *>          D is DOUBLE PRECISION array, dimension (N)
// *>         On entry, the main diagonal of the tridiagonal matrix.
// *>         On exit, its eigenvalues.
// *> \endverbatim
// *>
// *> \param[in] E
// *> \verbatim
// *>          E is DOUBLE PRECISION array, dimension (N-1)
// *>         The off-diagonal elements of the tridiagonal matrix.
// *>         On exit, E has been destroyed.
// *> \endverbatim
// *>
// *> \param[in,out] Q
// *> \verbatim
// *>          Q is DOUBLE PRECISION array, dimension (LDQ, N)
// *>         On entry, Q must contain an N-by-N orthogonal matrix.
// *>         If ICOMPQ = 0    Q is not referenced.
// *>         If ICOMPQ = 1    On entry, Q is a subset of the columns of th
// *>                          orthogonal matrix used to reduce the full
// *>                          matrix to tridiagonal form corresponding to

// *>                          the subset of the full matrix which is being
// *>                          decomposed at this time.
// *>         If ICOMPQ = 2    On entry, Q will be the identity matrix.
// *>                          On exit, Q contains the eigenvectors of the

// *>                          tridiagonal matrix.
// *> \endverbatim
// *>
// *> \param[in] LDQ
// *> \verbatim
// *>          LDQ is INTEGER
// *>         The leading dimension of the array Q.  If eigenvectors are
// *>         desired, then  LDQ >= max(1,N).  In any case,  LDQ >= 1.
// *> \endverbatim
// *>
// *> \param[out] QSTORE
// *> \verbatim
// *>          QSTORE is DOUBLE PRECISION array, dimension (LDQS, N)
// *>         Referenced only when ICOMPQ = 1.  Used to store parts of
// *>         the eigenvector matrix when the updating matrix multiplies
// *>         take place.
// *> \endverbatim
// *>
// *> \param[in] LDQS
// *> \verbatim
// *>          LDQS is INTEGER
// *>         The leading dimension of the array QSTORE.  If ICOMPQ = 1,
// *>         then  LDQS >= max(1,N).  In any case,  LDQS >= 1.
// *> \endverbatim
// *>
// *> \param[out] WORK
// *> \verbatim
// *>          WORK is DOUBLE PRECISION array,
// *>         If ICOMPQ = 0 or 1, the dimension of WORK must be at least
// *>                     1 + 3*N + 2*N*lg N + 3*N**2
// *>                     ( lg( N ) = smallest integer k
// *>                                 such that 2^k >= N )
// *>         If ICOMPQ = 2, the dimension of WORK must be at least
// *>                     4*N + N**2.
// *> \endverbatim
// *>
// *> \param[out] IWORK
// *> \verbatim
// *>          IWORK is INTEGER array,
// *>         If ICOMPQ = 0 or 1, the dimension of IWORK must be at least
// *>                        6 + 6*N + 5*N*lg N.
// *>                        ( lg( N ) = smallest integer k
// *>                                    such that 2^k >= N )
// *>         If ICOMPQ = 2, the dimension of IWORK must be at least
// *>                        3 + 5*N.
// *> \endverbatim
// *>
// *> \param[out] INFO
// *> \verbatim
// *>          INFO is INTEGER
// *>          = 0:  successful exit.
// *>          < 0:  if INFO = -i, the i-th argument had an illegal value.

// *>          > 0:  The algorithm failed to compute an eigenvalue while
// *>                working on the submatrix lying in rows and columns
// *>                INFO/(N+1) through mod(INFO,N+1).
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup auxOTHERcomputational
// *
// *> \par Contributors:
// *  ==================
// *>
// *> Jeff Rutter, Computer Science Division, University of California
// *> at Berkeley, USA
// *
// *  =====================================================================
//
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. External Subroutines ..
***/
/***
*     ..
*     .. External Functions ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
***/
// *

public static void dlaed0 (int icompq,
int qsiz,
int n,
double [] d, int _d_offset,
double [] e, int _e_offset,
double [] q, int _q_offset,
int ldq,
double [] qstore, int _qstore_offset,
int ldqs,
double [] work, int _work_offset,
int [] iwork, int _iwork_offset,
intW info)  {

label_999999:{

int curlvl= 0;
int curprb= 0;
int curr= 0;
int i= 0;
int igivcl= 0;
int igivnm= 0;
int igivpt= 0;
int indxq= 0;
int iperm= 0;
int iprmpt= 0;
int iq= 0;
int iqptr= 0;
int iwrem= 0;
int j= 0;
int k= 0;
int lgn= 0;
int matsiz= 0;
int msd2= 0;
int smlsiz= 0;
int smm1= 0;
int spm1= 0;
int spm2= 0;
int submat= 0;
int subpbs= 0;
int tlvls= 0;
double temp= 0.0d;
info.val = 0;
if (((icompq < 0) || (icompq > 2)))  {
    info.val = -1;
}
else if ((((icompq == 1)) && ((qsiz < Math.max(0, n)))))  {
    info.val = -2;
}              // Close else if()
else if ((n < 0))  {
    info.val = -3;
}              // Close else if()
else if ((ldq < Math.max(1, n)))  {
    info.val = -7;
}              // Close else if()
else if ((ldqs < Math.max(1, n)))  {
    info.val = -9;
}              // Close else if()
if ((info.val != 0))  {
    com.polytechnik.lapack310.Xerbla.xerbla("DLAED0",(-(info.val)));
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",999999);
/***
*
*     Quick return if possible
*
***/
}
// *
if ((n == 0)) {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",999999);
}
    /***
*
*     Determine the size and placement of the submatrices, and save in
*     the leading elements of IWORK.
*
***/
smlsiz = 25;//com.polytechnik.lapack310.Ilaenv.ilaenv(9,"DLAED0"," ",0,0,0,0);
iwork[(1-(1))+ _iwork_offset] = n;
subpbs = 1;
tlvls = 0;
label140:{
label130:{
label10:for(int jjx=0;jjx<Util.ITMAX;jjx++){
    //Dummy.label("com/polytechnik/lapack310/Dlaed0",10);
if ((iwork[(subpbs-(1))+ _iwork_offset] > smlsiz))  {
    {
int _j_inc = -1;
for (j = subpbs; j >= 1; j += _j_inc) {
iwork[((2*j)-(1))+ _iwork_offset] = (((iwork[(j-(1))+ _iwork_offset]+1))/2);
iwork[(((2*j)-1)-(1))+ _iwork_offset] = (iwork[(j-(1))+ _iwork_offset]/2);
//Dummy.label("com/polytechnik/lapack310/Dlaed0",20);
}              //  Close for() loop.
}
tlvls = (tlvls+1);
subpbs = (2*subpbs);
continue label10;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",10);
}
break label10;}// END label10
{
for (j = 2; j <= subpbs; j++) {
iwork[(j-(1))+ _iwork_offset] = (iwork[(j-(1))+ _iwork_offset]+iwork[((j-1)-(1))+ _iwork_offset]);
/***
*
*     Divide the matrix into SUBPBS submatrices of size at most SMLSIZ+1
*     using rank-1 modifications (cuts).
*
***/
//Dummy.label("com/polytechnik/lapack310/Dlaed0",30);
}              //  Close for() loop.
}
spm1 = (subpbs-1);
{
for (i = 1; i <= spm1; i++) {
submat = (iwork[(i-(1))+ _iwork_offset]+1);
smm1 = (submat-1);
d[(smm1-(1))+ _d_offset] = (d[(smm1-(1))+ _d_offset]-Math.abs(e[(smm1-(1))+ _e_offset]));
d[(submat-(1))+ _d_offset] = (d[(submat-(1))+ _d_offset]-Math.abs(e[(smm1-(1))+ _e_offset]));
// *
//Dummy.label("com/polytechnik/lapack310/Dlaed0",40);
}              //  Close for() loop.
}
indxq = ((4*n)+3);
/***
*
*        Set up workspaces for eigenvalues only/accumulate new vectors
*        routine
*
***/
if ((icompq != 2))  {
    temp = (Math.log((double)(n))/Math.log(2.0));
lgn = (int)(temp);
if ((((int)Math.pow(2, lgn)) < n)) {
    lgn = (lgn+1);
}
    if ((((int)Math.pow(2, lgn)) < n)) {
    lgn = (lgn+1);
}
    iprmpt = ((indxq+n)+1);
iperm = (iprmpt+(n*lgn));
iqptr = (iperm+(n*lgn));
igivpt = ((iqptr+n)+2);
// *
igivcl = (igivpt+(n*lgn));
igivnm = 1;
iq = (igivnm+((2*n)*lgn));
/***
*
*        Initialize pointers
*
***/
iwrem = ((iq+((int)Math.pow(n, 2)))+1);
{
for (i = 0; i <= subpbs; i++) {
iwork[((iprmpt+i)-(1))+ _iwork_offset] = 1;
iwork[((igivpt+i)-(1))+ _iwork_offset] = 1;
//Dummy.label("com/polytechnik/lapack310/Dlaed0",50);
}              //  Close for() loop.
}
iwork[(iqptr-(1))+ _iwork_offset] = 1;
/***
*
*     Solve each submatrix eigenproblem at the bottom of the divide and
*     conquer tree.
*
***/
}
curr = 0;
{
for (i = 0; i <= spm1; i++) {
if ((i == 0))  {
    submat = 1;
matsiz = iwork[(1-(1))+ _iwork_offset];
}
else  {
  submat = (iwork[(i-(1))+ _iwork_offset]+1);
matsiz = (iwork[((i+1)-(1))+ _iwork_offset]-iwork[(i-(1))+ _iwork_offset]);
}              //  Close else.
if ((icompq == 2))  {
    com.polytechnik.lapack310.Dsteqr.dsteqr("I",matsiz,d,(submat-(1))+ _d_offset,e,(submat-(1))+ _e_offset,q,(submat-(1))+(submat-(1)) * (ldq)+ _q_offset,ldq,work,_work_offset,info);
if ((info.val != 0)) {
    break label130;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",130);
}
    }
else  {
  com.polytechnik.lapack310.Dsteqr.dsteqr("I",matsiz,d,(submat-(1))+ _d_offset,e,(submat-(1))+ _e_offset,work,(((iq-1)+iwork[((iqptr+curr)-(1))+ _iwork_offset])-(1))+ _work_offset,matsiz,work,_work_offset,info);
if ((info.val != 0)) {
    break label130;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",130);
}
    if ((icompq == 1))  {
    com.polytechnik.lapack310.Dgemm.dgemm("N","N",qsiz,matsiz,matsiz,1.0,q,(1-(1))+(submat-(1)) * (ldq)+ _q_offset,ldq,work,(((iq-1)+iwork[((iqptr+curr)-(1))+ _iwork_offset])-(1))+ _work_offset,matsiz,0.0,qstore,(1-(1))+(submat-(1)) * (ldqs)+ _qstore_offset,ldqs);
}
iwork[(((iqptr+curr)+1)-(1))+ _iwork_offset] = (iwork[((iqptr+curr)-(1))+ _iwork_offset]+((int)Math.pow(matsiz, 2)));
curr = (curr+1);
}              //  Close else.
k = 1;
{
for (j = submat; j <= iwork[((i+1)-(1))+ _iwork_offset]; j++) {
iwork[((indxq+j)-(1))+ _iwork_offset] = k;
k = (k+1);
//Dummy.label("com/polytechnik/lapack310/Dlaed0",60);
}              //  Close for() loop.
}
/***
*
*     Successively merge eigensystems of adjacent submatrices
*     into eigensystem for the corresponding larger matrix.
*
*     while ( SUBPBS > 1 )
*
***/
//Dummy.label("com/polytechnik/lapack310/Dlaed0",70);
}              //  Close for() loop.
}
curlvl = 1;
label80:for(int jjxxx=0;jjxxx<Util.ITMAX;jjxxx++){
    //Dummy.label("com/polytechnik/lapack310/Dlaed0",80);
if ((subpbs > 1))  {
    spm2 = (subpbs-2);
{
int _i_inc = 2;
for (i = 0; i <= spm2; i += _i_inc) {
if ((i == 0))  {
    submat = 1;
matsiz = iwork[(2-(1))+ _iwork_offset];
msd2 = iwork[(1-(1))+ _iwork_offset];
curprb = 0;
}
else  {
  submat = (iwork[(i-(1))+ _iwork_offset]+1);
matsiz = (iwork[((i+2)-(1))+ _iwork_offset]-iwork[(i-(1))+ _iwork_offset]);
msd2 = (matsiz/2);
curprb = (curprb+1);
/***
*
*     Merge lower order eigensystems (of size MSD2 and MATSIZ - MSD2)
*     into an eigensystem of size MATSIZ.
*     DLAED1 is used only for the full eigensystem of a tridiagonal
*     matrix.
*     DLAED7 handles the cases in which eigenvalues only or eigenvalues
*     and eigenvectors of a full symmetric matrix (which was reduced to
*     tridiagonal form) are desired.
*
***/
}              //  Close else.

if ((icompq == 2))  {
    throw new RuntimeException("dlaed1 is not implemented");
    //com.polytechnik.lapack310.Dlaed1.dlaed1(matsiz,d,(submat-(1))+ _d_offset,q,(submat-(1))+(submat-(1)) * (ldq)+ _q_offset,ldq,iwork,((indxq+submat)-(1))+ _iwork_offset,e,(((submat+msd2)-1)-(1))+ _e_offset,msd2,work,_work_offset,iwork,((subpbs+1)-(1))+ _iwork_offset,info);
}
else  {
    if(true)throw new RuntimeException("dlaed7 is not implemented");
    //com.polytechnik.lapack310.Dlaed7.dlaed7(icompq,matsiz,qsiz,tlvls,curlvl,curprb,d,(submat-(1))+ _d_offset,qstore,(1-(1))+(submat-(1)) * (ldqs)+ _qstore_offset,ldqs,iwork,((indxq+submat)-(1))+ _iwork_offset,e,(((submat+msd2)-1)-(1))+ _e_offset,msd2,work,(iq-(1))+ _work_offset,iwork,(iqptr-(1))+ _iwork_offset,iwork,(iprmpt-(1))+ _iwork_offset,iwork,(iperm-(1))+ _iwork_offset,iwork,(igivpt-(1))+ _iwork_offset,iwork,(igivcl-(1))+ _iwork_offset,work,(igivnm-(1))+ _work_offset,work,(iwrem-(1))+ _work_offset,iwork,((subpbs+1)-(1))+ _iwork_offset,info);
}              //  Close else.
if ((info.val != 0)) {
    break label130;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",130);
}
    iwork[(((i/2)+1)-(1))+ _iwork_offset] = iwork[((i+2)-(1))+ _iwork_offset];
//Dummy.label("com/polytechnik/lapack310/Dlaed0",90);
}              //  Close for() loop.
}
subpbs = (subpbs/2);
curlvl = (curlvl+1);
continue label80;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",80);
/***
*
*     end while
*
*     Re-merge the eigenvalues/vectors which were deflated at the final
*     merge step.
*
***/
}
break label80;}// END label80
if ((icompq == 1))  {
    {
for (i = 1; i <= n; i++) {
j = iwork[((indxq+i)-(1))+ _iwork_offset];
work[(i-(1))+ _work_offset] = d[(j-(1))+ _d_offset];
com.polytechnik.lapack310.Dcopy.dcopy(qsiz,qstore,(1-(1))+(j-(1)) * (ldqs)+ _qstore_offset,1,q,(1-(1))+(i-(1)) * (ldq)+ _q_offset,1);
//Dummy.label("com/polytechnik/lapack310/Dlaed0",100);
}              //  Close for() loop.
}
com.polytechnik.lapack310.Dcopy.dcopy(n,work,_work_offset,1,d,_d_offset,1);
}
else if ((icompq == 2))  {
    {
for (i = 1; i <= n; i++) {
j = iwork[((indxq+i)-(1))+ _iwork_offset];
work[(i-(1))+ _work_offset] = d[(j-(1))+ _d_offset];
com.polytechnik.lapack310.Dcopy.dcopy(n,q,(1-(1))+(j-(1)) * (ldq)+ _q_offset,1,work,(((n*i)+1)-(1))+ _work_offset,1);
//Dummy.label("com/polytechnik/lapack310/Dlaed0",110);
}              //  Close for() loop.
}
com.polytechnik.lapack310.Dcopy.dcopy(n,work,_work_offset,1,d,_d_offset,1);
com.polytechnik.lapack310.Dlacpy.dlacpy("A",n,n,work,((n+1)-(1))+ _work_offset,n,q,_q_offset,ldq);
}              // Close else if()
else  {
  {
for (i = 1; i <= n; i++) {
j = iwork[((indxq+i)-(1))+ _iwork_offset];
work[(i-(1))+ _work_offset] = d[(j-(1))+ _d_offset];
//Dummy.label("com/polytechnik/lapack310/Dlaed0",120);
}              //  Close for() loop.
}
com.polytechnik.lapack310.Dcopy.dcopy(n,work,_work_offset,1,d,_d_offset,1);
}              //  Close else.
// *
break label140;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",140);
} // END label130
//Dummy.label("com/polytechnik/lapack310/Dlaed0",130);
// *
info.val = ((((submat*((n+1)))+submat)+matsiz)-1);
break label140;}// END label140
//Dummy.label("com/polytechnik/lapack310/Dlaed0",140);
/***
*
*     End of DLAED0
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlaed0",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Dlaed0",999999);
return;
   }
} // End class.
