/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dlaexc.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Dlaexc {

// *> \brief \b DLAEXC swaps adjacent diagonal blocks of a real upper quasi
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *> \htmlonly
// *> Download DLAEXC + dependencies
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE DLAEXC( WANTQ, N, T, LDT, Q, LDQ, J1, N1, N2, WORK,
// *                          INFO )
// *
// *       .. Scalar Arguments ..
// *       LOGICAL            WANTQ
// *       INTEGER            INFO, J1, LDQ, LDT, N, N1, N2
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION   Q( LDQ, * ), T( LDT, * ), WORK( * )
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DLAEXC swaps adjacent diagonal blocks T11 and T22 of order 1 or 2 in

// *> an upper quasi-triangular matrix T by an orthogonal similarity
// *> transformation.
// *>
// *> T must be in Schur canonical form, that is, block upper triangular
// *> with 1-by-1 and 2-by-2 diagonal blocks; each 2-by-2 diagonal block
// *> has its diagonal elements equal and its off-diagonal elements of
// *> opposite sign.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] WANTQ
// *> \verbatim
// *>          WANTQ is LOGICAL
// *>          = .TRUE. : accumulate the transformation in the matrix Q;
// *>          = .FALSE.: do not accumulate the transformation.
// *> \endverbatim
// *>
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>          The order of the matrix T. N >= 0.
// *> \endverbatim
// *>
// *> \param[in,out] T
// *> \verbatim
// *>          T is DOUBLE PRECISION array, dimension (LDT,N)
// *>          On entry, the upper quasi-triangular matrix T, in Schur
// *>          canonical form.
// *>          On exit, the updated matrix T, again in Schur canonical form
// *> \endverbatim
// *>
// *> \param[in] LDT
// *> \verbatim
// *>          LDT is INTEGER
// *>          The leading dimension of the array T. LDT >= max(1,N).
// *> \endverbatim
// *>
// *> \param[in,out] Q
// *> \verbatim
// *>          Q is DOUBLE PRECISION array, dimension (LDQ,N)
// *>          On entry, if WANTQ is .TRUE., the orthogonal matrix Q.
// *>          On exit, if WANTQ is .TRUE., the updated matrix Q.
// *>          If WANTQ is .FALSE., Q is not referenced.
// *> \endverbatim
// *>
// *> \param[in] LDQ
// *> \verbatim
// *>          LDQ is INTEGER
// *>          The leading dimension of the array Q.
// *>          LDQ >= 1; and if WANTQ is .TRUE., LDQ >= N.
// *> \endverbatim
// *>
// *> \param[in] J1
// *> \verbatim
// *>          J1 is INTEGER
// *>          The index of the first row of the first block T11.
// *> \endverbatim
// *>
// *> \param[in] N1
// *> \verbatim
// *>          N1 is INTEGER
// *>          The order of the first block T11. N1 = 0, 1 or 2.
// *> \endverbatim
// *>
// *> \param[in] N2
// *> \verbatim
// *>          N2 is INTEGER
// *>          The order of the second block T22. N2 = 0, 1 or 2.
// *> \endverbatim
// *>
// *> \param[out] WORK
// *> \verbatim
// *>          WORK is DOUBLE PRECISION array, dimension (N)
// *> \endverbatim
// *>
// *> \param[out] INFO
// *> \verbatim
// *>          INFO is INTEGER
// *>          = 0: successful exit
// *>          = 1: the transformed matrix T would be too far from Schur
// *>               form; the blocks are not swapped and T and Q are
// *>               unchanged.
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup doubleOTHERauxiliary
// *
// *  =====================================================================
//
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. Local Arrays ..
***/
/***
*     ..
*     .. External Functions ..
***/
/***
*     ..
*     .. External Subroutines ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
***/
/***
*
*     Quick return if possible
*
***/

public static void dlaexc (boolean wantq,
int n,
double [] t, int _t_offset,
int ldt,
double [] q, int _q_offset,
int ldq,
int j1,
int n1,
int n2,
double [] work, int _work_offset,
intW info)  {

label_999999:{
label50:{

intW ierr= new intW(0);
int j2= 0;
int j3= 0;
int j4= 0;
int k= 0;
int nd= 0;
doubleW cs= new doubleW(0.0d);
double dnorm= 0.0d;
double eps= 0.0d;
doubleW scale= new doubleW(0.0d);
double smlnum= 0.0d;
doubleW sn= new doubleW(0.0d);
double t11= 0.0d;
double t22= 0.0d;
double t33= 0.0d;
doubleW tau= new doubleW(0.0d);
doubleW tau1= new doubleW(0.0d);
doubleW tau2= new doubleW(0.0d);
doubleW temp= new doubleW(0.0d);
double thresh= 0.0d;
doubleW wi1= new doubleW(0.0d);
doubleW wi2= new doubleW(0.0d);
doubleW wr1= new doubleW(0.0d);
doubleW wr2= new doubleW(0.0d);
doubleW xnorm=new doubleW(0.0d);
double [] d= new double[(4) * (4)];
double [] u= new double[(3)];
double [] u1= new double[(3)];
double [] u2= new double[(3)];
double [] x= new double[(2) * (2)];
info.val = 0;
if ((((n == 0) || (n1 == 0)) || (n2 == 0))) {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",999999);
}
    // *
if (((j1+n1) > n)) {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",999999);
}
    j2 = (j1+1);
j3 = (j1+2);
// *
j4 = (j1+3);
/***
*
*        Swap two 1-by-1 blocks.
*
***/
if (((n1 == 1) && (n2 == 1)))  {
    t11 = t[(j1-(1))+(j1-(1)) * (ldt)+ _t_offset];
/***
*
*        Determine the transformation to perform the interchange.
*
***/
t22 = t[(j2-(1))+(j2-(1)) * (ldt)+ _t_offset];
/***
*
*        Apply transformation to the matrix T.
*
***/
com.polytechnik.lapack310.Dlartg.dlartg(t[(j1-(1))+(j2-(1)) * (ldt)+ _t_offset],(t22-t11),cs,sn,temp);
if ((j3 <= n)) {
    com.polytechnik.lapack310.Drot.drot(((n-j1)-1),t,(j1-(1))+(j3-(1)) * (ldt)+ _t_offset,ldt,t,(j2-(1))+(j3-(1)) * (ldt)+ _t_offset,ldt,cs.val,sn.val);
}
    // *
com.polytechnik.lapack310.Drot.drot((j1-1),t,(1-(1))+(j1-(1)) * (ldt)+ _t_offset,1,t,(1-(1))+(j2-(1)) * (ldt)+ _t_offset,1,cs.val,sn.val);
t[(j1-(1))+(j1-(1)) * (ldt)+ _t_offset] = t22;
// *
t[(j2-(1))+(j2-(1)) * (ldt)+ _t_offset] = t11;
/***
*
*           Accumulate transformation in the matrix Q.
*
***/
if (wantq)  {
    com.polytechnik.lapack310.Drot.drot(n,q,(1-(1))+(j1-(1)) * (ldq)+ _q_offset,1,q,(1-(1))+(j2-(1)) * (ldq)+ _q_offset,1,cs.val,sn.val);
// *
}
/***
*
*        Swapping involves at least one 2-by-2 block.
*
*        Copy the diagonal block of order N1+N2 to the local array D
*        and compute its norm.
*
***/
}
else  {
label40:{
  nd = (n1+n2);
com.polytechnik.lapack310.Dlacpy.dlacpy("Full",nd,nd,t,(j1-(1))+(j1-(1)) * (ldt)+ _t_offset,ldt,d,0,4);
/***
*
*        Compute machine-dependent threshold for test for accepting
*        swap.
*
***/
dnorm = com.polytechnik.lapack310.Dlange.dlange("Max",nd,nd,d,0,4,work,_work_offset);
eps = com.polytechnik.lapack310.Dlamch.dlamch("P");
smlnum = (com.polytechnik.lapack310.Dlamch.dlamch("S")/eps);
/***
*
*        Solve T11*X - X*T22 = scale*T12 for X.
*
***/
thresh = Math.max(((10.0*eps)*dnorm), smlnum);
/***
*
*        Swap the adjacent diagonal blocks.
*
***/
com.polytechnik.lapack310.Dlasy2.dlasy2(false,false,-1,n1,n2,d,0,4,d,((n1+1)-(1))+((n1+1)-(1)) * (4),4,d,(1-(1))+((n1+1)-(1)) * (4),4,scale,x,0,2,xnorm,ierr);
k = (((n1+n1)+n2)-3);
// *
label30:{
label20:{
label10:{
{
  int _cg_tmp = k;
if (_cg_tmp == 1)
    break label10;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",10);
else if (_cg_tmp == 2)
    break label20;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",20);
else if (_cg_tmp == 3)
    break label30;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",30);
}
/***
*
*        N1 = 1, N2 = 2: generate elementary reflector H so that:
*
*        ( scale, X11, X12 ) H = ( 0, 0, * )
*
***/
}// END label10:
	//Dummy.label("com/polytechnik/lapack310/Dlaexc",10);
u[(1-(1))] = scale.val;
u[(2-(1))] = x[(1-(1))+(1-(1)) * (2)];
u[(3-(1))] = x[(1-(1))+(2-(1)) * (2)];
dlarfg_adapter(3,u,(3-(1)),u,0,1,tau);
u[(3-(1))] = 1.0;
/***
*
*        Perform swap provisionally on diagonal block in D.
*
***/
t11 = t[(j1-(1))+(j1-(1)) * (ldt)+ _t_offset];
com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,3,u,0,tau.val,d,0,4,work,_work_offset);
/***
*
*        Test whether to reject swap.
*
***/
com.polytechnik.lapack310.Dlarfx.dlarfx("R",3,3,u,0,tau.val,d,0,4,work,_work_offset);
/***
*
*        Accept swap: apply transformation to the entire matrix T.
*
***/
if ((Util.max(Math.abs(d[(3-(1))+(1-(1)) * (4)]), Math.abs(d[(3-(1))+(2-(1)) * (4)]), Math.abs((d[(3-(1))+(3-(1)) * (4)]-t11))) > thresh)) {
    break label50;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",50);
}
    com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,((n-j1)+1),u,0,tau.val,t,(j1-(1))+(j1-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
// *
com.polytechnik.lapack310.Dlarfx.dlarfx("R",j2,3,u,0,tau.val,t,(1-(1))+(j1-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
t[(j3-(1))+(j1-(1)) * (ldt)+ _t_offset] = 0.0;
t[(j3-(1))+(j2-(1)) * (ldt)+ _t_offset] = 0.0;
// *
t[(j3-(1))+(j3-(1)) * (ldt)+ _t_offset] = t11;
/***
*
*           Accumulate transformation in the matrix Q.
*
***/
if (wantq)  {
    com.polytechnik.lapack310.Dlarfx.dlarfx("R",n,3,u,0,tau.val,q,(1-(1))+(j1-(1)) * (ldq)+ _q_offset,ldq,work,_work_offset);
}
// *
break label40;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",40);
/***
*
*        N1 = 2, N2 = 1: generate elementary reflector H so that:
*
*        H (  -X11 ) = ( * )
*          (  -X21 ) = ( 0 )
*          ( scale ) = ( 0 )
*
***/
}// END label20:
    //Dummy.label("com/polytechnik/lapack310/Dlaexc",20);
u[(1-(1))] = (-(x[(1-(1))+(1-(1)) * (2)]));
u[(2-(1))] = (-(x[(2-(1))+(1-(1)) * (2)]));
u[(3-(1))] = scale.val;
dlarfg_adapter(3,u,(1-(1)),u,(2-(1)),1,tau);
u[(1-(1))] = 1.0;
/***
*
*        Perform swap provisionally on diagonal block in D.
*
***/
t33 = t[(j3-(1))+(j3-(1)) * (ldt)+ _t_offset];
com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,3,u,0,tau.val,d,0,4,work,_work_offset);
/***
*
*        Test whether to reject swap.
*
***/
com.polytechnik.lapack310.Dlarfx.dlarfx("R",3,3,u,0,tau.val,d,0,4,work,_work_offset);
/***
*
*        Accept swap: apply transformation to the entire matrix T.
*
***/
if ((Util.max(Math.abs(d[(2-(1))+(1-(1)) * (4)]), Math.abs(d[(3-(1))+(1-(1)) * (4)]), Math.abs((d[(1-(1))+(1-(1)) * (4)]-t33))) > thresh)) {
    break label50;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",50);
}
    com.polytechnik.lapack310.Dlarfx.dlarfx("R",j3,3,u,0,tau.val,t,(1-(1))+(j1-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
// *
com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,(n-j1),u,0,tau.val,t,(j1-(1))+(j2-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
t[(j1-(1))+(j1-(1)) * (ldt)+ _t_offset] = t33;
t[(j2-(1))+(j1-(1)) * (ldt)+ _t_offset] = 0.0;
// *
t[(j3-(1))+(j1-(1)) * (ldt)+ _t_offset] = 0.0;
/***
*
*           Accumulate transformation in the matrix Q.
*
***/
if (wantq)  {
    com.polytechnik.lapack310.Dlarfx.dlarfx("R",n,3,u,0,tau.val,q,(1-(1))+(j1-(1)) * (ldq)+ _q_offset,ldq,work,_work_offset);
}
// *
break label40;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",40);
/***
*
*        N1 = 2, N2 = 2: generate elementary reflectors H(1) and H(2) so
*        that:
*
*        H(2) H(1) (  -X11  -X12 ) = (  *  * )
*                  (  -X21  -X22 )   (  0  * )
*                  ( scale    0  )   (  0  0 )
*                  (    0  scale )   (  0  0 )
*
***/
}// END label30:
//Dummy.label("com/polytechnik/lapack310/Dlaexc",30);
u1[(1-(1))] = (-(x[(1-(1))+(1-(1)) * (2)]));
u1[(2-(1))] = (-(x[(2-(1))+(1-(1)) * (2)]));
u1[(3-(1))] = scale.val;
dlarfg_adapter(3,u1,(1-(1)),u1,(2-(1)),1,tau1);
// *
u1[(1-(1))] = 1.0;
temp.val = (-((tau1.val*((x[(1-(1))+(2-(1)) * (2)]+(u1[(2-(1))]*x[(2-(1))+(2-(1)) * (2)]))))));
u2[(1-(1))] = ((-((temp.val*u1[(2-(1))])))-x[(2-(1))+(2-(1)) * (2)]);
u2[(2-(1))] = (-((temp.val*u1[(3-(1))])));
u2[(3-(1))] = scale.val;
dlarfg_adapter(3,u2,(1-(1)),u2,(2-(1)),1,tau2);
/***
*
*        Perform swap provisionally on diagonal block in D.
*
***/
u2[(1-(1))] = 1.0;
com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,4,u1,0,tau1.val,d,0,4,work,_work_offset);
com.polytechnik.lapack310.Dlarfx.dlarfx("R",4,3,u1,0,tau1.val,d,0,4,work,_work_offset);
com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,4,u2,0,tau2.val,d,(2-(1))+(1-(1)) * (4),4,work,_work_offset);
/***
*
*        Test whether to reject swap.
*
***/
com.polytechnik.lapack310.Dlarfx.dlarfx("R",4,3,u2,0,tau2.val,d,(1-(1))+(2-(1)) * (4),4,work,_work_offset);
/***
*
*        Accept swap: apply transformation to the entire matrix T.
*
***/
if ((Math.max(Util.max(Math.abs(d[(3-(1))+(1-(1)) * (4)]), Math.abs(d[(3-(1))+(2-(1)) * (4)]), Math.abs(d[(4-(1))+(1-(1)) * (4)])), Math.abs(d[(4-(1))+(2-(1)) * (4)]))  > thresh)) {
    break label50;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",50);
}
    com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,((n-j1)+1),u1,0,tau1.val,t,(j1-(1))+(j1-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
com.polytechnik.lapack310.Dlarfx.dlarfx("R",j4,3,u1,0,tau1.val,t,(1-(1))+(j1-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
com.polytechnik.lapack310.Dlarfx.dlarfx("L",3,((n-j1)+1),u2,0,tau2.val,t,(j2-(1))+(j1-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
// *
com.polytechnik.lapack310.Dlarfx.dlarfx("R",j4,3,u2,0,tau2.val,t,(1-(1))+(j2-(1)) * (ldt)+ _t_offset,ldt,work,_work_offset);
t[(j3-(1))+(j1-(1)) * (ldt)+ _t_offset] = 0.0;
t[(j3-(1))+(j2-(1)) * (ldt)+ _t_offset] = 0.0;
t[(j4-(1))+(j1-(1)) * (ldt)+ _t_offset] = 0.0;
// *
t[(j4-(1))+(j2-(1)) * (ldt)+ _t_offset] = 0.0;
/***
*
*           Accumulate transformation in the matrix Q.
*
***/
if (wantq)  {
    com.polytechnik.lapack310.Dlarfx.dlarfx("R",n,3,u1,0,tau1.val,q,(1-(1))+(j1-(1)) * (ldq)+ _q_offset,ldq,work,_work_offset);
com.polytechnik.lapack310.Dlarfx.dlarfx("R",n,3,u2,0,tau2.val,q,(1-(1))+(j2-(1)) * (ldq)+ _q_offset,ldq,work,_work_offset);
// *
}
// *
break label40;}// END label40
    //Dummy.label("com/polytechnik/lapack310/Dlaexc",40);
/***
*
*           Standardize new 2-by-2 block T11
*
***/
if ((n2 == 2))  {
    dlanv2_adapter(t,(j1-(1))+(j1-(1)) * (ldt)+ _t_offset,t,(j1-(1))+(j2-(1)) * (ldt)+ _t_offset,t,(j2-(1))+(j1-(1)) * (ldt)+ _t_offset,t,(j2-(1))+(j2-(1)) * (ldt)+ _t_offset,wr1,wi1,wr2,wi2,cs,sn);
com.polytechnik.lapack310.Drot.drot(((n-j1)-1),t,(j1-(1))+((j1+2)-(1)) * (ldt)+ _t_offset,ldt,t,(j2-(1))+((j1+2)-(1)) * (ldt)+ _t_offset,ldt,cs.val,sn.val);
com.polytechnik.lapack310.Drot.drot((j1-1),t,(1-(1))+(j1-(1)) * (ldt)+ _t_offset,1,t,(1-(1))+(j2-(1)) * (ldt)+ _t_offset,1,cs.val,sn.val);
if (wantq) {
    com.polytechnik.lapack310.Drot.drot(n,q,(1-(1))+(j1-(1)) * (ldq)+ _q_offset,1,q,(1-(1))+(j2-(1)) * (ldq)+ _q_offset,1,cs.val,sn.val);
}
    // *
}
/***
*
*           Standardize new 2-by-2 block T22
*
***/
if ((n1 == 2))  {
    j3 = (j1+n2);
j4 = (j3+1);
dlanv2_adapter(t,(j3-(1))+(j3-(1)) * (ldt)+ _t_offset,t,(j3-(1))+(j4-(1)) * (ldt)+ _t_offset,t,(j4-(1))+(j3-(1)) * (ldt)+ _t_offset,t,(j4-(1))+(j4-(1)) * (ldt)+ _t_offset,wr1,wi1,wr2,wi2,cs,sn);
if (((j3+2) <= n)) {
    com.polytechnik.lapack310.Drot.drot(((n-j3)-1),t,(j3-(1))+((j3+2)-(1)) * (ldt)+ _t_offset,ldt,t,(j4-(1))+((j3+2)-(1)) * (ldt)+ _t_offset,ldt,cs.val,sn.val);
}
    com.polytechnik.lapack310.Drot.drot((j3-1),t,(1-(1))+(j3-(1)) * (ldt)+ _t_offset,1,t,(1-(1))+(j4-(1)) * (ldt)+ _t_offset,1,cs.val,sn.val);
if (wantq) {
    com.polytechnik.lapack310.Drot.drot(n,q,(1-(1))+(j3-(1)) * (ldq)+ _q_offset,1,q,(1-(1))+(j4-(1)) * (ldq)+ _q_offset,1,cs.val,sn.val);
}
    // *
}
}              //  Close else.
/***
*
*     Exit with INFO = 1 if swap was rejected.
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",999999);
}// END label50
//Dummy.label("com/polytechnik/lapack310/Dlaexc",50);
info.val = 1;
/***
*
*     End of DLAEXC
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlaexc",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Dlaexc",999999);
return;
   }
// adapter for dlarfg(ILorg/netlib/util/doubleW;[DIILorg/netlib/util/doubleW;)V
private static void dlarfg_adapter(int arg0 ,double [] arg1 , int arg1_offset ,double [] arg2 , int arg2_offset ,int arg3 ,doubleW arg4 )
{
doubleW _f2j_tmp1 = new doubleW(arg1[arg1_offset]);

com.polytechnik.lapack310.Dlarfg.dlarfg(arg0,_f2j_tmp1,arg2, arg2_offset,arg3,arg4);

arg1[arg1_offset] = _f2j_tmp1.val;
}

// adapter for dlanv2(Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;Lorg/netlib/util/doubleW;)V
private static void dlanv2_adapter(double [] arg0 , int arg0_offset ,double [] arg1 , int arg1_offset ,double [] arg2 , int arg2_offset ,double [] arg3 , int arg3_offset ,doubleW arg4 ,doubleW arg5 ,doubleW arg6 ,doubleW arg7 ,doubleW arg8 ,doubleW arg9 )
{
doubleW _f2j_tmp0 = new doubleW(arg0[arg0_offset]);
doubleW _f2j_tmp1 = new doubleW(arg1[arg1_offset]);
doubleW _f2j_tmp2 = new doubleW(arg2[arg2_offset]);
doubleW _f2j_tmp3 = new doubleW(arg3[arg3_offset]);

com.polytechnik.lapack310.Dlanv2.dlanv2(_f2j_tmp0,_f2j_tmp1,_f2j_tmp2,_f2j_tmp3,arg4,arg5,arg6,arg7,arg8,arg9);

arg0[arg0_offset] = _f2j_tmp0.val;
arg1[arg1_offset] = _f2j_tmp1.val;
arg2[arg2_offset] = _f2j_tmp2.val;
arg3[arg3_offset] = _f2j_tmp3.val;
}

} // End class.
