/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dlapy2.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Dlapy2 {

// *> \brief \b DLAPY2 returns sqrt(x2+y2).
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *> \htmlonly
// *> Download DLAPY2 + dependencies
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly
// *
// *  Definition:
// *  ===========
// *
// *       DOUBLE PRECISION FUNCTION DLAPY2( X, Y )
// *
// *       .. Scalar Arguments ..
// *       DOUBLE PRECISION   X, Y
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DLAPY2 returns sqrt(x**2+y**2), taking care not to cause unnecessary

// *> overflow and unnecessary underflow.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] X
// *> \verbatim
// *>          X is DOUBLE PRECISION
// *> \endverbatim
// *>
// *> \param[in] Y
// *> \verbatim
// *>          Y is DOUBLE PRECISION
// *>          X and Y specify the values x and y.
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup OTHERauxiliary
// *
// *  =====================================================================
//
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. External Functions ..
***/
/***
*     ..
*     .. External Subroutines ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
***/

public static double dlapy2 (double x,
double y)  {

double dlapy2= 0.0d;

label_999999:{

double w= 0.0d;
double xabs= 0.0d;
double yabs= 0.0d;
double z= 0.0d;
double hugeval= 0.0d;
boolean x_is_nan= false;
boolean y_is_nan= false;
double dlamch= 0.0d;
x_is_nan = com.polytechnik.lapack310.Disnan.disnan(x);
y_is_nan = com.polytechnik.lapack310.Disnan.disnan(y);
if (x_is_nan) {
    dlapy2 = x;
}
    if (y_is_nan) {
    dlapy2 = y;
}
    // *
hugeval = com.polytechnik.lapack310.Dlamch.dlamch("Overflow");
if ((!((x_is_nan || y_is_nan))))  {
    xabs = Math.abs(x);
yabs = Math.abs(y);
w = Math.max(xabs, yabs);
z = Math.min(xabs, yabs);
if (((z == 0.0) || (w > hugeval)))  {
    dlapy2 = w;
}
else  {
  dlapy2 = (w*Math.sqrt((1.0+( Math.pow(((z/w)), 2)))));
}              //  Close else.
}
/***
*
*     End of DLAPY2
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dlapy2",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Dlapy2",999999);
return dlapy2;
   }
} // End class.
