/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dorgql.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Dorgql {

// *> \brief \b DORGQL
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *> \htmlonly
// *> Download DORGQL + dependencies
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE DORGQL( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
// *
// *       .. Scalar Arguments ..
// *       INTEGER            INFO, K, LDA, LWORK, M, N
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DORGQL generates an M-by-N real matrix Q with orthonormal columns,
// *> which is defined as the last N columns of a product of K elementary
// *> reflectors of order M
// *>
// *>       Q  =  H(k) . . . H(2) H(1)
// *>
// *> as returned by DGEQLF.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] M
// *> \verbatim
// *>          M is INTEGER
// *>          The number of rows of the matrix Q. M >= 0.
// *> \endverbatim
// *>
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>          The number of columns of the matrix Q. M >= N >= 0.
// *> \endverbatim
// *>
// *> \param[in] K
// *> \verbatim
// *>          K is INTEGER
// *>          The number of elementary reflectors whose product defines th
// *>          matrix Q. N >= K >= 0.
// *> \endverbatim
// *>
// *> \param[in,out] A
// *> \verbatim
// *>          A is DOUBLE PRECISION array, dimension (LDA,N)
// *>          On entry, the (n-k+i)-th column must contain the vector whic
// *>          defines the elementary reflector H(i), for i = 1,2,...,k, as
// *>          returned by DGEQLF in the last k columns of its array
// *>          argument A.
// *>          On exit, the M-by-N matrix Q.
// *> \endverbatim
// *>
// *> \param[in] LDA
// *> \verbatim
// *>          LDA is INTEGER
// *>          The first dimension of the array A. LDA >= max(1,M).
// *> \endverbatim
// *>
// *> \param[in] TAU
// *> \verbatim
// *>          TAU is DOUBLE PRECISION array, dimension (K)
// *>          TAU(i) must contain the scalar factor of the elementary
// *>          reflector H(i), as returned by DGEQLF.
// *> \endverbatim
// *>
// *> \param[out] WORK
// *> \verbatim
// *>          WORK is DOUBLE PRECISION array, dimension (MAX(1,LWORK))
// *>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
// *> \endverbatim
// *>
// *> \param[in] LWORK
// *> \verbatim
// *>          LWORK is INTEGER
// *>          The dimension of the array WORK. LWORK >= max(1,N).
// *>          For optimum performance LWORK >= N*NB, where NB is the
// *>          optimal blocksize.
// *>
// *>          If LWORK = -1, then a workspace query is assumed; the routin
// *>          only calculates the optimal size of the WORK array, returns

// *>          this value as the first entry of the WORK array, and no erro
// *>          message related to LWORK is issued by XERBLA.
// *> \endverbatim
// *>
// *> \param[out] INFO
// *> \verbatim
// *>          INFO is INTEGER
// *>          = 0:  successful exit
// *>          < 0:  if INFO = -i, the i-th argument has an illegal value
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup doubleOTHERcomputational
// *
// *  =====================================================================
//
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. External Subroutines ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. External Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
***/

public static void dorgql (int m,
int n,
int k,
double [] a, int _a_offset,
int lda,
double [] tau, int _tau_offset,
double [] work, int _work_offset,
int lwork,
intW info)  {

label_999999:{

boolean lquery= false;
int i= 0;
int ib= 0;
intW iinfo= new intW(0);
int iws= 0;
int j= 0;
int kk= 0;
int l= 0;
int ldwork= 0;
int lwkopt= 0;
int nb= 0;
int nbmin= 0;
int nx= 0;
info.val = 0;
lquery = ((lwork == -1));
if ((m < 0))  {
    info.val = -1;
}
else if (((n < 0) || (n > m)))  {
    info.val = -2;
}              // Close else if()
else if (((k < 0) || (k > n)))  {
    info.val = -3;
}              // Close else if()
else if ((lda < Math.max(1, m)))  {
    info.val = -5;
// *
}              // Close else if()
if ((info.val == 0))  {
    if ((n == 0))  {
    lwkopt = 1;
}
else  {
    nb = 1;//com.polytechnik.lapack310.Ilaenv.ilaenv(1,"DORGQL"," ",m,n,k,-1);
lwkopt = (n*nb);
}              //  Close else.
// *
work[(1-(1))+ _work_offset] = (double)(lwkopt);
if (((lwork < Math.max(1, n)) && (!lquery)))  {
    info.val = -8;
}
// *
}
if ((info.val != 0))  {
    com.polytechnik.lapack310.Xerbla.xerbla("DORGQL",(-(info.val)));
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgql",999999);
}
else if (lquery)  {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgql",999999);
/***
*
*     Quick return if possible
*
***/
}              // Close else if()
if ((n <= 0))  {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgql",999999);
// *
}
nbmin = 2;
nx = 0;
iws = n;
/***
*
*        Determine when to cross over from blocked to unblocked code.
*
***/
if (((nb > 1) && (nb < k)))  {
    nx = Math.max(0, 0/*com.polytechnik.lapack310.Ilaenv.ilaenv(3,"DORGQL"," ",m,n,k,-1)*/);
/***
*
*           Determine if workspace is large enough for blocked code.
*
***/
if ((nx < k))  {
    ldwork = n;
iws = (ldwork*nb);
/***
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
***/
if ((lwork < iws))  {
    nb = (lwork/ldwork);
    nbmin = Math.max(2, 2/*com.polytechnik.lapack310.Ilaenv.ilaenv(2,"DORGQL"," ",m,n,k,-1)*/);
}
}
// *
}
/***
*
*        Use blocked code after the first block.
*        The last kk columns are handled by the block method.
*
***/
if ((((nb >= nbmin) && (nb < k)) && (nx < k)))  {
    /***
*
*        Set A(m-kk+1:m,1:n-kk) to zero.
*
***/
kk = Math.min(k, (((((((k-nx)+nb)-1))/nb))*nb));
{
for (j = 1; j <= (n-kk); j++) {
{
for (i = ((m-kk)+1); i <= m; i++) {
a[(i-(1))+(j-(1)) * (lda)+ _a_offset] = 0.0;
//Dummy.label("com/polytechnik/lapack310/Dorgql",10);
}              //  Close for() loop.
}
//Dummy.label("com/polytechnik/lapack310/Dorgql",20);
}              //  Close for() loop.
}
}
else  {
  kk = 0;
/***
*
*     Use unblocked code for the first or only block.
*
***/
}              //  Close else.
// *
com.polytechnik.lapack310.Dorg2l.dorg2l((m-kk),(n-kk),(k-kk),a,_a_offset,lda,tau,_tau_offset,work,_work_offset,iinfo);
/***
*
*        Use blocked code
*
***/
if ((kk > 0))  {
    {
int _i_inc = nb;
for (i = ((k-kk)+1); (_i_inc < 0) ? i >= k : i <= k; i += _i_inc) {
ib = Math.min(nb, ((k-i)+1));
/***
*
*              Form the triangular factor of the block reflector
*              H = H(i+ib-1) . . . H(i+1) H(i)
*
***/
if ((((n-k)+i) > 1))  {
    /***
*
*              Apply H to A(1:m-k+i+ib-1,1:n-k+i-1) from the left
*
***/
com.polytechnik.lapack310.Dlarft.dlarft("Backward","Columnwise",((((m-k)+i)+ib)-1),ib,a,(1-(1))+(((n-k)+i)-(1)) * (lda)+ _a_offset,lda,tau,(i-(1))+ _tau_offset,work,_work_offset,ldwork);
com.polytechnik.lapack310.Dlarfb.dlarfb("Left","No transpose","Backward","Columnwise",((((m-k)+i)+ib)-1),(((n-k)+i)-1),ib,a,(1-(1))+(((n-k)+i)-(1)) * (lda)+ _a_offset,lda,work,_work_offset,ldwork,a,_a_offset,lda,work,((ib+1)-(1))+ _work_offset,ldwork);
/***
*
*           Apply H to rows 1:m-k+i+ib-1 of current block
*
***/
}
/***
*
*           Set rows m-k+i+ib:m of current block to zero
*
***/
com.polytechnik.lapack310.Dorg2l.dorg2l(((((m-k)+i)+ib)-1),ib,ib,a,(1-(1))+(((n-k)+i)-(1)) * (lda)+ _a_offset,lda,tau,(i-(1))+ _tau_offset,work,_work_offset,iinfo);
{
for (j = ((n-k)+i); j <= ((((n-k)+i)+ib)-1); j++) {
{
for (l = (((m-k)+i)+ib); l <= m; l++) {
a[(l-(1))+(j-(1)) * (lda)+ _a_offset] = 0.0;
//Dummy.label("com/polytechnik/lapack310/Dorgql",30);
}              //  Close for() loop.
}
//Dummy.label("com/polytechnik/lapack310/Dorgql",40);
}              //  Close for() loop.
}
//Dummy.label("com/polytechnik/lapack310/Dorgql",50);
}              //  Close for() loop.
}
// *
}
work[(1-(1))+ _work_offset] = (double)(iws);
/***
*
*     End of DORGQL
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgql",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Dorgql",999999);
return;
   }
} // End class.
