/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dorgqr.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Dorgqr {

// *> \brief \b DORGQR
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *> \htmlonly
// *> Download DORGQR + dependencies
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE DORGQR( M, N, K, A, LDA, TAU, WORK, LWORK, INFO )
// *
// *       .. Scalar Arguments ..
// *       INTEGER            INFO, K, LDA, LWORK, M, N
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION   A( LDA, * ), TAU( * ), WORK( * )
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DORGQR generates an M-by-N real matrix Q with orthonormal columns,
// *> which is defined as the first N columns of a product of K elementary

// *> reflectors of order M
// *>
// *>       Q  =  H(1) H(2) . . . H(k)
// *>
// *> as returned by DGEQRF.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] M
// *> \verbatim
// *>          M is INTEGER
// *>          The number of rows of the matrix Q. M >= 0.
// *> \endverbatim
// *>
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>          The number of columns of the matrix Q. M >= N >= 0.
// *> \endverbatim
// *>
// *> \param[in] K
// *> \verbatim
// *>          K is INTEGER
// *>          The number of elementary reflectors whose product defines th
// *>          matrix Q. N >= K >= 0.
// *> \endverbatim
// *>
// *> \param[in,out] A
// *> \verbatim
// *>          A is DOUBLE PRECISION array, dimension (LDA,N)
// *>          On entry, the i-th column must contain the vector which
// *>          defines the elementary reflector H(i), for i = 1,2,...,k, as
// *>          returned by DGEQRF in the first k columns of its array
// *>          argument A.
// *>          On exit, the M-by-N matrix Q.
// *> \endverbatim
// *>
// *> \param[in] LDA
// *> \verbatim
// *>          LDA is INTEGER
// *>          The first dimension of the array A. LDA >= max(1,M).
// *> \endverbatim
// *>
// *> \param[in] TAU
// *> \verbatim
// *>          TAU is DOUBLE PRECISION array, dimension (K)
// *>          TAU(i) must contain the scalar factor of the elementary
// *>          reflector H(i), as returned by DGEQRF.
// *> \endverbatim
// *>
// *> \param[out] WORK
// *> \verbatim
// *>          WORK is DOUBLE PRECISION array, dimension (MAX(1,LWORK))
// *>          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
// *> \endverbatim
// *>
// *> \param[in] LWORK
// *> \verbatim
// *>          LWORK is INTEGER
// *>          The dimension of the array WORK. LWORK >= max(1,N).
// *>          For optimum performance LWORK >= N*NB, where NB is the
// *>          optimal blocksize.
// *>
// *>          If LWORK = -1, then a workspace query is assumed; the routin
// *>          only calculates the optimal size of the WORK array, returns

// *>          this value as the first entry of the WORK array, and no erro
// *>          message related to LWORK is issued by XERBLA.
// *> \endverbatim
// *>
// *> \param[out] INFO
// *> \verbatim
// *>          INFO is INTEGER
// *>          = 0:  successful exit
// *>          < 0:  if INFO = -i, the i-th argument has an illegal value
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup doubleOTHERcomputational
// *
// *  =====================================================================
//
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. External Subroutines ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. External Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
***/

public static void dorgqr (int m,
int n,
int k,
double [] a, int _a_offset,
int lda,
double [] tau, int _tau_offset,
double [] work, int _work_offset,
int lwork,
intW info)  {

label_999999:{

boolean lquery= false;
int i= 0;
int ib= 0;
intW iinfo= new intW(0);
int iws= 0;
int j= 0;
int ki= 0;
int kk= 0;
int l= 0;
int ldwork= 0;
int lwkopt= 0;
int nb= 0;
int nbmin= 0;
int nx= 0;
info.val = 0;
nb = 1;//com.polytechnik.lapack310.Ilaenv.ilaenv(1,"DORGQR"," ",m,n,k,-1);
lwkopt = (Math.max(1, n)*nb);
work[(1-(1))+ _work_offset] = (double)(lwkopt);
lquery = ((lwork == -1));
if ((m < 0))  {
    info.val = -1;
}
else if (((n < 0) || (n > m)))  {
    info.val = -2;
}              // Close else if()
else if (((k < 0) || (k > n)))  {
    info.val = -3;
}              // Close else if()
else if ((lda < Math.max(1, m)))  {
    info.val = -5;
}              // Close else if()
else if (((lwork < Math.max(1, n)) && (!lquery)))  {
    info.val = -8;
}              // Close else if()
if ((info.val != 0))  {
    com.polytechnik.lapack310.Xerbla.xerbla("DORGQR",(-(info.val)));
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgqr",999999);
}
else if (lquery)  {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgqr",999999);
/***
*
*     Quick return if possible
*
***/
}              // Close else if()
if ((n <= 0))  {
    work[(1-(1))+ _work_offset] = (double)(1);
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgqr",999999);
// *
}
nbmin = 2;
nx = 0;
iws = n;
/***
*
*        Determine when to cross over from blocked to unblocked code.
*
***/
if (((nb > 1) && (nb < k)))  {
    nx = Math.max(0, 0/*com.polytechnik.lapack310.Ilaenv.ilaenv(3,"DORGQR"," ",m,n,k,-1)*/);
/***
*
*           Determine if workspace is large enough for blocked code.
*
***/
if ((nx < k))  {
    ldwork = n;
iws = (ldwork*nb);
/***
*
*              Not enough workspace to use optimal NB:  reduce NB and
*              determine the minimum value of NB.
*
***/
if ((lwork < iws))  {
    nb = (lwork/ldwork);
    nbmin = Math.max(2, 2/*com.polytechnik.lapack310.Ilaenv.ilaenv(2,"DORGQR"," ",m,n,k,-1)*/);
}
}
// *
}
/***
*
*        Use blocked code after the last block.
*        The first kk columns are handled by the block method.
*
***/
if ((((nb >= nbmin) && (nb < k)) && (nx < k)))  {
    ki = ((((((k-nx)-1))/nb))*nb);
/***
*
*        Set A(1:kk,kk+1:n) to zero.
*
***/
kk = Math.min(k, (ki+nb));
{
for (j = (kk+1); j <= n; j++) {
{
for (i = 1; i <= kk; i++) {
a[(i-(1))+(j-(1)) * (lda)+ _a_offset] = 0.0;
//Dummy.label("com/polytechnik/lapack310/Dorgqr",10);
}              //  Close for() loop.
}
//Dummy.label("com/polytechnik/lapack310/Dorgqr",20);
}              //  Close for() loop.
}
}
else  {
  kk = 0;
/***
*
*     Use unblocked code for the last or only block.
*
***/
}              //  Close else.
// *
if ((kk < n)) {
    com.polytechnik.lapack310.Dorg2r.dorg2r((m-kk),(n-kk),(k-kk),a,((kk+1)-(1))+((kk+1)-(1)) * (lda)+ _a_offset,lda,tau,((kk+1)-(1))+ _tau_offset,work,_work_offset,iinfo);
}
    /***
*
*        Use blocked code
*
***/
if ((kk > 0))  {
    {
int _i_inc = (-(nb));
for (i = (ki+1); (_i_inc < 0) ? i >= 1 : i <= 1; i += _i_inc) {
ib = Math.min(nb, ((k-i)+1));
/***
*
*              Form the triangular factor of the block reflector
*              H = H(i) H(i+1) . . . H(i+ib-1)
*
***/
if (((i+ib) <= n))  {
    /***
*
*              Apply H to A(i:m,i+ib:n) from the left
*
***/
com.polytechnik.lapack310.Dlarft.dlarft("Forward","Columnwise",((m-i)+1),ib,a,(i-(1))+(i-(1)) * (lda)+ _a_offset,lda,tau,(i-(1))+ _tau_offset,work,_work_offset,ldwork);
com.polytechnik.lapack310.Dlarfb.dlarfb("Left","No transpose","Forward","Columnwise",((m-i)+1),(((n-i)-ib)+1),ib,a,(i-(1))+(i-(1)) * (lda)+ _a_offset,lda,work,_work_offset,ldwork,a,(i-(1))+((i+ib)-(1)) * (lda)+ _a_offset,lda,work,((ib+1)-(1))+ _work_offset,ldwork);
/***
*
*           Apply H to rows i:m of current block
*
***/
}
/***
*
*           Set rows 1:i-1 of current block to zero
*
***/
com.polytechnik.lapack310.Dorg2r.dorg2r(((m-i)+1),ib,ib,a,(i-(1))+(i-(1)) * (lda)+ _a_offset,lda,tau,(i-(1))+ _tau_offset,work,_work_offset,iinfo);
{
for (j = i; j <= ((i+ib)-1); j++) {
{
for (l = 1; l <= (i-1); l++) {
a[(l-(1))+(j-(1)) * (lda)+ _a_offset] = 0.0;
//Dummy.label("com/polytechnik/lapack310/Dorgqr",30);
}              //  Close for() loop.
}
//Dummy.label("com/polytechnik/lapack310/Dorgqr",40);
}              //  Close for() loop.
}
//Dummy.label("com/polytechnik/lapack310/Dorgqr",50);
}              //  Close for() loop.
}
// *
}
work[(1-(1))+ _work_offset] = (double)(iws);
/***
*
*     End of DORGQR
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dorgqr",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Dorgqr",999999);
return;
   }
} // End class.
