/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: dsterf.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Dsterf {

// *> \brief \b DSTERF
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *> \htmlonly
// *> Download DSTERF + dependencies
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly
// *
// *  Definition:
// *  ===========
// *
// *       SUBROUTINE DSTERF( N, D, E, INFO )
// *
// *       .. Scalar Arguments ..
// *       INTEGER            INFO, N
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION   D( * ), E( * )
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> DSTERF computes all eigenvalues of a symmetric tridiagonal matrix
// *> using the Pal-Walker-Kahan variant of the QL or QR algorithm.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>          The order of the matrix.  N >= 0.
// *> \endverbatim
// *>
// *> \param[in,out] D
// *> \verbatim
// *>          D is DOUBLE PRECISION array, dimension (N)
// *>          On entry, the n diagonal elements of the tridiagonal matrix.
// *>          On exit, if INFO = 0, the eigenvalues in ascending order.
// *> \endverbatim
// *>
// *> \param[in,out] E
// *> \verbatim
// *>          E is DOUBLE PRECISION array, dimension (N-1)
// *>          On entry, the (n-1) subdiagonal elements of the tridiagonal

// *>          matrix.
// *>          On exit, E has been destroyed.
// *> \endverbatim
// *>
// *> \param[out] INFO
// *> \verbatim
// *>          INFO is INTEGER
// *>          = 0:  successful exit
// *>          < 0:  if INFO = -i, the i-th argument had an illegal value
// *>          > 0:  the algorithm failed to find all of the eigenvalues in
// *>                a total of 30*N iterations; if INFO = i, then i
// *>                elements of E have not converged to zero.
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup auxOTHERcomputational
// *
// *  =====================================================================
//
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. External Functions ..
***/
/***
*     ..
*     .. External Subroutines ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
***/
/***
*
*     Quick return if possible
*
***/

public static void dsterf (int n,
double [] d, int _d_offset,
double [] e, int _e_offset,
intW info)  {

label_999999:{

int i= 0;
int iscale= 0;
int jtot= 0;
int l= 0;
int l1= 0;
int lend= 0;
int lendsv= 0;
int lsv= 0;
int m= 0;
int nmaxit= 0;
double alpha= 0.0d;
double anorm= 0.0d;
double bb= 0.0d;
double c= 0.0d;
double eps= 0.0d;
double eps2= 0.0d;
double gamma= 0.0d;
double oldc= 0.0d;
double oldgam= 0.0d;
double p= 0.0d;
double r= 0.0d;
doubleW rt1= new doubleW(0.0d);
doubleW rt2= new doubleW(0.0d);
double rte= 0.0d;
double s= 0.0d;
double safmax= 0.0d;
double safmin= 0.0d;
double sigma= 0.0d;
double ssfmax= 0.0d;
double ssfmin= 0.0d;
double rmax= 0.0d;
info.val = 0;
if ((n < 0))  {
    info.val = -1;
com.polytechnik.lapack310.Xerbla.xerbla("DSTERF",(-(info.val)));
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",999999);
}
/***
*
*     Determine the unit roundoff for this environment.
*
***/
if ((n <= 1)) {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",999999);
}
    eps = com.polytechnik.lapack310.Dlamch.dlamch("E");
eps2 = ( Math.pow(eps, 2));
safmin = com.polytechnik.lapack310.Dlamch.dlamch("S");
safmax = (1.0/safmin);
ssfmax = (Math.sqrt(safmax)/3.0);
ssfmin = (Math.sqrt(safmin)/eps2);
/***
*
*     Compute the eigenvalues of the tridiagonal matrix.
*
***/
rmax = com.polytechnik.lapack310.Dlamch.dlamch("O");
nmaxit = (n*30);
sigma = 0.0;
/***
*
*     Determine where the matrix splits and choose QL or QR iteration
*     for each block, according to whether top or bottom diagonal
*     element is smaller.
*
***/
jtot = 0;
// *
l1 = 1;
label180:{
label170:{
label10:for(;;){
label150:{
label30:{
    //Dummy.label("com/polytechnik/lapack310/Dsterf",10);
if ((l1 > n)) {
    break label170;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",170);
}
    if ((l1 > 1)) {
    e[((l1-1)-(1))+ _e_offset] = 0.0;
}
    {
for (m = l1; m <= (n-1); m++) {
if ((Math.abs(e[(m-(1))+ _e_offset]) <= (((Math.sqrt(Math.abs(d[(m-(1))+ _d_offset]))*Math.sqrt(Math.abs(d[((m+1)-(1))+ _d_offset]))))*eps)))  {
    e[(m-(1))+ _e_offset] = 0.0;
    break label30;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",30);
}
//Dummy.label("com/polytechnik/lapack310/Dsterf",20);
}              //  Close for() loop.
}
// *
m = n;
break label30;}
//Dummy.label("com/polytechnik/lapack310/Dsterf",30);
l = l1;
lsv = l;
lend = m;
lendsv = lend;
l1 = (m+1);
/***
*
*     Scale submatrix in rows and columns L to LEND
*
***/
if ((lend == l)) {
    continue label10;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",10);
}
    anorm = com.polytechnik.lapack310.Dlanst.dlanst("M",((lend-l)+1),d,(l-(1))+ _d_offset,e,(l-(1))+ _e_offset);
iscale = 0;
if ((anorm == 0.0)) {
    continue label10;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",10);
}
    if (((anorm > ssfmax)))  {
    iscale = 1;
com.polytechnik.lapack310.Dlascl.dlascl("G",0,0,anorm,ssfmax,((lend-l)+1),1,d,(l-(1))+ _d_offset,n,info);
com.polytechnik.lapack310.Dlascl.dlascl("G",0,0,anorm,ssfmax,(lend-l),1,e,(l-(1))+ _e_offset,n,info);
}
else if ((anorm < ssfmin))  {
    iscale = 2;
com.polytechnik.lapack310.Dlascl.dlascl("G",0,0,anorm,ssfmin,((lend-l)+1),1,d,(l-(1))+ _d_offset,n,info);
com.polytechnik.lapack310.Dlascl.dlascl("G",0,0,anorm,ssfmin,(lend-l),1,e,(l-(1))+ _e_offset,n,info);
// *
}              // Close else if()
{
for (i = l; i <= (lend-1); i++) {
e[(i-(1))+ _e_offset] = ( Math.pow(e[(i-(1))+ _e_offset], 2));
/***
*
*     Choose between QL and QR iteration
*
***/
//Dummy.label("com/polytechnik/lapack310/Dsterf",40);
}              //  Close for() loop.
}
if ((Math.abs(d[(lend-(1))+ _d_offset]) < Math.abs(d[(l-(1))+ _d_offset])))  {
    lend = lsv;
l = lendsv;
// *
}
/***
*
*        QL Iteration
*
*        Look for small subdiagonal element.
*
***/
if ((lend >= l))  {
label50:for(;;){
label90:{
label70:{
	//Dummy.label("com/polytechnik/lapack310/Dsterf",50);
if ((l != lend))  {
    {
for (m = l; m <= (lend-1); m++) {
if ((Math.abs(e[(m-(1))+ _e_offset]) <= (eps2*Math.abs((d[(m-(1))+ _d_offset]*d[((m+1)-(1))+ _d_offset]))))) {
    break label70;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",70);
}
//Dummy.label("com/polytechnik/lapack310/Dsterf",60);
}              //  Close for() loop.
}
}
// *
m = lend;
break label70;}
//Dummy.label("com/polytechnik/lapack310/Dsterf",70);
if ((m < lend)) {
    e[(m-(1))+ _e_offset] = 0.0;
}
    p = d[(l-(1))+ _d_offset];
/***
*
*        If remaining matrix is 2 by 2, use DLAE2 to compute its
*        eigenvalues.
*
***/
if ((m == l)) {
    break label90;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",90);
}
    if ((m == (l+1)))  {
    rte = Math.sqrt(e[(l-(1))+ _e_offset]);
com.polytechnik.lapack310.Dlae2.dlae2(d[(l-(1))+ _d_offset],rte,d[((l+1)-(1))+ _d_offset],rt1,rt2);
d[(l-(1))+ _d_offset] = rt1.val;
d[((l+1)-(1))+ _d_offset] = rt2.val;
e[(l-(1))+ _e_offset] = 0.0;
l = (l+2);
if ((l <= lend)) {
    continue label50;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",50);
}
break label150;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",150);
// *
}
if ((jtot == nmaxit)) {
    break label150;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",150);
}
    /***
*
*        Form shift.
*
***/
jtot = (jtot+1);
rte = Math.sqrt(e[(l-(1))+ _e_offset]);
sigma = (((d[((l+1)-(1))+ _d_offset]-p))/((2.0*rte)));
r = com.polytechnik.lapack310.Dlapy2.dlapy2(sigma,1.0);
// *
sigma = (p-((rte/((sigma+Util.dsign(r,sigma))))));
c = 1.0;
s = 0.0;
gamma = (d[(m-(1))+ _d_offset]-sigma);
/***
*
*        Inner loop
*
***/
p = (gamma*gamma);
{
int _i_inc = -1;
for (i = (m-1); i >= l; i += _i_inc) {
bb = e[(i-(1))+ _e_offset];
r = (p+bb);
if ((i != (m-1))) {
    e[((i+1)-(1))+ _e_offset] = (s*r);
}
    oldc = c;
c = (p/r);
s = (bb/r);
oldgam = gamma;
alpha = d[(i-(1))+ _d_offset];
gamma = ((c*((alpha-sigma)))-(s*oldgam));
d[((i+1)-(1))+ _d_offset] = (oldgam+((alpha-gamma)));
if ((c != 0.0))  {
    p = (((gamma*gamma))/c);
}
else  {
  p = (oldc*bb);
}              //  Close else.
// *
//Dummy.label("com/polytechnik/lapack310/Dsterf",80);
}              //  Close for() loop.
}
e[(l-(1))+ _e_offset] = (s*p);
d[(l-(1))+ _d_offset] = (sigma+gamma);
/***
*
*        Eigenvalue found.
*
***/
continue label50;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",50);
}//break label90;
	//Dummy.label("com/polytechnik/lapack310/Dsterf",90);
// *
d[(l-(1))+ _d_offset] = p;
l = (l+1);
if ((l <= lend)) {
    continue label50;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",50);
}
break label50;}
    // *
break label150;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",150);
/***
*
*        QR Iteration
*
*        Look for small superdiagonal element.
*
***/
}
else  {
label100:for(;;){
label140:{
label120:{
	//Dummy.label("com/polytechnik/lapack310/Dsterf",100);
{
int _m_inc = -1;
for (m = l; m >= (lend+1); m += _m_inc) {
if ((Math.abs(e[((m-1)-(1))+ _e_offset]) <= (eps2*Math.abs((d[(m-(1))+ _d_offset]*d[((m-1)-(1))+ _d_offset]))))) {
    break label120;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",120);
}
//Dummy.label("com/polytechnik/lapack310/Dsterf",110);
}              //  Close for() loop.
}
// *
m = lend;
break label120;}
	//Dummy.label("com/polytechnik/lapack310/Dsterf",120);
if ((m > lend)) {
    e[((m-1)-(1))+ _e_offset] = 0.0;
}
    p = d[(l-(1))+ _d_offset];
/***
*
*        If remaining matrix is 2 by 2, use DLAE2 to compute its
*        eigenvalues.
*
***/
if ((m == l)) {
    break label140;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",140);
}
    if ((m == (l-1)))  {
    rte = Math.sqrt(e[((l-1)-(1))+ _e_offset]);
com.polytechnik.lapack310.Dlae2.dlae2(d[(l-(1))+ _d_offset],rte,d[((l-1)-(1))+ _d_offset],rt1,rt2);
d[(l-(1))+ _d_offset] = rt1.val;
d[((l-1)-(1))+ _d_offset] = rt2.val;
e[((l-1)-(1))+ _e_offset] = 0.0;
l = (l-2);
if ((l >= lend)) {
    continue label100;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",100);
}
    break label150;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",150);
// *
}
if ((jtot == nmaxit)) {
    break label150;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",150);
}
    /***
*
*        Form shift.
*
***/
jtot = (jtot+1);
rte = Math.sqrt(e[((l-1)-(1))+ _e_offset]);
sigma = (((d[((l-1)-(1))+ _d_offset]-p))/((2.0*rte)));
r = com.polytechnik.lapack310.Dlapy2.dlapy2(sigma,1.0);
// *
sigma = (p-((rte/((sigma+Util.dsign(r,sigma))))));
c = 1.0;
s = 0.0;
gamma = (d[(m-(1))+ _d_offset]-sigma);
/***
*
*        Inner loop
*
***/
p = (gamma*gamma);
{
for (i = m; i <= (l-1); i++) {
bb = e[(i-(1))+ _e_offset];
r = (p+bb);
if ((i != m)) {
    e[((i-1)-(1))+ _e_offset] = (s*r);
}
    oldc = c;
c = (p/r);
s = (bb/r);
oldgam = gamma;
alpha = d[((i+1)-(1))+ _d_offset];
gamma = ((c*((alpha-sigma)))-(s*oldgam));
d[(i-(1))+ _d_offset] = (oldgam+((alpha-gamma)));
if ((c != 0.0))  {
    p = (((gamma*gamma))/c);
}
else  {
  p = (oldc*bb);
}              //  Close else.
// *
//Dummy.label("com/polytechnik/lapack310/Dsterf",130);
}              //  Close for() loop.
}
e[((l-1)-(1))+ _e_offset] = (s*p);
d[(l-(1))+ _d_offset] = (sigma+gamma);
/***
*
*        Eigenvalue found.
*
***/
continue label100;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",100);

}//break label140;

	//Dummy.label("com/polytechnik/lapack310/Dsterf",140);
// *
d[(l-(1))+ _d_offset] = p;
l = (l-1);
if ((l >= lend)) {
    continue label100;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",100);
}
break label100;}
    // *
break label150;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",150);
/***
*
*     Undo scaling if necessary
*
***/
}              //  Close else.
}//break label150;
//Dummy.label("com/polytechnik/lapack310/Dsterf",150);
if ((iscale == 1)) {
    com.polytechnik.lapack310.Dlascl.dlascl("G",0,0,ssfmax,anorm,((lendsv-lsv)+1),1,d,(lsv-(1))+ _d_offset,n,info);
}
    /***
*
*     Check for no convergence to an eigenvalue after a total
*     of N*MAXIT iterations.
*
***/
if ((iscale == 2)) {
    com.polytechnik.lapack310.Dlascl.dlascl("G",0,0,ssfmin,anorm,((lendsv-lsv)+1),1,d,(lsv-(1))+ _d_offset,n,info);
}
    if ((jtot < nmaxit)) {
    continue label10;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",10);
}
    {
for (i = 1; i <= (n-1); i++) {
if ((e[(i-(1))+ _e_offset] != 0.0)) {
    info.val = (info.val+1);
}
//Dummy.label("com/polytechnik/lapack310/Dsterf",160);
}              //  Close for() loop.
}
break label10;}
/***
*
*     Sort eigenvalues in increasing order.
*
***/
break label180;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",180);
//break label170;
}
//Dummy.label("com/polytechnik/lapack310/Dsterf",170);
// *
com.polytechnik.lapack310.Dlasrt.dlasrt("I",n,d,_d_offset,info);
break label180;}
//Dummy.label("com/polytechnik/lapack310/Dsterf",180);
/***
*
*     End of DSTERF
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Dsterf",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Dsterf",999999);
return;
   }
} // End class.
