/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: idamax.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Idamax {

// *> \brief \b IDAMAX
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *  Definition:
// *  ===========
// *
// *       INTEGER FUNCTION IDAMAX(N,DX,INCX)
// *
// *       .. Scalar Arguments ..
// *       INTEGER INCX,N
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION DX(*)
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *>    IDAMAX finds the index of the first element having maximum absolut
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>         number of elements in input vector(s)
// *> \endverbatim
// *>
// *> \param[in] DX
// *> \verbatim
// *>          DX is DOUBLE PRECISION array, dimension ( 1 + ( N - 1 )*abs(
// *> \endverbatim
// *>
// *> \param[in] INCX
// *> \verbatim
// *>          INCX is INTEGER
// *>         storage spacing between elements of DX
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup aux_blas
// *
// *> \par Further Details:
// *  =====================
// *>
// *> \verbatim
// *>
// *>     jack dongarra, linpack, 3/11/78.
// *>     modified 3/93 to return if incx .le. 0.
// *>     modified 12/3/93, array(1) declarations changed to array(*)
// *> \endverbatim
// *>
// *  =====================================================================
//
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
***/
/***
*     ..
*     .. Intrinsic Functions ..
***/
// *     ..

public static int idamax (int n,
double [] dx, int _dx_offset,
int incx)  {

int idamax= 0;

label_999999:{

double dmax= 0.0d;
int i= 0;
int ix= 0;
idamax = 0;
if (((n < 1) || (incx <= 0))) {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Idamax",999999);
}
    idamax = 1;
if ((n == 1)) {
    break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Idamax",999999);
}
    /***
*
*        code for increment equal to 1
*
***/
if ((incx == 1))  {
    dmax = Math.abs(dx[(1-(1))+ _dx_offset]);
{
for (i = 2; i <= n; i++) {
if ((Math.abs(dx[(i-(1))+ _dx_offset]) > dmax))  {
    idamax = i;
dmax = Math.abs(dx[(i-(1))+ _dx_offset]);
}
//Dummy.label("com/polytechnik/lapack310/Idamax",1000000);
}              //  Close for() loop.
}
/***
*
*        code for increment not equal to 1
*
***/
}
else  {
  ix = 1;
dmax = Math.abs(dx[(1-(1))+ _dx_offset]);
ix = (ix+incx);
{
for (i = 2; i <= n; i++) {
if ((Math.abs(dx[(ix-(1))+ _dx_offset]) > dmax))  {
    idamax = i;
dmax = Math.abs(dx[(ix-(1))+ _dx_offset]);
}
ix = (ix+incx);
//Dummy.label("com/polytechnik/lapack310/Idamax",1000001);
}              //  Close for() loop.
}
}              //  Close else.
/***
*
*     End of IDAMAX
*
***/
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Idamax",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Idamax",999999);
return idamax;
   }
} // End class.
