/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: iladlr.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Iladlr {

// *> \brief \b ILADLR scans a matrix for its last non-zero row.
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *> \htmlonly
// *> Download ILADLR + dependencies
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&fil
// *> [TGZ]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&fil
// *> [ZIP]</a>
// *> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&fil
// *> [TXT]</a>
// *> \endhtmlonly
// *
// *  Definition:
// *  ===========
// *
// *       INTEGER FUNCTION ILADLR( M, N, A, LDA )
// *
// *       .. Scalar Arguments ..
// *       INTEGER            M, N, LDA
// *       ..
// *       .. Array Arguments ..
// *       DOUBLE PRECISION   A( LDA, * )
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> ILADLR scans A for its last non-zero row.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] M
// *> \verbatim
// *>          M is INTEGER
// *>          The number of rows of the matrix A.
// *> \endverbatim
// *>
// *> \param[in] N
// *> \verbatim
// *>          N is INTEGER
// *>          The number of columns of the matrix A.
// *> \endverbatim
// *>
// *> \param[in] A
// *> \verbatim
// *>          A is DOUBLE PRECISION array, dimension (LDA,N)
// *>          The m by n matrix A.
// *> \endverbatim
// *>
// *> \param[in] LDA
// *> \verbatim
// *>          LDA is INTEGER
// *>          The leading dimension of the array A. LDA >= max(1,M).
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup OTHERauxiliary
// *
// *  =====================================================================
//
/***
*     ..
*     .. Array Arguments ..
***/
/***
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*     .. Executable Statements ..
*
*     Quick test for the common case where one corner is non-zero.
***/

public static int iladlr (int m,
int n,
double [] a, int _a_offset,
int lda)  {

int iladlr= 0;

label_999999:{

int i= 0;
int j= 0;
if ((m == 0))  {
    iladlr = m;
}
else if (((a[(m-(1))+(1-(1)) * (lda)+ _a_offset] != 0.0) || (a[(m-(1))+(n-(1)) * (lda)+ _a_offset] != 0.0)))  {
    iladlr = m;
// *     Scan up each column tracking the last zero row seen.
}              // Close else if()
else  {
  iladlr = 0;
{
for (j = 1; j <= n; j++) {
// *            DO WHILE((A(MAX(I,1),J).EQ.ZERO).AND.(I.GE.1))
i = m;
{
while ((((a[(Math.max(i, 1)-(1))+(j-(1)) * (lda)+ _a_offset] == 0.0)) && ((i >= 1))))  {
    i = (i-1);
//}
//else  {
//  Dummy.go_to("com/polytechnik/lapack310/Iladlr",1774);
//}              //  Close else.
//Dummy.label("com/polytechnik/lapack310/Iladlr",1000001);
}              //  Close for() loop.
}
//label1774:
//   Dummy.label("com/polytechnik/lapack310/Iladlr",1774);
iladlr = Math.max(iladlr, i);
//Dummy.label("com/polytechnik/lapack310/Iladlr",1000000);
}              //  Close for() loop.
}
}              //  Close else.
break label_999999;//Dummy.go_to("com/polytechnik/lapack310/Iladlr",999999);
// dummy stmt
}//Dummy.label("com/polytechnik/lapack310/Iladlr",999999);
return iladlr;
   }
} // End class.
