/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  http://www.netlib.org.
 *
 *  Fortran input file: lsame.f
 *  f2java version: 0.8.1
 *
 */

package com.polytechnik.lapack310;


public class Lsame {

// *> \brief \b LSAME
// *
// *  =========== DOCUMENTATION ===========
// *
// * Online html documentation available at
// *            http://www.netlib.org/lapack/explore-html/
// *
// *  Definition:
// *  ===========
// *
// *       LOGICAL FUNCTION LSAME(CA,CB)
// *
// *       .. Scalar Arguments ..
// *       CHARACTER CA,CB
// *       ..
// *
// *
// *> \par Purpose:
// *  =============
// *>
// *> \verbatim
// *>
// *> LSAME returns .TRUE. if CA is the same letter as CB regardless of
// *> case.
// *> \endverbatim
// *
// *  Arguments:
// *  ==========
// *
// *> \param[in] CA
// *> \verbatim
// *>          CA is CHARACTER*1
// *> \endverbatim
// *>
// *> \param[in] CB
// *> \verbatim
// *>          CB is CHARACTER*1
// *>          CA and CB specify the single characters to be compared.
// *> \endverbatim
// *
// *  Authors:
// *  ========
// *
// *> \author Univ. of Tennessee
// *> \author Univ. of California Berkeley
// *> \author Univ. of Colorado Denver
// *> \author NAG Ltd.
// *
// *> \ingroup aux_blas
// *
// *  =====================================================================
//
/***
*     ..
*
* =====================================================================
*
*     .. Intrinsic Functions ..
***/
/***
*     ..
*     .. Local Scalars ..
***/
/***
*     ..
*
*     Test if the characters are equal
*
***/

public static boolean lsame (String ca,
String cb)  {

boolean lsame= false;
int inta= 0;
int intb= 0;
int zcode= 0;
final char a = ca.charAt(0),b = cb.charAt(0);
return a==b;
}

} // End class.
