package com.polytechnik.outils;
/*
 * (C) Vladislav Malyshkin 2010
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.Laguerre;

/** Find real roots using Laguerre basis. The program for testing main code, do not use for production.
 *  @version $Id: LaguerrePolynomialRootsFinder.java,v 1.18 2020/02/06 10:29:41 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class LaguerrePolynomialRootsFinder extends PolynomialSimpleRootsFinder {

    public LaguerrePolynomialRootsFinder()
    {
	super(new Laguerre(),100,17,0,1e-3);
    }

/*
static void printAllQuadratures(final int n_max,
				final PolynomialSimpleRootsFinder thisfinder,
				final java.util.Random r)
{
    final Laguerre.TestBasisLaguerre t=new Laguerre.TestBasisLaguerre();
    for(int n=1;n<=n_max;n++)
    {
	t.printQuadratures(thisfinder,n);
	t.printRadauQuadratures2(thisfinder,n,r);
	t.printDeltaFunctionRoots(thisfinder,n);
    }
}
*/
    public static void main(String [] args)
    {
	final java.util.Random r=new java.util.Random(2711);
	final double eps=1e-8;
	//printAllQuadratures(30,new LaguerrePolynomialRootsFinder(),r);
	test_RealRootsFinder(19,new LaguerrePolynomialRootsFinder(),eps);
    }


}
