package com.polytechnik.outils;
/*
 * (C) Vladislav Malyshkin 2010
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.LegendreShifted;

/** Find real roots using LegendreShifted basis. The program for testing main code, do not use for production.
 *  @version $Id: LegendreShiftedPolynomialRootsFinder.java,v 1.17 2020/02/06 10:29:41 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class LegendreShiftedPolynomialRootsFinder extends PolynomialSimpleRootsFinder {
    public LegendreShiftedPolynomialRootsFinder()
    {
	super(new LegendreShifted(),100,17,1,1e-3);
    }

/*
static void printAllQuadratures(final int n_max,
				final PolynomialSimpleRootsFinder thisfinder,
				final java.util.Random r)
{
    for(int n=1;n<=n_max;n++)
    {
	final LegendreShifted.TestBasisLegendreShifted t=new LegendreShifted.TestBasisLegendreShifted();
	t.printQuadratures(thisfinder,n);
	t.printRadauQuadratures2(thisfinder,n,r);
	t.printDeltaFunctionRoots(thisfinder,n);
    }
}
*/

    public static void main(String [] args)
    {
	final java.util.Random r=new java.util.Random(2711);
	final double eps=1e-8;
	//printAllQuadratures(25,new LegendreShiftedPolynomialRootsFinder(),r);
	test_RealRootsFinder(12,new LegendreShiftedPolynomialRootsFinder(),eps);
    }


}
