#!/usr/bin/perl -w
use strict;
use FileHandle;

# Author: Vladislav Malyshkin mal@gromco.com
# $Id: distance_c4.5.pl,v 1.1 2008/10/19 16:50:27 mal Exp $

# plot a chart 

if($#ARGV<1 or ! -r $ARGV[0] )
{
    die "Usage: plot_chart datafile field1 field2 ...\n";
}

my $dist=[1000,2000,4000,8000,16000,32000,64000,128000,256000,512000,1024000];
my $pmin=[];
my $pmax=[];
foreach my $e (@$dist)
{
    push @$pmin,"P_dmin_1_004_".$e;
    push @$pmax,"P_dmax_1_004_".$e;
}

sub convfile($$$)
{
    my($infile,$outfile,$fields)=@_;
    print{*STDERR} "Converting $infile to $outfile ";
    my $ifh=new FileHandle();
    open($ifh,"<$infile") or die "can not open $infile";
    my $ofh=new FileHandle();
    open($ofh,">$outfile") or die "can not open $outfile";
    my $n=0;
    my $fields_ind=[];
    $#$fields_ind=$#$fields;
    my $nf=0;
    while(<$ifh>)
    {
	chomp; 
	my @a=split(/,/,$_);
	if($n<=0)
	{ # first line
	    my $nfff=0;
	    foreach my $f (@a)
	    {
		#print{*STDERR} $f," NF=$#$fields\n";
		for(my $nff=0;$nff<=$#$fields;$nff++)
		{
		    #print{*STDERR} $f," try $nff=",$fields->[$nff],"\n";
		    if($f eq $fields->[$nff])
		    {
			$fields_ind->[$nff]=$nf;
			$nfff++;
			#print{*STDERR} "FOUND nfff=$nfff\n";
			last;
		    }
		}
		$nf++;
	    }
	    if($nfff!=1+$#$fields)
	    {
		die "Some fields ".join(':',@$fields)." are not found $nfff and ".(1+$#$fields);
	    }
	    $nf--; # perl array style
	}
	else
	{
	    if($#a != $nf)
	    {
		die "invalid number of records $#a should be $nf";
	    }
	    foreach my $nff (@$fields_ind)
	    {
		print{$ofh} $a[$nff]," ";
	    }
	    print{$ofh}"\n";
	}
	$n++;
    }
    close($ifh);
    close($ofh);
    print{*STDERR} "DONE OK\n";
}





my $f=[];
for(my $v=1;$v<=$#ARGV;$v++)
{
    push @$f,$ARGV[$v];
}

convfile($ARGV[0],'/tmp/k.dat',$f);


