#!/usr/bin/perl -w
use strict;
# A simple script to reduce double precision.
# Used for comparison of double files with numbers separated by comma
# Author: Vladislav Malyshkin mal@gromco.com
# $Id: limit_double_precision.pl,v 1.8 2010/03/25 08:33:04 mal Exp $

my $n_digit=10;
if($#ARGV>=0)
{
    $n_digit=int($ARGV[0]);
    if($n_digit<=0)
    {
	die "number or digits should be positive\n";
    }
}
my $fmt="%.".$n_digit."e";

while(<STDIN>)
{
    chomp;
    my @a=split m@,@ ;
    my $n=0;
    foreach my $x (@a)
    {
	if($n++>0)
	{
	    print ",";
	}
	$x=~s@^\s+@@;
	$x=~s@\s+$@@;
	if($x eq '0.0')
	{
	    print $x;	
	}
	elsif($x=~m@^[+-]?\d+\.\d+(?is:e[+-]?\d+)?$@)
	{
	    print sprintf($fmt,$x);
	    #print sprintf("%.7e",$x);
	}
	else
	{
	    print $x;
	}
    }
    print "\n";
       
}
