#!/usr/bin/perl -w
use strict;
use FileHandle;

# Author: Vladislav Malyshkin mal@gromco.com
# $Id: plot_chart.pl,v 1.12 2009/05/04 22:00:48 mal Exp $

# plot a chart 

if($#ARGV<1 or ! -r $ARGV[0] )
{
    die "Usage: plot_chart datafile field1 field2 ...\n";
}


sub convfile($$$)
{
    my($infile,$outfile,$fields)=@_;
    print{*STDERR} "Converting $infile to $outfile\n";
    my $ifh=new FileHandle();
    open($ifh,"<$infile") or die "can not open $infile";
    my $ofh=new FileHandle();
    open($ofh,">$outfile") or die "can not open $outfile";
    my $n=0;
    my $fields_ind=[];
    $#$fields_ind=$#$fields;
    my $nf=0;
    while(<$ifh>)
    {
	chomp; 
	my @a=split(/,/,$_);
	if($n<=0)
	{ # first line
	    my $missed=[];
	    #print{*STDERR} "\n\n\nFIELDS ALL ",join(':',@a),"\n";
	    #print{*STDERR} "\n\n\nFIELDS REQUESTED ",join(':',@$fields),"\n";
	    for(my $nff=0;$nff<=$#$fields;$nff++)
	    {
		my $fc=1;
		#print{*STDERR} $f," try $nff=",$fields->[$nff],"\n";
		my $nfff=0;
		foreach my $f (@a)
		{
		    if($f eq $fields->[$nff])
		    {
			$fields_ind->[$nff]=$nfff;
			$fc=0;
			#print{*STDERR} "FOUND nfff=$nfff\n";
			last;
		    }
		    $nfff++;
		}
		if($fc)
		{
		    push @$missed,$fields->[$nff];
		}
	    }	   
	    if($#$missed>=0)
	    {
		die "The fields '".join(':',@$missed)."' are not found\n";
	    }
	    $nf=$#a;
	    # print header as gnuplot comment
	    print{$ofh}'#';
	    my $k=0;
	    foreach my $nff (@$fields_ind)
	    {
		if($k++ >0)
		{
		    print{$ofh} "\t";
		}
		print{$ofh} $a[$nff];
	    }
	    print{$ofh}"\n";
	}
	else
	{
	    if($_ =~ m@^\s*\|@)
	    {
		# comments start with |
		next;
	    }
	    if($#a != $nf)
	    {
		die "invalid number of records $#a should be $nf";
	    }
	    my $k=0;
	    foreach my $nff (@$fields_ind)
	    {
		if($k++ >0)
		{
		    print{$ofh} "\t";
		}
		print{$ofh} $a[$nff];
	    }
	    print{$ofh}"\n";
	}
	$n++;
    }
    close($ifh);
    close($ofh);
    print{*STDERR} "column\tfieldname\n";
    for(my $nff=0;$nff<=$#$fields;$nff++)
    {
	print{*STDERR} $nff+1,"\t",$fields->[$nff],"\n";	
    }
    print{*STDERR} "conversion to $outfile DONE ".($#$fields+1)." fields of ".($nf+1)." read $n lines OK\n";
}

my $f=[];
for(my $v=1;$v<=$#ARGV;$v++)
{
    push @$f,$ARGV[$v];
}

convfile($ARGV[0],'/tmp/k.dat',$f);


