#!/usr/bin/perl -w
use strict;
use FileHandle;

# Author: Vladislav Malyshkin mal@gromco.com
# $Id: use_c4.5.pl,v 1.16 2008/11/01 09:33:17 mal Exp $

# perl -w /home/polytechnik/new_way/com/polytechnik/scripts/use_c4.5.pl QQQQ.names 'hh(){ /home/polytechnik/c4.5/R8/Src/c4.5 -f $1 ; /home/polytechnik/c4.5/R8/Src/c4.5rules -F0.3 -f $1 ; } ; hh'

# perl -w /home/polytechnik/new_way/com/polytechnik/scripts/use_c4.5.pl /pdata/prices/out_ml/T.names  'hh(){ /home/polytechnik/rulequest/C50Release2/bin/c5.0 -r -w $@ ;  } ; hh ' 

if($#ARGV!=1 or ! -r $ARGV[0] )
{
    die "Usage: use_c4.5 generated_filestem.names cmdtorun\n";
}

sub readFromFile($)
{
    my($f)=@_;
    my $fh=new FileHandle();
    local $/=undef;
    open($fh,"<$f") or die "can not open $f";
    my $c=<$fh>;
    close($fh) or die "can not close $f";
    return $c;
}

sub convfile($$$)
{
    my($infile,$outfile,$lskip)=@_;
    print{*STDERR} "Converting $infile to $outfile ";
    my $ifh=new FileHandle();
    open($ifh,"<$infile") or die "can not open $infile";
    my $ofh=new FileHandle();
    open($ofh,">$outfile") or die "can not open $outfile";
    my $n=0;
    my $s={};
    while(<$ifh>)
    {
	chomp;
	$n++;
	my $y=substr($_,0,-$lskip);
	if($y!~m@\?$@)
	{
	    if($y=~m@^\|@is)
	    {
		print{$ofh} $y,"\n";	
	    }
	    else
	    {
		my($cns)=$y=~m@,(\d)$@is;
		if(!defined($cns))
		{
		    die "Invalid line $n in $infile";
		}
		my $v=$s->{$cns};
		if(!defined($v))
		{
		    $v=0;
		}
		$s->{$cns}=++$v;
		print{$ofh} $y,"\n";
	    }
	}
    }
    close($ifh);
    close($ofh);
    print{*STDERR} "DONE OK\n";
    return $s;
}


my $names_file=$ARGV[0];
my $cmdtorun=$ARGV[1];
my $content=readFromFile($names_file);
my ($cnsq)=$content=~m@\|_consequent_class_all=([^\r\n]*)@im;
my ($fstem)=$content=~m@\|_filestem=([^\r\n]*)@im;

if(!defined($cnsq) || !defined($fstem))
{
    die "No _consequent_class_all or _filestem found";
}

if($names_file=~m@/@)
{
    my $fprefix=$names_file;
    $fprefix=~s@/[^/]*$@@;
    $fstem=$fprefix.'/'.$fstem;
}

my @cns=split(/[\s,]/,$cnsq);
my @lines=split(/[\r\n]/,$content);

foreach my $c (@cns)
{
    my $fh=new FileHandle();
    my $fstem2=$fstem.'_'.$c;
    my $fstemnamesfile=$fstem2.".names";
    print{*STDERR} "Creating NAMES $fstemnamesfile ";
    open($fh,">$fstemnamesfile") or die "can not open $fstemnamesfile";
    my $test_skip=1;
    my $nskipped=0;
    my $r='';
    foreach my $l (@lines)
    {
	if($test_skip)
	{
	    if(0==index($l,$c.':'))
	    {
		$test_skip=0;
		my($x,$xx)= $l=~m@^(.*?:\s*ignore\s*\|\s*):(.*)@is;
		
		$r="\| $c CLASS VARIABLE\n".$xx."\n\n\n".$r;
		$r.='| ';
	    }
	}
	else
        {
	    $r.='| ';
	    if($l=~m@^[^\|]+:@)
	    {
		$nskipped++;
	    }
	}
	$r.=$l;
	$r.="\n";
    }
    print{$fh} $r;
    close($fh);
    print{*STDERR} "DONE \n";       
    
    # do not use regexp as slow
    my $lskip=length("EOL")+1+2*($nskipped-1);
    my $s=convfile($fstem.".data",$fstem2.".data",$lskip);
    my $m=-1;
    foreach my $v (values %$s)
    {
	#print{*STDERR} "V=$v\n";
	if($m<0 || $v<$m)
	{
	    $m=$v;
	}
    }
    #print{*STDERR} "M=$m\n";
    $m=int($m/20); #  min fraction 
    if($m<5)
    {
	$m=5;
    }
    #print{*STDERR} "M=$m\n";
    if(-r $fstem.".test")
    {
	convfile($fstem.".test",$fstem2.".test",$lskip);	
    }

    $fh=new FileHandle();
    open($fh,">$fstem2.costs") or die "can not open $fstem2.costs";
    print{$fh}"0,0 : 0\n";
    print{$fh}"1,0 : 1.3\n";
    print{$fh}"0,0 : 0\n";
    print{$fh}"0,1 : 1\n";
    close($fh);
    

    #print{*STDERR} "M=$m\n";
    system($cmdtorun." -m $m -f $fstem2  ");
    #system($cmdtorun." -f $fstem2  ");

    unlink($fstem2.".data");
    unlink($fstemnamesfile);
    unlink($fstem2.".test");
    unlink($fstem2.".cost");
}




