package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */

import com.polytechnik.utils.UnitTests;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: AQVMLegendreShifted.java,v 1.5 2019/01/06 23:50:30 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class AQVMLegendreShifted extends AQVM {

private final DeprecatedHelperLegendreShiftedBasis odata;
private final DeprecatedHelperLegendreShiftedBasis [] idata;
AQVMLegendreShifted(final DeprecatedHelperLegendreShiftedBasis obasis,final DeprecatedHelperLegendreShiftedBasis [] ibasis)
{
    super(obasis,ibasis);
    this.odata=obasis;
    this.idata=ibasis;
}

public static AQVMLegendreShifted calculate(final int neq_t,
					    final int neq_i,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final Trade [][] itb,
					    final int [] itbsize,
					    final AQVMLegendreShifted ref)
{
    final int npm=3;
    final DeprecatedHelperLegendreShiftedBasis o=
	DeprecatedHelperLegendreShiftedBasis.calculateBasis(neq_t,
					    npm,
					    currenttime,
					    tau,
					    tb,
					    tsize,
					    ref!=null?ref.odata:null);
    final DeprecatedHelperLegendreShiftedBasis [] i=new DeprecatedHelperLegendreShiftedBasis [neq_i];
    for(int k=0;k<neq_i;k++)
    {
	i[k]=DeprecatedHelperLegendreShiftedBasis.calculateBasis(neq_t,
						 npm,
						 currenttime,
						 tau,
						 itb[k],
						 itbsize[k],
						 ref!=null?ref.idata[k]:null);
    }
    return new AQVMLegendreShifted(o,i);
}


public static void main(String [] args)
{
    new AQVMTest("AQVMLegendreShifted:",1e-6,1e-3){
	AQVMLegendreShifted getAQVM(final int tsize,final int ntm,final int neq_i,final java.util.Random r)
	{
	    final Trade [] o_tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
	    long currenttime=o_tb[o_tb.length-1].time+1000;
	    final long tau=(o_tb[o_tb.length-1].time-o_tb[0].time)/3;
	    final Trade [][] i_tb=new Trade [neq_i][];
	    final int [] i_tb_size=new int [neq_i];
	    for(int i=0;i<neq_i;i++)
	    {
		final Trade [] tb=i_tb[i]=CalculateKendall.TradeEMoments.getRandomTrades(tsize+r.nextInt(tsize+1),r);
		i_tb_size[i]=tb.length;
		if(currenttime<tb[tb.length-1].time)
		{
		    currenttime=tb[tb.length-1].time;
		}
	    }
	    return calculate(ntm,neq_i,currenttime,tau,o_tb,tsize,i_tb,i_tb_size,null);
	}}.runTests();
}

}
