package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

public class BkQVMLaguerre extends BkQVM<QVMDataL> {

BkQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}

public static BkQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final BkQVMLaguerre ref)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new BkQVMLaguerre(neq,o);
}
DeprecatedHelperQVMDataLDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataLDirectAccessWithBasis();}
double getX0(){return 0;}

double [] getEDPsi(final double [] psi){return WIntegratorLaguerre.getEDPsi(psi);}


static class BkQVMLaguerreTest extends BkQVMTest<QVMDataL> {
BkQVMLaguerreTest(final String name)
{
    super(name,new java.util.Random(-1872L),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLaguerre.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
BkQVMLaguerre getBkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DkQVMLaguerre getDkQVM(){return DkQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class BkQVMLaguerreTest

public static void main(String [] args)
{
    new BkQVMLaguerreTest("BkQVMLaguerre").runTests(7);
} // END main



} // END OF class BkQVMLaguerre
