package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

public class BkQVMLegendreShifted extends BkQVM<QVMDataP> {
BkQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static BkQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final BkQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new BkQVMLegendreShifted(neq,o);
}
DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
double getX0(){return 1;}

double [] getEDPsi(final double [] psi){return WIntegratorLegendreShifted.getEDPsi(psi);}


static class BkQVMLegendreShiftedTest extends BkQVMTest<QVMDataP> {
BkQVMLegendreShiftedTest(final String name)
{
    super(name,new java.util.Random(-6891L),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
BkQVMLegendreShifted getBkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DkQVMLegendreShifted getDkQVM(){return DkQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class BkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new BkQVMLegendreShiftedTest("BkQVMLegendreShifted").runTests(7);
} // END main



} // END OF class BkQVMLegendreShifted
