package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

public class BkQVMMonomials extends BkQVM<QVMData> {

BkQVMMonomials(final int neq,final QVMData odata){super(neq,odata);}

public static BkQVMMonomials calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final BkQVMMonomials ref)
{
    final int nvm=1,npm=3;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     2*neq-1,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new BkQVMMonomials(neq,o);
}
DeprecatedHelperQVMDataDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataDirectAccessWithBasis();}
double getX0(){return 0;}

double [] getEDPsi(final double [] psi){return WIntegratorMonomials.getEDPsi(psi);}


static class BkQVMMonomialsTest extends BkQVMTest<QVMData> {
BkQVMMonomialsTest(final String name)
{
    super(name,new java.util.Random(-1872L),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
BkQVMMonomials getBkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DkQVMLaguerre getDkQVM(){return DkQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class BkQVMMonomialsTest

public static void main(String [] args)
{
    new BkQVMMonomialsTest("BkQVMMonomials").runTests(5);
} // END main


} // END OF class BkQVMMonomials
