package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.realtimebook.*;

public class CQVMLegendreShifted extends CQVM<QVMDataP> {

CQVMLegendreShifted(final int neq,final QVMDataP [] odata){super(neq,odata);}

public static CQVMLegendreShifted calculate(final int neq_t,
					    final int neq_i,
					    final long currenttime,
					    final long tau,
					    final Trade [][] tba,
					    final int [] tbasize,
					    final CQVMLegendreShifted ref)
{
    if(ref!=null && ref.odata.length!=neq_i)
	throw new RuntimeException("Dimension mismatch: neq_i="+neq_i+" ref.odata.length="+ref.odata.length);
    final int npm=3;
    final QVMDataP [] o=new QVMDataP [neq_i];
    for(int k=0;k<neq_i;k++)
    {
	o[k]=QVMDataP.calculateQVMDataP(2*neq_t-1,
					npm,
					currenttime,
					tau,
					tba[k],
					tbasize[k],
					ref!=null?ref.odata[k]:null);
    }
    return new CQVMLegendreShifted(neq_t,o);
}

DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
double getX0(){return 1;}


static class CQVMLegendreShiftedTest extends CQVMTest<QVMDataP> {
CQVMLegendreShiftedTest(final String name)
{
    super(name,new java.util.Random(6870L),1e-4);
}
long getTau(final Trade [] tb)
{
    return ((tb[tb.length-1].time-tb[0].time)/2)/(9*5*7*8)*(9*5*7*8);
}

CQVMLegendreShifted getCQVM(){return calculate(neq,tba.length,currenttime,tau,tba,tba_size,null);}
CQVMLegendreShifted getCQVM1(){return calculate(neq,1,currenttime,tau,tba,tba_size,null);}
BQVMLegendreShifted getBQVM(final int ni){return BQVMLegendreShifted.calculate(neq,currenttime,tau,tba[ni],tba_size[ni],null);}

} // END of class CQVMLegendreShiftedTest

public static void main(String [] args)
{
    new CQVMLegendreShiftedTest("CQVMLegendreShifted").runTests(5,7);
} // END main



} // END OF class CQVMLegendreShifted
