package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2010
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.realtimebook.*;


/** Liquidity deficit v16.
 *  @version $Id: CalculateLiquidityDeficit16.java,v 1.102 2018/07/02 23:10:58 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class CalculateLiquidityDeficit16 {

    private final Distribution<Trade> trades;
    private final com.polytechnik.utils.PolynomialRootsFinder rf=
	//new com.polytechnik.algorithms.PolynomialRootsCompanionMatrix(2*N_EM-1);
	new com.polytechnik.utils.PolynomialRootsJenkinsTraubORIG();
	// null;

    CalculateLiquidityDeficit16(final Distribution<Trade> trades)
    {
	this.trades=trades;
    }


    /** Results container.
     */
    static class VQ {
	final long currenttime,tau;
	final CalculateKendall.QATradeIP qatip;
	final QVM.QVMAverage atip;
	final QVM.QVMVT vt;
	final QVM.QVMVTMU mmu;
	final QVML qvml;
	final QVMLL qvmll;
	final QVMPP qvmpp;
	final QVMpi qvmpi;
	final QVMLMV qvmlmv;
	final QVMPMV qvmpmv;
	final QVMDLaguerre qvmdll,qvmdllbs;
	final QVMDLegendreShifted qvmdpp,qvmdppbs;
	final AQVMLaguerre aqvmll;
	final AQVMLegendreShifted aqvmpp;
	final EQVMLaguerre eqvmll;
	final EQVMLegendreShifted eqvmpp;
	final IQVMLaguerre iqvmll;
	final IQVMLegendreShifted iqvmpp;
	final RQVMLaguerre rqvmll;
	final RQVMLegendreShifted rqvmpp;
	final SQVMLaguerre sqvmll;
	final SQVMLegendreShifted sqvmpp;
	final KQVMLaguerre kqvmll;
	final KQVMLegendreShifted kqvmpp;

	final LQVMLaguerre lqvml;
	final LQVMLegendreShifted lqvmp;
	final RadauLQVMLaguerre rlqvml;
	final RadauLQVMLegendreShifted rlqvmp;

	final MQVMLaguerre mqvmll;
	final MQVMLegendreShifted mqvmpp;

	final NQVMLaguerre nqvmll;
	final NQVMLegendreShifted nqvmpp;

	final OQVMLaguerre oqvmll;
	final OQVMLegendreShifted oqvmpp;

	final QQVMLaguerre qqvmll;
	final QQVMLegendreShifted qqvmpp;

	final UQVMLaguerre uqvmll;
	final UQVMLegendreShifted uqvmpp;

	final VQVMLaguerre vqvmll;
	final VQVMLegendreShifted vqvmpp;

	final WQVMLaguerre wqvmll;
	final WQVMLegendreShifted wqvmpp;

	final XQVMLaguerre xqvmll;
	final XQVMLegendreShifted xqvmpp;
	VQ(final long currenttime,
	   final long tau,
	   final CalculateKendall.QATradeIP qatip,
	   final QVM.QVMAverage atip,
	   final QVM.QVMVT vt,
	   final QVM.QVMVTMU mmu,
	   final QVML qvml,
	   final QVMLL qvmll,
	   final QVMPP qvmpp,
	   final QVMpi qvmpi,
	   final QVMLMV qvmlmv,
	   final QVMPMV qvmpmv,
	   final QVMDLaguerre qvmdll,
	   final QVMDLaguerre qvmdllbs,
	   final QVMDLegendreShifted qvmdpp,
	   final QVMDLegendreShifted qvmdppbs,
	   final AQVMLaguerre aqvmll,
	   final AQVMLegendreShifted aqvmpp,
	   final EQVMLaguerre eqvmll,
	   final EQVMLegendreShifted eqvmpp,
	   final IQVMLaguerre iqvmll,
	   final IQVMLegendreShifted iqvmpp,
	   final RQVMLaguerre rqvmll,
	   final RQVMLegendreShifted rqvmpp,
	   final SQVMLaguerre sqvmll,
	   final SQVMLegendreShifted sqvmpp,
	   final KQVMLaguerre kqvmll,
	   final KQVMLegendreShifted kqvmpp,

	   final LQVMLaguerre lqvml,
	   final LQVMLegendreShifted lqvmp,
	   final RadauLQVMLaguerre rlqvml,
	   final RadauLQVMLegendreShifted rlqvmp,
	   final MQVMLaguerre mqvmll,
	   final MQVMLegendreShifted mqvmpp,

	   final NQVMLaguerre nqvmll,
	   final NQVMLegendreShifted nqvmpp,

	   final OQVMLaguerre oqvmll,
	   final OQVMLegendreShifted oqvmpp,

	   final QQVMLaguerre qqvmll,
	   final QQVMLegendreShifted qqvmpp,
	   final UQVMLaguerre uqvmll,
	   final UQVMLegendreShifted uqvmpp,
	   final VQVMLaguerre vqvmll,
	   final VQVMLegendreShifted vqvmpp,
	   final WQVMLaguerre wqvmll,
	   final WQVMLegendreShifted wqvmpp,
	   final XQVMLaguerre xqvmll,
	   final XQVMLegendreShifted xqvmpp)
	{
	    this.currenttime=currenttime;
	    this.tau=tau;
	    this.qatip=qatip;
	    this.atip=atip;
	    this.vt=vt;
	    this.mmu=mmu;
	    this.qvml=qvml;
	    this.qvmll=qvmll;
	    this.qvmpp=qvmpp;
	    this.qvmpi=qvmpi;
	    this.qvmlmv=qvmlmv;
	    this.qvmpmv=qvmpmv;
	    this.qvmdll=qvmdll;
	    this.qvmdllbs=qvmdllbs;
	    this.qvmdpp=qvmdpp;
	    this.qvmdppbs=qvmdppbs;
	    this.aqvmll=aqvmll;
	    this.aqvmpp=aqvmpp;
	    this.eqvmll=eqvmll;
	    this.eqvmpp=eqvmpp;
	    this.iqvmll=iqvmll;
	    this.iqvmpp=iqvmpp;
	    this.rqvmll=rqvmll;
	    this.rqvmpp=rqvmpp;
	    this.sqvmll=sqvmll;
	    this.sqvmpp=sqvmpp;
	    this.kqvmll=kqvmll;
	    this.kqvmpp=kqvmpp;

	    this.lqvml=lqvml;
	    this.lqvmp=lqvmp;
	    this.rlqvml=rlqvml;
	    this.rlqvmp=rlqvmp;
	    this.mqvmll=mqvmll;
	    this.mqvmpp=mqvmpp;
	    this.nqvmll=nqvmll;
	    this.nqvmpp=nqvmpp;
	    this.oqvmll=oqvmll;
	    this.oqvmpp=oqvmpp;
	    this.qqvmll=qqvmll;
	    this.qqvmpp=qqvmpp;
	    this.uqvmll=uqvmll;
	    this.uqvmpp=uqvmpp;
	    this.vqvmll=vqvmll;
	    this.vqvmpp=vqvmpp;
	    this.wqvmll=wqvmll;
	    this.wqvmpp=wqvmpp;
	    this.xqvmll=xqvmll;
	    this.xqvmpp=xqvmpp;
	}
    }
    VQ [] tdata=null;


    void clear()
    {
	this.tdata=null;
    }

    static final int NT=9,NP=3,N_EV=0,N_ET=0,N_EM=3;
    void calculateLiquidityDeficitRecurrent(final long [] delays,
					    final long currenttime,
					    final long trades_cleared_before,
					    final VQ [] prev)
    {
	final int nt=delays.length;
	final boolean PRINT_DATA_DEBUG=false;


	if(PRINT_DATA_DEBUG)
	{
	    System.err.println("=="+getClass().getName()+
			       "============Liquidity Deficit t=\t"+currenttime+
			       "\tN TRADES=\t"+this.trades.getSize()+
			       "\tnt\t"+nt);
	}

	this.tdata=new VQ [nt];
	for(int i=0;i<nt;i++)
	{
	    final VQ amprev=prev!=null?prev[i]:null;
	    final long tau=delays[i];
	    this.tdata[i]=new VQ(currenttime,
				 tau,
				 CalculateKendall.QATradeIP.calculateQATradeIP(
				     NP-1,
				     currenttime,
				     tau,
				     this.trades.getBuffer(),
				     this.trades.getSize(),
				     this.rf,
				     amprev!=null?amprev.qatip:null),
				 QVM.QVMAverage.calculateQVMAverage(N_EV,
								    N_ET,
								    N_EM,
								    currenttime,
								    tau,
								    this.trades.getBuffer(),
								    this.trades.getSize(),
								    this.rf,
								    amprev!=null?amprev.atip:null),
				 QVM.QVMVT.calculateQVMVT(N_EM,
							  currenttime,
							  tau,
							  this.trades.getBuffer(),
							  this.trades.getSize(),
							  this.rf,
							  amprev!=null?amprev.vt:null),
				 QVM.QVMVTMU.calculateQVMVTMU(currenttime,
							      N_EM,
							      tau,
							      this.trades.getBuffer(),
							      this.trades.getSize(),
							      this.rf,
							      amprev!=null?amprev.mmu:null),
				 QVML.calculateQVML(NT,
						    currenttime,
						    tau,
						    this.trades.getBuffer(),
						    this.trades.getSize(),
						    this.rf,
						    amprev!=null?amprev.qvml:null),
				 QVMLL.calculateQVMLL(NT,
						      currenttime,
						      tau,
						      this.trades.getBuffer(),
						      this.trades.getSize(),
						      amprev!=null?amprev.qvmll:null,
						      rf),
				 QVMPP.calculateQVMPP(NT,
						      currenttime,
						      tau, // back to tau // minimal time scale would be tau for neq_t=NT
						      this.trades.getBuffer(),
						      this.trades.getSize(),
						      amprev!=null?amprev.qvmpp:null,
						      rf),
				 QVMpi.calculateQVMpi(NT, // use NT as NP
						      currenttime,
						      tau,
						      this.trades.getBuffer(),
						      this.trades.getSize(),
						      this.rf,
						      amprev!=null?amprev.qvmpi:null),
				 QVMLMV.calculateQVMLMV(NT,0,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							null,null,
							amprev!=null?amprev.qvmlmv:null),
				 QVMPMV.calculateQVMPMV(NT,0,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							null,null,
							amprev!=null?amprev.qvmpmv:null),
				 QVMDLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.qvmdll:null),
				 QVMDLaguerre.calculateBS(NT,
							  currenttime,
							  tau,
							  this.trades.getBuffer(),
							  this.trades.getSize(),
							  amprev!=null?amprev.qvmdllbs:null),
				 QVMDLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.qvmdpp:null),
				 QVMDLegendreShifted.calculateBS(NT,
								 currenttime,
								 tau,
								 this.trades.getBuffer(),
								 this.trades.getSize(),
								 amprev!=null?amprev.qvmdppbs:null),
				 AQVMLaguerre.calculate(NT,
							0,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							null,
							null,
							amprev!=null?amprev.aqvmll:null),
				 AQVMLegendreShifted.calculate(NT,
							       0,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       null,
							       null,
							       amprev!=null?amprev.aqvmpp:null),
				 EQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.eqvmll:null),
				 EQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.eqvmpp:null),
				 IQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.iqvmll:null,
							IQVMLaguerre.default_MT),
				 IQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.iqvmpp:null,
							       IQVMLegendreShifted.default_MT),
				 RQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.rqvmll:null),
				 RQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.rqvmpp:null),
				 SQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.sqvmll:null),
				 SQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.sqvmpp:null),
				 KQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.kqvmll:null),
				 KQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.kqvmpp:null),
				 LQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.lqvml:null),
				 LQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.lqvmp:null),
				 RadauLQVMLaguerre.calculate(NT,
							     currenttime,
							     tau,
							     this.trades.getBuffer(),
							     this.trades.getSize(),
							     amprev!=null?amprev.rlqvml:null),
				 RadauLQVMLegendreShifted.calculate(NT,
								    currenttime,
								    tau,
								    this.trades.getBuffer(),
								    this.trades.getSize(),
								    amprev!=null?amprev.rlqvmp:null),
				 MQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.mqvmll:null),
				 MQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.mqvmpp:null),
				 NQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.nqvmll:null),
				 NQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.nqvmpp:null),
				 OQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.oqvmll:null),
				 OQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.oqvmpp:null),
				 QQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.qqvmll:null),
				 QQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.qqvmpp:null),
				 UQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.uqvmll:null),
				 UQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.uqvmpp:null),
				 VQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.vqvmll:null),
				 VQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.vqvmpp:null),
				 WQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.wqvmll:null),
				 WQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.wqvmpp:null),
				 XQVMLaguerre.calculate(NT,
							currenttime,
							tau,
							this.trades.getBuffer(),
							this.trades.getSize(),
							amprev!=null?amprev.xqvmll:null),
				 XQVMLegendreShifted.calculate(NT,
							       currenttime,
							       tau,
							       this.trades.getBuffer(),
							       this.trades.getSize(),
							       amprev!=null?amprev.xqvmpp:null));
	}
    }
}

