package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** A class to store past calculations.
 *  @version $Id: CalculationData.java,v 1.136 2012/09/23 14:01:07 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class CalculationData extends CalculationDataRef {


    private static final boolean DEBUG_PRINT_DATA=false;

    /** Book volume on current price level.
     */
    final long t_trades_cleared_before;

    final TradeOpportunityChecker topp;

    final ModelParameters.ModelParametersData modelparametersdata;



    private final long [] tau_embedding;

    CalculationData(final long id,
		    final long time,
		    final double p_buy,
		    final double p_sell,
		    final double p_last,
		    final long vol_p_buy,
		    final long vol_p_sell,
		    final long t_trades_cleared_before,

		    final TradeOpportunityChecker topp,
		    final ModelParameters.ModelParametersData modelparametersdata,

		    final long [] tau_embedding)
    {
	super(id,time,p_buy,p_sell,p_last,vol_p_buy,vol_p_sell);
	this.t_trades_cleared_before=t_trades_cleared_before;
	this.topp=topp;

	this.modelparametersdata=modelparametersdata;
	this.tau_embedding=tau_embedding;


	if(DEBUG_PRINT_DATA)
	{
	    System.err.println("====CalculationData time="+getTime());
	    System.err.println("p_buy="+this.p_buy+" p_sell="+this.p_sell);
	    System.err.println("v_buy\tv_sell\tns_buy\tns_sell");
	    final CalculateBookVolumePriceThreshold bbuy=this.topp.calculate_buy_thresholds,bsell=this.topp.calculate_sell_thresholds;
	    for(int i=0;i<bbuy.out_shares.length;i++)
	    {
		System.err.print(bbuy.out_shares[i]+"\t");
		System.err.print(bsell.out_shares[i]+"\t");
	    }
	    System.err.println("tall_buy\tall_sell\tview_v_buy\tview_v_sell\tmin\tmax");
	    final CalculateTradeVolume tvc=this.topp.tradevolumecalculator;
	    for(int i=0;i<tvc.v_hiddentrades_buy_tau.length;i++)
	    {
		System.err.print(tvc.v_alltrades_buy_tau[i]+"\t");
		System.err.println(tvc.v_alltrades_sell_tau[i]+"\t");
		System.err.print(tvc.v_hiddentrades_buy_tau[i]+"\t");
		System.err.print(tvc.v_hiddentrades_sell_tau[i]+"\t");
		System.err.print(tvc.minprice[i]+"\t");
		System.err.print(tvc.maxprice[i]+"\t");
	    }
	}
    }


    long [] getTaus()
    {
	return this.tau_embedding;
    }

}
