package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** A class to store past calculations.
 *  @version $Id: CalculationDataRef.java,v 1.6 2012/09/23 14:01:08 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class CalculationDataRef implements com.polytechnik.utils.CircularList.TimeAccess {

    private final long time;
    final long id;
    final long vol_p_buy,vol_p_sell;
    final double p_buy,p_sell,p_last;

    CalculationDataRef(
	final long id,
	final long time,
	final double p_buy,
	final double p_sell,
	final double p_last,
	final long vol_p_buy,
	final long vol_p_sell)

    {
	this.id=id;
	this.time=time;
	this.p_buy=p_buy;
	this.p_sell=p_sell;
	this.p_last=p_last;
	this.vol_p_buy=vol_p_buy;
	this.vol_p_sell=vol_p_sell;
	if(this.id<0)
	{
	    throw new RuntimeException("Invalid ID="+this.id);
	}

    }
    public long getTime()
    {
	return this.time;
    }

}
