package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

public class CiQVMLegendreShifted extends CiQVM<QVMDataP> {

CiQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static CiQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final CiQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new CiQVMLegendreShifted(neq,o);
}
DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
double getX0(){return 1;}

static class CiQVMLegendreShiftedTest extends CiQVMTest<QVMDataP> {
CiQVMLegendreShiftedTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
CiQVMLegendreShifted getCiQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
BQVMLegendreShifted getBQVM(){return BQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}
QVMData [] getPData(final int nmoms)
{
    final QVMData [] qdata=new QVMData [nmoms];
    for(int k=0;k<nmoms;k++)
    {
	final long t=tau/(1+k);
	if(t*(1+k)!=tau) throw new RuntimeException("t*(1+k)="+(t*(1+k))+" tau="+tau+" (1+k)="+(1+k));
	qdata[k]=QVMData.calculateQVMData(2,1+r.nextInt(3),4+r.nextInt(3),currenttime,t,tb,tb.length,null);
    }
    return qdata;
}
double [] getDFCoefsPolynomials(final double [] coefs)
{
    final double [] dcoefs=Polynomials.getPolynomialDifferentiated(coefs),xD=Polynomials.getxP(dcoefs);
    TMatr.sumP1(xD,coefs,1);
    return xD;
}
int setDFMomentsPolynomails(final double [] dFmoments,final double [] Fmoments,final int n)
{
    for(int k=0;k<n;k++){dFmoments[k]=(k+1)*Fmoments[k];}
    return n;
}
double [][] getMonomialMoments(final QVMDataP odata)
{
    final int nmoms=2*neq-1;
    final QVMData [] qd=getPData(nmoms);
    final double [] mv=new double [nmoms],
	imoms=MQVMLegendreShifted.MQVMLegendreShiftedTest.getMonomialMoments(nmoms,qd,0,QVMData.MOM_dV,false,odata.p_offset),
	dpmoms=MQVMLegendreShifted.MQVMLegendreShiftedTest.getMonomialMoments(nmoms,qd,1,QVMData.MOM_DP,false,odata.p_offset);
    return new double [][]{
	MQVMLegendreShifted.MQVMLegendreShiftedTest.getMonomialMomT(nmoms),
	imoms,
	dpmoms,
	MQVMLegendreShifted.MQVMLegendreShiftedTest.getMonomialMoments(nmoms,qd,0,QVMData.MOM_VS,false,odata.p_offset)
    };
}

} // END of class CiQVMLegendreShiftedTest

public static void main(String [] args)
{
    new CiQVMLegendreShiftedTest("CiQVMLegendreShifted").runTests(5);
} // END main



} // END OF class CiQVMLegendreShifted
