package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** An interface to classification predictor.
 *  @version $Id: ClassificationPredictor.java,v 1.23 2009/04/10 07:40:53 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public abstract class ClassificationPredictor {

    static final boolean PRINT_DEBUG=true;


    static final int P_YES=1001,P_NO=1000,P_NA=-999;

    static class PredictionResults {
	final double confidence;
	final double pricelevel;
	final long tau;
	final int result;
	final String extra_description;
	final PrepareFilestems.ConsequentStat consequentstat;
	PredictionResults(final int result,
			  final double confidence,
			  final String extra_description,
			  final PrepareFilestems.ConsequentStat consequentstat,
			  final long tau,
			  final double pricelevel)
	{
	    this.result=result;
	    this.confidence=confidence;
	    this.extra_description=extra_description;
	    this.consequentstat=consequentstat;
	    this.pricelevel=pricelevel;
	    this.tau=tau;
	}
	final String getDesctiption()
	{

	    return this.consequentstat.getDesctiption()+
		" tau="+this.tau+
		" confidence="+this.confidence+
		" result="+this.result+
		" pricelevel="+this.pricelevel+
		(this.extra_description!=null?"edescr="+this.extra_description:"");
	}
    }

    static interface GetRefPrice {
	double getPriceLevel(final CalculationData cd,final double level);
    }


    final long tau;

    ClassificationPredictor(final long tau)
    {

	this.tau=tau;
    }



    public abstract PredictionResults getPrediction(final String [] sattribs,
						    final double [] datribs,
						    final int [] nattribs,
						    final CalculationData cd);
}
