package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** A predictor for several time scales.
 *  @version $Id: ClassificationPredictorMultiScale.java,v 1.24 2009/01/26 12:58:42 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class ClassificationPredictorMultiScale {


    private final ClassificationPredictorC5 [] predictors;

    ClassificationPredictorMultiScale(final String pname,
				      final StatusData sd,
				      final String [] string_attribs,
				      final String [] double_attribs,
				      final String [] nominal_attribs,
				      ClassificationPredictor.GetRefPrice getrefprice)
    {
	final long [] tau=sd.mparametersdata.tau_embedding_consequent;
	this.predictors=new ClassificationPredictorC5 [tau.length];
	for(int i=0;i<this.predictors.length;i++)
	{
	    this.predictors[i]=new ClassificationPredictorC5(sd,
							     tau[i],
							     pname,
							     string_attribs,
							     double_attribs,
							     nominal_attribs,
							     getrefprice);
	}
    }



    ClassificationPredictor.PredictionResults [] getMultiPredictions(
	final String [] sattribs,
	final double [] datribs,
	final int [] nattribs,
	final CalculationData cd)
    {
	final ClassificationPredictor.PredictionResults [] i_p=
	    new ClassificationPredictor.PredictionResults [this.predictors.length];

	for(int i=0;i<i_p.length;i++)
	{
	    i_p[i]=this.predictors[i].getPrediction(sattribs,datribs,nattribs,cd);
	}
	return i_p;
    }
}
