package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.Laguerre;
import com.polytechnik.utils.PolynomialRootsFinder;
import com.polytechnik.utils.PolynomialRootsConfederateMatrix;
import com.polytechnik.realtimebook.*;

public class DQVMLaguerre extends DQVM<QVMDataL> {

DQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}

public static DQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final DQVMLaguerre ref)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new DQVMLaguerre(neq,o);
}

DeprecatedHelperQVMDataLDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataLDirectAccessWithBasis();}
double getX0(){return 0;}
boolean isEdgeAtRight(){return false;}
public PolynomialRootsFinder getPolynomialRootsFinderInBasis()
{
    return PolynomialRootsConfederateMatrix.ABASISLAGUERRE;
}

static class DQVMLaguerreTest extends DQVMTest<QVMDataL> {
DQVMLaguerreTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
DQVM<?> getDQVMbasis(){return null;}
DQVMLaguerre getDQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DjQVMLaguerre getDjQVM(){return DjQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class DQVMLaguerreTest

public static void main(String [] args)
{
    new DQVMLaguerreTest("DQVMLaguerre").runTests(5);
} // END main



} // END OF class DQVMLaguerre
