package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.utils.PolynomialRootsFinder;
import com.polytechnik.utils.PolynomialRootsConfederateMatrix;
import com.polytechnik.realtimebook.*;

public class DQVMLegendreShifted extends DQVM<QVMDataP> {

DQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static DQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final DQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new DQVMLegendreShifted(neq,o);
}

DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
double getX0(){return 1;}
boolean isEdgeAtRight(){return true;}
public PolynomialRootsFinder getPolynomialRootsFinderInBasis()
{
    return PolynomialRootsConfederateMatrix.ABASISLEGENDRESHIFTED;
}

static class DQVMLegendreShiftedTest extends DQVMTest<QVMDataP> {
DQVMLegendreShiftedTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
DQVM<?> getDQVMbasis(){return null;}
DQVMLegendreShifted getDQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DjQVMLegendreShifted getDjQVM(){return DjQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class DQVMLegendreShiftedTest

public static void main(String [] args)
{
    new DQVMLegendreShiftedTest("DQVMLegendreShifted").runTests(5);
} // END main



} // END OF class DQVMLegendreShifted
