package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2022
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;
import com.polytechnik.utils.EVXData;
/**
 * da/dv is back.
 * @see com.polytechnik.freemoney.FreeMoneyForAll
 * @version $Id: DaDv.java,v 1.3 2022/09/10 01:58:22 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
*/
public class DaDv {
    public final EVXData I;

    public final double pv_L,Tv_L,pa_L;
    public final double pv_H,Tv_H,pa_H;

    DaDv(final int n,
	 final double p_offset,
	 final double p_last,

	 // input moment matrices
	 final double [] QQt,
	 final double [] QQv,
	 final double [] QQTv,

	 final double [] QQi,
	 final double [] QQpi,
	 final double [] QQa,
	 final double [] QQpa,

	  // basis operations
	 final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M,
	 // for unit test
	 final double eps){

	this.I=EVXData.getEVXDataFromQQ(n,QQa,QQi,M);
	final int iL=0,iH=n-1;
	pv_L=p_offset+I.getFPsi(iL,QQpi)/I.getFPsi(iL,QQi);
	Tv_L=I.getFPsi(iL,QQTv)/I.getFPsi(iL,QQv);
	pa_L=p_offset+I.getFPsi(iL,QQpa)/I.getFPsi(iL,QQa);

	pv_H=p_offset+I.getFPsi(iH,QQpi)/I.getFPsi(iH,QQi);
	Tv_H=I.getFPsi(iH,QQTv)/I.getFPsi(iH,QQv);
	pa_H=p_offset+I.getFPsi(iH,QQpa)/I.getFPsi(iH,QQa);
    }
}
