package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */

/** An interface to analyze data by external programs.
 *  @version $Id: DataAnalyzable.java,v 1.7 2008/11/11 20:30:50 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public interface DataAnalyzable {


    void setTicker(final String ticker,
		   final CalculateAntecedents calc_antecedents,
		   final CalculateConsequents calc_consequents,
		   final StatusData sd);


    int printAntecedents(final long record_id,
			 final String ticker,
			 final CalculateAntecedents calc_antecedents);

    int printConsequents(final long record_id,
			 final String ticker,
			 final CalculateConsequents calc_consequents);
}
