package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */

/** Calculate dF and \int F moments.
 *  @version $Id: DataInterfaceFDFMoments.java,v 1.3 2022/07/29 20:46:42 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public interface DataInterfaceFDFMoments {
/** Calculates V moments from dV moments using integration by parsts.
 * @see com.polytechnik.freemoney.CommonBasisOperations#getFMomentsFromDF
 */
int setFMoments(final double [] Vmoments,final double [] dVmoments,final int n);

/** Calculates dF from F using integration by parsts.
 *  F(x0) is assumed to be 0.
 *  @see com.polytechnik.utils.VolMatrix#getDiffMatrix
 */
int setDFMoments(final double [] dFmoments,final double [] Fmoments,final int n);

}
