package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.TMatr;

/** One more interface to a basis.
 *  @version $Id: DeprecatedHelperBWrapperDataDirectAccessWithBasis.java,v 1.6 2022/07/28 12:27:15 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class DeprecatedHelperBWrapperDataDirectAccessWithBasis<DTYPE> extends DeprecatedHelperDataDirectAccessWithBasis<DTYPE> {


public void setM(final double [] m,final int n,final int mom,final DTYPE odata,final int nmoms_tosave)
{
    throw new RuntimeException();
}
public void setMT(final double [] m,final int nmoms)
{
    throw new RuntimeException();
}


private final DeprecatedHelperDataDirectAccessWithBasis<DTYPE> access;
private final double [][] basis;

DeprecatedHelperBWrapperDataDirectAccessWithBasis(final DeprecatedHelperDataDirectAccessWithBasis<DTYPE> access,
				  final double [][] basis)
{
    super(null);
    this.access=access;
    this.basis=basis;
}

public double fx(final double [] m,final double x)
{
    double s=0;
    for(int k=m.length;--k>=0;) s+=m[k]*access.fx(basis[k],x);
    return s;
}
public double Dfx(final double [] m,final double x)
{
   double s=0;
   for(int k=m.length;--k>=0;) s+=m[k]*access.Dfx(basis[k],x);
   return s;
}
public double D2fx(final double [] m,final double x)
{
    double s=0;
    for(int k=m.length;--k>=0;) s+=m[k]*access.D2fx(basis[k],x);
    return s;
}
public int setQQCoefs(final int q,final int r,final double [] res)
{
    final double [] basisq=basis[q],basisr=basis[r];
    final int n1=basisq.length,n2=basisr.length,n=n1+n2-1;
    for(int k=n;--k>=0;) res[k]=0;
    final double [] tmp=new double [n];
    for(int k=n1;--k>=0;)
    {
	final double c1=basisq[k];
	for(int l=n2;--l>=0;)
	{
	    final double b=c1*basisr[l];
	    if(b==0) continue; // optimization
	    final int na=access.setQQCoefs(k,l,tmp);
	    DeprecatedHelperTMatr.sumP1(res,tmp,na,b);
	}
    }
    return n;
}


/** Calculates V moments from dV moments using integration by parsts.
 */
public int setFMoments(final double [] Vmoments,final double [] dVmoments,final int n)
{
    throw new RuntimeException();
}

/** Calculates dF from F using integration by parsts.
 *  F(x0) is assumed to be 0.
 */
public int setDFMoments(final double [] dFmoments,final double [] Fmoments,final int n)
{
    throw new RuntimeException();
}

}
