package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.EVXData;

/** One more interface to a basis.
 *  ALL CODE IS OBSOLETE. Used only by old code now transferred to unit tests.
 *  @version $Id: DeprecatedHelperDataDirectAccessWithBasis.java,v 1.29 2022/07/28 12:27:15 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
@Deprecated
public abstract class DeprecatedHelperDataDirectAccessWithBasis<DTYPE> implements DataInterfaceDirectTradesHistorical {

private final DataInterfaceToMoments<DTYPE> a;

public DeprecatedHelperDataDirectAccessWithBasis(final DataInterfaceToMoments<DTYPE> a){this.a=a;}

public void setM(final double [] m,final int n,final int mom,final DTYPE odata,final int neq_t){a.setM(m,n,mom,odata,neq_t);}
public void setMT(final double [] m,final int nmoms){a.setMT(m,nmoms);}
public int setFMoments(final double [] Vmoments,final double [] dVmoments,final int nmoms){return a.setFMoments(Vmoments,dVmoments,nmoms);}
public int setDFMoments(final double [] dFmoments,final double [] Fmoments,final int nmoms){return a.setDFMoments(dFmoments,Fmoments,nmoms);}

public abstract double fx(final double [] m,final double x);
public abstract double Dfx(final double [] m,final double x);
public abstract double D2fx(final double [] m,final double x);
public abstract int setQQCoefs(final int l,final int m,final double [] coefs);

/** Calculates {@literal <Q_i|Q_j>} matrices from {@literal <Q_k>} moments.
 */
public double [][] getQQ_Matrs(final int n,final double scale,final double [][] moms)
{
    final double [][] r=new double [moms.length][n*n];
    final double [] tmp=new double [2*n-1];
    for(int k=0;k<n;k++)
    {
	final int ok=n*k;
	for(int l=0;l<=k;l++)
	{
	    final int ne=setQQCoefs(l,k,tmp);
	    for(int j=r.length,kl=ok+l,lk=n*l+k;--j>=0;)
	    {
		r[j][kl]=r[j][lk]=TMatr.mulVVn(ne,tmp,moms[j])/scale;
	    }
	}
    }
    //  <Q_i|Q_j> are now generated for all moms
    return r;
}
/** Calculates polynomials Q_i(x) QQ_ij Q_j(x).
 */
public double [][] getKK(final int n,final double [][] qq)
{
    final double [][] r=new double [qq.length][2*n-1];
    final double [] tmp=new double [2*n-1];
    for(int k=0;k<n;k++)
    {
	for(int l=0;l<n;l++)
	{
	    final int ne=setQQCoefs(l,k,tmp);
	    for(int j=r.length,kl=k*n+l;--j>=0;)
	    {
		DeprecatedHelperTMatr.sumP1(r[j],tmp,ne,qq[j][kl]);
	    }
	}
    }
    // Q(x)<QQ>_mu Q(x) is now formed
    return r;
}
/** Calculates polynomials Q_i(x) (QQ^{-1})_ij mom_j.
 *  Used for least squares approximation.
 */
public double [][] getLSQ(final int n,final double [] qq,final double [][] moms)
{
    final double [] QQ=new double [n*n];
    System.arraycopy(qq,0,QQ,0,n*n);
    final double [][] r=new double [moms.length][n];
    final int [] ipvt=new int [n];
    final int pinfo=com.polytechnik.utils.Linsystems.dgefa_m1(QQ,n,n,ipvt);
    if(pinfo!=0) {
	for(int k=r.length;--k>=0;){java.util.Arrays.fill(r[k],Double.NaN);}
	return r;
    }
    for(int k=r.length;--k>=0;){
	System.arraycopy(moms[k],0,r[k],0,n);
	com.polytechnik.utils.Linsystems.dgesl_m1(QQ,n,n,ipvt,r[k],1);
    }
    return r;
}
/** Calculates polynomial Q_i(x) (QQ^{-1})_ij Q_j(x0).
 */
double [] getOK(final int n,final double [] QQ,final double x0)
{
    return getLSQ(n,QQ,new double [][]{DeprecatedHelperEVXData.getX0Moms(n,this,x0)})[0];
}


}
