package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.Laguerre;

/** Legendre Polynomials basis.
 *  @version $Id: DeprecatedHelperQVMDataBLDirectAccessWithBasis.java,v 1.14 2019/01/06 23:56:13 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class DeprecatedHelperQVMDataBLDirectAccessWithBasis extends DeprecatedHelperDataDirectAccessWithBasis<QVMDataBL> {

    static final Laguerre B=new Laguerre();
    public DeprecatedHelperQVMDataBLDirectAccessWithBasis(){super(null);}

public void setM(final double [] m,final int n,final int mom,final QVMDataBL odata,final int neq_t)
{
    if(n>=odata.npm||neq_t>odata.ntm) throw new IllegalArgumentException("n="+n+" odata.npm="+odata.npm+" neq_t="+neq_t+" odata.ntm="+odata.ntm);

    final double [] abc;
    if(mom==M_I) abc=odata.vmoments_Ltau_x_p;
    else throw new RuntimeException("mom="+mom);
    for(int k=0,o=n;k<neq_t;k++,o+=odata.npm){m[k]=abc[o];}
}

public void setMT(final double [] m,final int nmoms){java.util.Arrays.fill(m,0,nmoms,0);m[0]=1;}
public int setQQCoefs(final int l,final int m,final double [] coefs){B.setQlQmExpansionCoefs(l,m,coefs);return l+m+1;}
public double fx(final double [] m,final double x){return B.getD0(m,x);}
public double Dfx(final double [] m,final double x){return B.getD1(m,x);}
public double D2fx(final double [] m,final double x){return B.getD2(m,x);}
public int setFMoments(final double [] Vmoments,final double [] dVmoments,final int n)
{
    throw new RuntimeException("Not Implemented");
}
public int setDFMoments(final double [] dFmoments,final double [] Fmoments,final int n)
{
    throw new RuntimeException("Not Implemented");
}

}
