package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.Polynomials;

/** Polynomial basis in price space.
 *  @version $Id: DeprecatedHelperQVMDataBLpDirectAccessWithBasis.java,v 1.13 2019/01/06 23:56:13 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class DeprecatedHelperQVMDataBLpDirectAccessWithBasis extends DeprecatedHelperDataDirectAccessWithBasis<QVMDataBL> {

    public DeprecatedHelperQVMDataBLpDirectAccessWithBasis(){super(null);}

/** @param m Array to save p^k L_n(x) moments, k=[0..nmoms-1].
    @param n The Laguerre polynomial to use.
    @param odata calculated data.
    @param nmoms the number of p^k moments to save.
*/
public void setM(final double [] m,final int n,final int mom,final QVMDataBL odata,final int nmoms)
{
    if(n>=odata.ntm||nmoms>odata.npm) throw new IllegalArgumentException("n="+n+" odata.ntm="+odata.ntm+" nmoms="+nmoms+" odata.npm="+odata.npm);

    final double [] abc;
    if(mom==M_I) abc=odata.vmoments_Ltau_x_p;
    else throw new RuntimeException("mom="+mom);
    System.arraycopy(abc,n*odata.npm,m,0,nmoms);
}

public void setMT(final double [] m,final int nmoms){throw new RuntimeException("Not supported");}
public int setQQCoefs(final int l,final int m,final double [] coefs){java.util.Arrays.fill(coefs,0,l+m,0);coefs[l+m]=1;return l+m+1;}
public double fx(final double [] m,final double x){return Polynomials.getD0(m,x);}
public double Dfx(final double [] m,final double x){return Polynomials.getD1(m,x);}
public double D2fx(final double [] m,final double x){return Polynomials.getD2(m,x);}
public int setFMoments(final double [] Vmoments,final double [] dVmoments,final int n)
{
    throw new RuntimeException("Not Implemented");
}
public int setDFMoments(final double [] dFmoments,final double [] Fmoments,final int n)
{
    throw new RuntimeException("Not Implemented");
}
}
