package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.Laguerre;
import com.polytechnik.freemoney.*;

/** Laguerre basis.
 *  @version $Id: DeprecatedHelperQVMDataLAccess.java,v 1.27 2022/07/10 10:59:03 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
@Deprecated
class DeprecatedHelperQVMDataLAccess implements DeprecatedHelperDataInterface<QVMDataL> {

final int neq_t;
DeprecatedHelperQVMDataLAccess(final int neq_t)
{
    this.neq_t=neq_t;
}

public int get_NT(){return neq_t;}
public double get_o_o(){return neq_t;}
public double get_f_o(final double [] f){
    if(f.length!=neq_t) throw new RuntimeException();
    return WIntegratorLaguerre.B.getD0(f,0);
}
public double get_f_g(final double [] f,final double [] g){
    if(neq_t!=f.length) throw new RuntimeException();
    return WIntegratorLaguerre.B.get2LaguerreAveraged(f,g);
}
public double getPOffset(final QVMDataL odata){return odata.p_offset;}
public void setM(final double [] m,final int n,final int mom,final QVMDataL odata)
{
    if(n>=odata.npm||neq_t>odata.ntm) throw new IllegalArgumentException("n="+n+" odata.npm="+odata.npm+" neq_t="+neq_t+" odata.ntm="+odata.ntm);
    if(mom==M_O)
    {
	for(int k=0;k<neq_t;k++){m[k]=1;}
	return;
    }
    final double [] abc;
    if(mom==M_I) abc=odata.vmoments_Ltau_x_p;
    else if(mom==M_IBUY) abc=odata.vbuymoments_Ltau_x_p;
    else if(mom==M_ISELL) abc=odata.vsellmoments_Ltau_x_p;
    else if(mom==M_DP) abc=odata.pmoments_Ltau_x_p;
    else if(mom==M_DPPLUS) abc=odata.pluspmoments_Ltau_x_p;
    else if(mom==M_DPMINUS) abc=odata.minuspmoments_Ltau_x_p;
    else if(mom==M_TS) abc=odata.tsmoments_Ltau_x_p;
    else if(mom==M_VS) abc=odata.vsmoments_Ltau_x_p;
    else if(mom==M_RTS) abc=odata.rtsmoments_Ltau_x_p;
    else if(mom==M_RVS) abc=odata.rvsmoments_Ltau_x_p;
    else throw new RuntimeException("mom="+mom);
    if(mom==M_I||mom==M_IBUY||mom==M_ISELL)
    {
	for(int k=0,o=n;k<neq_t;k++,o+=odata.npm){m[k]=(abc[o]/odata.vmoments_Ltau_x_p[0]);}
    }
    else
    {
	for(int k=0,o=n;k<neq_t;k++,o+=odata.npm){m[k]=abc[o];}
    }
}
public void setDmoments(final double [] df,final double [] f)
{
    final double [] m=WIntegratorLaguerre.B.getL1FromL0(f);
    System.arraycopy(m,0,df,0,neq_t);
}
public void setDfDt(final double [] dfdt,final double [] f)
{
    dfdt[neq_t-1]=0;
    if(f.length!=neq_t) throw new IllegalArgumentException();
    final double [] d=WIntegratorLaguerre.B.getDifferentiated(f);
    // inverted time
    for(int k=0;k<neq_t;k++) dfdt[k]=-d[k];
}
}
