package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.freemoney.*;

/** Shifted Legendre basis.
 *  @version $Id: DeprecatedHelperQVMDataPAccess.java,v 1.27 2022/07/10 10:59:03 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
@Deprecated
class DeprecatedHelperQVMDataPAccess implements DeprecatedHelperDataInterface<QVMDataP> {

final int neq_t;
DeprecatedHelperQVMDataPAccess(final int neq_t)
{
    this.neq_t=neq_t;
}

public int get_NT(){return neq_t;}
public double get_o_o(){return neq_t*neq_t;}
public double get_f_o(final double [] f){
    if(f.length!=neq_t) throw new RuntimeException();
    return WIntegratorLegendreShifted.B.getD0(f,1);
}
public double get_f_g(final double [] f,final double [] g){
    if(neq_t!=f.length) throw new RuntimeException();
    return WIntegratorLegendreShifted.B.get2LegendreAveraged(f,g);
}
public double getPOffset(final QVMDataP odata){return odata.p_offset;}
public void setM(final double [] m,final int n,final int mom,final QVMDataP odata)
{
    if(n>=odata.npm||neq_t>odata.ntm) throw new IllegalArgumentException("n="+n+" odata.npm="+odata.npm+" neq_t="+neq_t+" odata.ntm="+odata.ntm);
    if(mom==M_O)
    {
	for(int k=0;k<neq_t;k++){m[k]=2*k+1;}
	return;
    }
    final double [] abc;
    if(mom==M_I) abc=odata.vmoments_Ptau_x_p;
    else if(mom==M_IBUY) abc=odata.vbuymoments_Ptau_x_p;
    else if(mom==M_ISELL) abc=odata.vsellmoments_Ptau_x_p;
    else if(mom==M_DP) abc=odata.pmoments_Ptau_x_p;
    else if(mom==M_DPPLUS) abc=odata.pluspmoments_Ptau_x_p;
    else if(mom==M_DPMINUS) abc=odata.minuspmoments_Ptau_x_p;
    else if(mom==M_TS) abc=odata.tsmoments_Ptau_x_p;
    else if(mom==M_VS) abc=odata.vsmoments_Ptau_x_p;
    else if(mom==M_RTS) abc=odata.rtsmoments_Ptau_x_p;
    else if(mom==M_RVS) abc=odata.rvsmoments_Ptau_x_p;
    else throw new RuntimeException("mom="+mom);

    if(mom==M_I||mom==M_IBUY||mom==M_ISELL)
    {
	for(int k=0,o=n;k<neq_t;k++,o+=odata.npm){m[k]=(2*k+1)*(abc[o]/odata.vmoments_Ptau_x_p[0]);}
    }
    else
    {
	for(int k=0,o=n;k<neq_t;k++,o+=odata.npm){m[k]=(2*k+1)*abc[o];}
    }
}
public void setDmoments(final double [] df,final double [] f)
{
    if(f.length!=neq_t||df.length!=neq_t) throw new RuntimeException();
    System.arraycopy(DeprecatedHelperEVXData.getXPnprimeplusPnMoments(f),0,df,0,neq_t);
}
public void setDfDt(final double [] dfdt,final double [] f)
{
    if(f.length!=neq_t||dfdt.length!=neq_t) throw new IllegalArgumentException();
    dfdt[neq_t-1]=0;
    System.arraycopy(WIntegratorLegendreShifted.B.getXDiffF(f),0,dfdt,0,neq_t);
}
}
