package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.TMatr;

/** A helper to use removed from TMatr deprecated code.
 *  @version $Id: DeprecatedHelperTMatr.java,v 1.18 2022/10/30 21:43:57 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
@Deprecated class DeprecatedHelperTMatr {

public static double [] remove0Element(final double [] m)
{
    if(m.length==0) return new double []{};
    final double [] r=new double [m.length-1];
    System.arraycopy(m,1,r,0,m.length-1);
    return r;
}

public static void sumP1(final double [] res,final double [] pin,final int pin_offset,final int nels,final double w)
{
    for(int k=0;k<nels;k++)
    {
	res[k]+=w*pin[k+pin_offset];
    }
}

public static double [] sumAB(final int n,final double [] A,final double [] B)
{
    final double [] r=new double [n];
    for(int k=0;k<n;k++)
    {
	r[k]=A[k]+B[k];
    }
    return r;
}

public static void sumP1(final double [] res,final double [] pin,final int nels,final double w)
{
    sumP1(res,pin,0,nels,w);
}

public static void sumP2(final double [] res,final double [] pin)
{
    TMatr.sumP1(res,com.polytechnik.utils.Polynomials.mult2Pol(pin,pin),1);
}

/** Vector components ratio.
 */
public static double [] getRatio(final int n,final double [] a,final double [] b)
{
    final double [] r=new double [n];
    for(int k=0;k<n;k++) r[k]=a[k]/b[k];
    return r;
}

public static double [] mulMV(final double [][] m,final double [] a)
{
    final double [] b=new double [m.length];
    for(int k=0;k<b.length;k++)
    {
	b[k]=TMatr.mulVV(m[k],a);
    }
    return b;
}

/** Calculate m x n^T, where m - matrix, n - transpose matrix. */
public static double [][] mulM_x_NT(final double [][] m,final double [][] nT)
{
    final int d=nT.length;
    final double [][] r=new double [m.length][];
    for(int k=0;k<r.length;k++)
    {
	r[k]=mulMV(nT,m[k]);
    }
    return r;
}
public static double [] mulVMT(final double [] a,final double [][] mT)
{
    if(a.length!=mT.length) throw new IllegalArgumentException();
    final double [] b=new double [mT[0].length];
    for(int l=0;l<a.length;l++)
    {
	if(b.length!=mT[l].length) throw new IllegalArgumentException();
	for(int k=0;k<b.length;k++)
	{
	    b[k]+=a[l]*mT[l][k];
	}
    }
    return b;
}
public static double [][] mulM_x_N(final double [][] m,final double [][] n)
{
    final int d=n.length;
    final double [][] r=new double [m.length][];
    for(int k=0;k<r.length;k++)
    {
	r[k]=mulVMT(m[k],n);
    }
    return r;
}
public static double getA_M_A(final int n,final double [] A,final double [][] matr)
{
    return getA_M_B(n,A,matr,A);
}
public static double getA_M_B(final int n,final double [] A,final double [][] matr,final double [] B)
{
    double s=0;
    for(int l=0;l<n;l++)
    {
	double sm=0;
	for(int m=0;m<n;m++) sm+=matr[l][m]*B[m];
	s+=A[l]*sm;
    }
    return s;
}

/** Calculates matrA_im matrB_mj
 */
public static void multiply_Matr_x_Matr(final int n,final double [] r,final double [] matrA,final int nmA,final double [] matrB,final int nmB)
{
    multiply_Matr_x_Matr(n,r,matrA,nmA,0,matrB,nmB,0);
}

/** Calculates matrA_im matrB_mj
 */
public static void multiply_Matr_x_Matr(final int n,final double [] r,final double [] matrA,final int nmA,final int off_matrA,final double [] matrB,final int nmB,final int off_matrB)
{
    for(int k=0;k<n;k++)
    {
	for(int l=0;l<n;l++)
	{
	    double s=0;
	    for(int m=0,o=off_matrA+k*nmA;m<n;m++,o++) s+=matrA[o]*matrB[m*nmB+off_matrB+l];
	    r[k*n+l]=s;
	}
    }
}
/** Calculates M_ij=matrA_im (matrB_mj)^T=matrA_im matrB_jm
 */
public static void multiply_Matr_x_MatrTrans(final int n,final double [] r,final double [] matrA,final int nmA,final int off_matrA,final double [] matrB,final int nmB,final int off_matrB)
{
    for(int k=0;k<n;k++)
    {
	for(int l=0;l<n;l++)
	{
	    double s=0;
	    for(int m=0,o=off_matrA+k*nmA;m<n;m++,o++) s+=matrA[o]*matrB[l*nmB+off_matrB+m];
	    r[k*n+l]=s;
	}
    }
}
/** Calculates M_ij=(matrA_im)^T matrB_mj=matrA_mi matrB_mj
 */
public static void multiply_MatrTrans_x_Matr(final int n,final double [] r,final double [] matrA,final int nmA,final int off_matrA,final double [] matrB,final int nmB,final int off_matrB)
{
    for(int k=0;k<n;k++)
    {
	for(int l=0;l<n;l++)
	{
	    double s=0;
	    for(int m=0;m<n;m++) s+=matrA[m*nmA+(k+off_matrA)]*matrB[m*nmB+(l+off_matrB)];
	    r[k*n+l]=s;
	}
    }
}
/** Calculates M_ij=(matrA_im)^T (matrB_mj)^T=matrA_mi matrB_jm
 */
public static void multiply_MatrTrans_x_MatrTrans(final int n,final double [] r,final double [] matrA,final int nmA,final int off_matrA,final double [] matrB,final int nmB,final int off_matrB)
{
    for(int k=0;k<n;k++)
    {
	for(int l=0;l<n;l++)
	{
	    double s=0;
	    for(int m=0;m<n;m++) s+=matrA[m*nmA+(k+off_matrA)]*matrB[(l*nmB+off_matrB)+m];
	    r[k*n+l]=s;
	}
    }
}

static double mulVVo(final int n,final double [] a,final int off_a,final double [] b,final int off_b)
{
    double s=0;
    for(int i=n;--i>=0;)
    {
	s+=a[i+off_a]*b[i+off_b];
    }
    return s;
}


/** r[i*sB+j]=\sum_{k=0}^{k=s-1} A[i*ldA+k]*B[k*ldB+j] ; i=[0..sA-1], j=[0..sB-1].
    A: sA x s matrix, B: s x sB matrix, r: sA x sB matrix, ld(r)=sB.
 */
static void multiply_MA_x_MB(final double [] r,final int sA,final double [] A,final int ldA,final int off_A,final int s,final double [] B,final int sB,final int ldB,final int off_B)
{
    if(s>ldA||sB>ldB) throw new IllegalArgumentException();
    for(int i=0;i<sA;i++)
    {
	for(int j=0;j<sB;j++)
	{
	    double sum=0;
	    for(int k=0;k<s;k++)
	    {
		sum+=A[off_A+i*ldA+k]*B[off_B+k*ldB+j];
	    }
	    r[i*sB+j]=sum;
	}
    }
}

/** r[i*sB+j]=\sum_{k=0}^{k=s-1} A[i*ldA+k]*B[j*ldB+k] ; i=[0..sA-1], j=[0..sB-1].
    A: sA x s matrix, B: sB x s matrix, r: sA x sB matrix, ld(r)=sB.
 */
static void multiply_MA_x_MBTrans(final double [] r,final int sA,final double [] A,final int ldA,final int off_A,final int s,final double [] B,final int sB,final int ldB,final int off_B)
{
    if(s>ldA||s>ldB) throw new IllegalArgumentException();
    for(int i=0;i<sA;i++)
    {
	for(int j=0;j<sB;j++)
	{
	    double sum=0;
	    for(int k=0;k<s;k++)
	    {
		sum+=A[off_A+i*ldA+k]*B[off_B+j*ldB+k];
	    }
	    r[i*sB+j]=sum;
	}
    }
}

}
