package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** An attribute for ML program.
 *  @version $Id: DoubleAttributes.java,v 1.10 2009/05/24 10:17:28 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class DoubleAttributes {

    private static final boolean PRG_DEBUG=false;

    private int n_values=0;
    private double [] attribute_values=new double [100];

    void clearData()
    {
	if(PRG_DEBUG)
	{
	    System.err.println("DoubleAttributes::cleared="+this.n_values);
	}
	this.n_values=0;
	java.util.Arrays.fill(this.attribute_values,0.0);
    }

    private void ensureValueCapacity()
    {
	if(this.n_values<this.attribute_values.length)
	{
	    throw new IllegalArgumentException("Try to catch wrong usage");
	}

	final int s=1+2*this.attribute_values.length;
	final double [] newvalues=new double [s];
	System.arraycopy(this.attribute_values,0,newvalues,0,this.n_values);
	this.attribute_values=newvalues;
	if(PRG_DEBUG)
	{
	    System.err.println("DoubleAttributes::NEWSIZE="+s);
	}
    }

    int getNValues()
    {
	return this.n_values;
    }

    void addValue(final double v)
    {
	if(this.n_values>=this.attribute_values.length)
	{
	    ensureValueCapacity();
	}
	this.attribute_values[this.n_values++]=v;
    }


    double [] getInternalBuffer()
    {
	return this.attribute_values;
    }

}
