package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;

/** Three point P&L.
 */
class Dyn3PnL {
    final double p_pnlL,I_pnlL,p_pnlH,I_pnlH;

    // assume offset=p_last
    Dyn3PnL(final int n,
	    final double [] QQi,final double [] QQt, final double [] QQpi,
	    final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M)
    {
	if(n<2) throw new IllegalArgumentException("n="+n+"<2");


	final int iL=1,iH=n-1;
	final double [] pnlbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQpi,QQt,M);
	this.I_pnlL=TMatr.getAMatrA(n,pnlbasis,n+iL*n,QQi,n);
	this.p_pnlL=pnlbasis[iL]/I_pnlL;
	this.I_pnlH=TMatr.getAMatrA(n,pnlbasis,n+iH*n,QQi,n);
	this.p_pnlH=pnlbasis[iH]/I_pnlH;
    }
}
