package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2015
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;
import com.polytechnik.utils.VolMatrix;

/** Adjust |o> to future I value
 */
class DynFVarPnL {
    final double I_0,I_L,I_H;
    final DynVarIPnL var;

DynFVarPnL(final int n,
	   final double [] QQi,final double [] QQt, final double [] QQpi,
	   final double p_shift,
	   final VolMatrix VOLATILITY_EDPsi,final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M)
{
    final int i0=0,iL=1,iH=n-1;
    final double [] basis=EdComm.getIRadauBasisPsi0FromQQ(n,QQi,QQt,M);
    this.I_0=basis[i0];
    this.I_L=basis[iL];
    this.I_H=basis[iH];

    final double [] QQ0=M.B.getQQMatr(n,M.B.getX0Moments(2*n-1,M.getRadauRoot()));
    final double di=(I_H*0-I_0)/TMatr.getAMatrA(n,basis,n+i0*n,QQ0,n);
    final double [] QQj=TMatr.sumAcB(QQi,di,QQ0),QQpj=TMatr.sumAcB(QQpi,di*p_shift,QQ0);

    this.var=new DynVarIPnL(n,QQj,QQt,QQpj,VOLATILITY_EDPsi.getDMatrix(n),M);
    if(false && true)
    {
	System.err.println("DynFVarPnL:I_H="+I_H+" var.I.s0="+var.I.s0+" var.I.sH="+var.I.sH);
    }
}


}

