package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: DynMicroImpactLegendreShifted.java,v 1.9 2022/07/10 10:41:20 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class DynMicroImpactLegendreShifted extends DynMicroImpact<QVMDataP> {

DynMicroImpactLegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}

public static DynMicroImpactLegendreShifted calculate(final int neq,
						 final long currenttime,
						 final long tau,
						 final Trade [] tb,
						 final int tsize,
						 final DynMicroImpactLegendreShifted ref)
{
    final int npm=4,nr=0;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1+nr,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new DynMicroImpactLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}

static class DynMicroImpactLegendreShiftedTest extends DynMicroImpactTest<QVMDataP> {
DynMicroImpactLegendreShiftedTest(final long initrandom)
{
    super("DynMicroImpactLegendreShifted",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
ImpactQVMLegendreShifted getImpactQVM(){return ImpactQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}
IAImpactLegendreShifted getIAImpact(){return IAImpactLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}
DynMicroImpactLegendreShifted getDynMicroImpact(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class DynMicroImpactLegendreShiftedTest

public static void main(String [] args)
{
    new DynMicroImpactLegendreShiftedTest(7163L).runTests(2,7);
} // END main



} // END OF class DynMicroImpactLegendreShifted
