package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.utils.Skewness;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: DynMicroImpact_pi.java,v 1.15 2018/05/05 20:53:58 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class DynMicroImpact_pi extends DynMicroImpact<QVMDataL> {
final ImpactFromTheFuture_Dpi iffa_pi;
DynMicroImpact_pi(final int neq,final QVMDataL odata,final State rst){super(neq,odata,rst);
    iffa_pi=new ImpactFromTheFuture_Dpi(getIMomentsData(neq),getABasis(),0);
}


public static DynMicroImpact_pi calculate(final int neq,
					   final long currenttime,
					   final long tau,
					   final Trade [] tb,
					   final int tsize,
					   final DynMicroImpact_pi ref)
{
    final int ntm=1,npm=2*neq+2;
    final QVMDataL o=QVMDataL.calculateQVMDataL(ntm,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new DynMicroImpact_pi(neq,o,ref!=null?ref.sst:null);
}
@Override
protected IMomentsData getIMomentsData(final int n){return IMomentsData.get_PriceMonomials_IMomentsData(n,odata,getAccess(),getABasis());}
QVMDataLDirectAccess getAccess(){return new QVMDataLDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){
    return new OrthogonalPolynomialsMonomialsBasisX(1,-getAccess().getPLast(odata)); // getPLast does have p_offset included
}

static class DynMicroImpact_piTest extends DynMicroImpactTest<QVMDataL> {
DynMicroImpact_piTest(final long initrandom)
{
    super("DynMicroImpact_pi",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}

@Override
void test_Extra(){
    final DynMicroImpact_pi q=getDynMicroImpact();
    final QkPnLpi_PBasis s=getQkPnLpi_PBasis();
    DMI.matchQkPnLpi_PBasis(q.dmiIH,s,eps);
    UnitTests.checkDoubleRel(q.pdmi.dpdt_orig_IH,"q.pdmi.dpdt_orig_IH",s.ist.dp_orig_IH,"s.ist.dp_orig_IH",eps);
    new ImpactFromTheFuture_Dpi(q.getIMomentsData(neq),q.getABasis(),eps);
    System.err.println(name+":DynMicroImpact_piTest:test_Extra(): test DynMicroImpact_pi OK neq="+neq+" eps="+eps);
}

ImpactQVM<QVMDataL> getImpactQVM(){return null; /* Skip this test. */}
IAImpact<QVMDataL> getIAImpact(){return IAImpact_pi.calculate(neq,currenttime,tau,tb,tb.length,null);}
QkPnLpi_PBasis getQkPnLpi_PBasis(){return QkPnLpi_PBasis.calculate(neq,currenttime,tau,tb,tb.length,null);}
DynMicroImpact_pi getDynMicroImpact(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class DynMicroImpact_piTest

public static void main(String [] args)
{
    new DynMicroImpact_piTest(12374L).runTests(2,5);
} // END main



} // END OF class DynMicroImpact_pi
