package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.EVXData;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;

class DynVolPnL {
    final double pEQ,IEQ,pEB,volP2EB;
    final EVXData I,Ipnl;

    DynVolPnL(final int n,
	      final int ind_pnl,
	      final double [] QQt,final double [] QQi, final double [] QQpi, final double [] QQp2i,
	      final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M)
    {
	this.I=EVXData.getEVXDataFromQQ(n,QQi,QQt,M);
	this.pEB=I.getFPsi(ind_pnl,QQpi)/I.ev[ind_pnl];
	final double [] QQa=new double [n*n];
	for(int k=QQa.length;--k>=0;) QQa[k]=QQp2i[k]+pEB*(-2*QQpi[k]+pEB*QQi[k]);
	if(false)
	{
	    final double [] QQpis=TMatr.sumAcB(QQpi,-pEB,QQi);
	    System.err.println("<psi|QQpi-pEB*QQi|psi>="+I.getFPsi(ind_pnl,QQpis)+" must be =0");
	}
	this.volP2EB=I.getFPsi(ind_pnl,QQa);
	this.Ipnl=EVXData.getEVXDataFromQQ(n,QQa,QQt,M);
	this.IEQ=Ipnl.getFPsi(ind_pnl,QQi);
	this.pEQ=Ipnl.getFPsi(ind_pnl,QQpi)/IEQ;
    }

}

