package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Laguerre;
import com.polytechnik.utils.OrthogonalPolynomialsLaguerreBasis;
import com.polytechnik.outils.*;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

public class EkQVMLaguerre extends EkQVM<QVMDataL> {

EkQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}

public static EkQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final EkQVMLaguerre ref)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*neq-1+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new EkQVMLaguerre(neq,o);
}
DeprecatedHelperQVMDataLDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataLDirectAccessWithBasis();}
OrthogonalPolynomialsLaguerreBasis getABasis(){return new OrthogonalPolynomialsLaguerreBasis();}
double getX0(){return 0;}
double getPOffset(){return odata.p_offset;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
boolean isEdgeAtRight(){return false;}
long getVolume(){return odata.vol;}
TwoCloseRootsFinder.RootsData execTR(final PTwoRoots tr)
{
    return TwoCloseRootsFinder.findRootsData(getX0(),2.1,3000,tr);
}
/** Calcucales psi/2-psi'
 */
double [] getEDPsi(final double [] psi){return WIntegratorLaguerre.getEDPsi(psi);}

double [] getCoefsForPNLInDPspace(final double [] psi)
{
    final double [] psi2=WIntegratorLaguerre.B.mult2Pol(psi,psi);
    final double [] intr=WIntegratorLaguerre.B.getLaguerreExpFIntegrated(psi2);
    return intr;
}


static class EkQVMLaguerreTest extends EkQVMTest<QVMDataL> {
EkQVMLaguerreTest(final long initrandom)
{
    super("EkQVMLaguerre",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLaguerre.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
EkQVMLaguerre getEkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DkQVMLaguerre getDkQVM(){return DkQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class EkQVMLaguerreTest

public static void main(String [] args)
{
    new EkQVMLaguerreTest(1118).runTests(5);
} // END main



} // END OF class EkQVMLaguerre
