package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.outils.*;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

public class EkQVMLegendreShifted extends EkQVM<QVMDataP> {
EkQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static EkQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final EkQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*neq-1+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new EkQVMLegendreShifted(neq,o);
}
DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getX0(){return 1;}
double getPOffset(){return odata.p_offset;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
boolean isEdgeAtRight(){return true;}
long getVolume(){return odata.vol;}
TwoCloseRootsFinder.RootsData execTR(final PTwoRoots tr)
{
    return TwoCloseRootsFinder.findRootsData(getX0(),0.5,3000,tr);
}
/** Calculates psi/2+x*psi'
 */
double [] getEDPsi(final double [] psi){return WIntegratorLegendreShifted.getEDPsi(psi);}

double [] getCoefsForPNLInDPspace(final double [] psi)
{
    final double [] psi2=WIntegratorLegendreShifted.B.mult2Pol(psi,psi);
    // access.setFMoments(tmp,psi2,psi2.length);
    final double [] intr=WIntegratorLegendreShifted.B.getIntegrated(psi2);
    return WIntegratorLegendreShifted.B.sdiv1(intr,0).q;
    //System.err.println("intr="+java.util.Arrays.toString(intr));
    //System.err.println("setFMoments="+java.util.Arrays.toString(tmp));
}


static class EkQVMLegendreShiftedTest extends EkQVMTest<QVMDataP> {
EkQVMLegendreShiftedTest(final long initrandom)
{
    super("EkQVMLegendreShifted",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
EkQVMLegendreShifted getEkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DkQVMLegendreShifted getDkQVM(){return DkQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class EkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new EkQVMLegendreShiftedTest(6L).runTests(5);
} // END main



} // END OF class EkQVMLegendreShifted
