package com.polytechnik.trading;
import com.polytechnik.utils.UnitTests;
/*
 * (C) Vladislav Malyshkin 2020
 * This file is under GPL version 3.
 *
 */

/**
 * A class to store enter point.
 * @version $Id: EnterPoint.java,v 1.4 2020/12/26 17:09:06 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
*/
public class EnterPoint {
    public final long time;
    public final double P,IH;

    public EnterPoint(final long time,
		      final double P,
		      final double IH){
	this.time=time;
	this.P=P;
	this.IH=IH;
    }


    static void matchEnterPoint(final EnterPoint a,final EnterPoint b,final double eps){
	if((a==null && b!=null)||(a!=null && b==null))
	    throw new RuntimeException("null mismatch");
	if(a!=null && b!=null){
	    UnitTests.checkDoubleRel(a.P,"a.P",b.P,"b.P",eps);
	    UnitTests.checkDoubleRel(a.IH,"a.IH",b.IH,"b.IH",eps);
	    if(a.time!=b.time) throw new RuntimeException("a.time="+a.time+" b.time="+b.time);
	}
	System.err.println("EnterPoint test OK eps="+eps);
    }
}
