package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2020
 * This file is under GPL version 3.
 *
 */

/**
 * A class to store exit point.
 * @version $Id: ExitPoint.java,v 1.4 2020/12/28 21:32:05 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
*/
public class ExitPoint extends EnterPoint {

    public final EnterPoint enter;

    public ExitPoint(final long time,
		     final double P,
		     final double IH,
		     final EnterPoint enter){
	super(time,P,IH);
	this.enter=enter;
    }

    public double getPriceChangePnL(){
	return enter==null?0:this.P-enter.P;
    }
    public double getIHChangePnL(){
	return enter==null?0:this.IH-enter.IH;
    }
}
