package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */

/** Save state.
 *  @version $Id: FStateSaver.java,v 1.3 2014/08/05 13:59:49 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class FStateSaver {

    public final StateSaver.S J;

    final int from;
    private boolean flag_tainted=false;
    static final int F_MAX=472,F_MIN=473,F_NONE=474;

    FStateSaver(final StateSaver.S J,final int from)
    {
	this.J=J;
	this.from=from;
    }

    double getPMin()
    {
	if(from==F_MIN) return J.Pc;
	return Double.NaN;
    }
    double getPMax()
    {
	if(from==F_MAX) return J.Pc;
	return Double.NaN;
    }


    public static FStateSaver getMaxUpdate(final double I,final double p,final long t,final double F,final long U,final long V,final FStateSaver rr)
    {
	final FStateSaver r=getNothingUpdate(rr);
	if(r.from!=F_MAX || r.flag_tainted || (r.from==F_MAX && !(I<r.J.Ic)))
	    return new FStateSaver(new StateSaver.S(I,p,t,F,U,V),F_MAX);
	return r;
    }

    public static FStateSaver getMinUpdate(final double I,final double p,final long t,final double F,final long U,final long V,final FStateSaver rr)
    {
	final FStateSaver r=getNothingUpdate(rr);
	if(r.from!=F_MIN || r.flag_tainted || (r.from==F_MIN && !(I>r.J.Ic)))
	    return new FStateSaver(new StateSaver.S(I,p,t,F,U,V),F_MIN);
	return r;
    }

    public static FStateSaver getTaintedUpdate(final FStateSaver rr)
    {
	final FStateSaver r=getNothingUpdate(rr);
	r.flag_tainted=true;
	return r;
    }

    public static FStateSaver getNothingUpdate(final FStateSaver rr)
    {
	if(rr!=null) return rr;
	return new FStateSaver(StateSaver.S.EMPTY,F_NONE);
    }
}
