package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2018
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: IHStateDMLegendreShifted.java,v 1.5 2022/07/10 10:41:20 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class IHStateDMLegendreShifted extends IHStateDM<QVMDataP> {
IHStateDMLegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}


public static IHStateDMLegendreShifted calculate(final int neq,
					  final long currenttime,
					  final long tau,
					  final Trade [] tb,
					  final int tsize,
					  final IHStateDMLegendreShifted ref)
{

    final int npm=4,nmoms=2*neq-1;
    final QVMDataP o=QVMDataP.calculateQVMDataP(nmoms,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new IHStateDMLegendreShifted(neq,o,ref!=null?ref.sst:null);
}

QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double [] getPsi2WIntegratedDt(final double [] psi){return WIntegratorLegendreShifted.getPsi2WIntegratedDt(psi);}
double [] getEDPsi(final double [] psi){return WIntegratorLegendreShifted.getEDPsi(psi);}



static class IHStateDMLegendreShiftedTest extends IHStateDMTest<QVMDataP> {
IHStateDMLegendreShiftedTest(final long initrandom)
{
    super("IHStateDMLegendreShifted",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
ImpactQVMLegendreShifted getImpactQVM(){return ImpactQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}
IHStateDMLegendreShifted getIHStateDM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class IHStateDMLegendreShiftedTest


public static void main(String [] args)
{
    new IHStateDMLegendreShiftedTest(7163L).runTests(2,7);
} // END main


}


