package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.realtimebook.*;

/** QVM calculations.
 *  @version $Id: IQVMLaguerre.java,v 1.12 2019/01/06 23:33:47 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class IQVMLaguerre extends IQVM<QVMDataL> {

IQVMLaguerre(final int neq_t,final QVMDataL odata,final int mtype)
{
    super(neq_t,odata,mtype);
}
DeprecatedHelperQVMDataLAccess getAccess(final int neq_t){return new DeprecatedHelperQVMDataLAccess(neq_t);}

public static IQVMLaguerre calculate(final int neq_t,
				     final long currenttime,
				     final long tau,
				     final Trade [] tb,
				     final int tsize,
				     final IQVMLaguerre ref,
				     final int mtype)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(neq_t,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new IQVMLaguerre(neq_t,o,mtype);
}

public static void main(String [] args)
{
    new IQVMTest<QVMDataL>("IQVMLaguerre",1e-6,1e-3){
	IQVMLaguerre getIQVMWithRandomData(final int neq_t,final java.util.Random r,final int tsize)
	{
	    final Trade [] o_tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
	    long currenttime=o_tb[o_tb.length-1].time+1000;
	    final long tau=(o_tb[o_tb.length-1].time-o_tb[0].time)/24;
	    return calculate(neq_t,currenttime,tau,o_tb,tsize,null,default_MT);
	}
	EQVMLaguerre getEQVM(final int neq_t,final QVMDataL odata)
	{
	    return new EQVMLaguerre(neq_t,odata);
	}
     }.runTests();
}

} // END OF class IQVMLaguerre
