package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.realtimebook.*;

/** QVM calculations.
 *  @version $Id: IQVMLegendreShifted.java,v 1.13 2019/01/06 23:33:47 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class IQVMLegendreShifted extends IQVM<QVMDataP> {

IQVMLegendreShifted(final int neq_t,final QVMDataP odata,final int mtype)
{
    super(neq_t,odata,mtype);
}
DeprecatedHelperQVMDataPAccess getAccess(final int neq_t){return new DeprecatedHelperQVMDataPAccess(neq_t);}

public static IQVMLegendreShifted calculate(final int neq_t,
				     final long currenttime,
				     final long tau,
				     final Trade [] tb,
				     final int tsize,
				     final IQVMLegendreShifted ref,
				     final int mtype)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(neq_t,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new IQVMLegendreShifted(neq_t,o,mtype);
}

public static void main(String [] args)
{
    new IQVMTest<QVMDataP>("IQVMLegendreShifted",1e-6,1e-3){
	IQVMLegendreShifted getIQVMWithRandomData(final int neq_t,final java.util.Random r,final int tsize)
	{
	    final Trade [] o_tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
	    long currenttime=o_tb[o_tb.length-1].time+1000;
	    final long tau=(o_tb[o_tb.length-1].time-o_tb[0].time)/3;
	    return calculate(neq_t,currenttime,tau,o_tb,tsize,null,default_MT);
	}
	EQVMLegendreShifted getEQVM(final int neq_t,final QVMDataP odata)
	{
	    return new EQVMLegendreShifted(neq_t,odata);
	}
     }.runTests();
}

} // END OF class IQVMLegendreShifted
