package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: IStateLegendreShifted.java,v 1.5 2022/07/10 10:41:20 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class IStateLegendreShifted extends IState<QVMDataP> {

IStateLegendreShifted(final int neq,final QVMDataP odata,final StateSaver2<PS> rst){super(neq,odata,rst);}

public static IStateLegendreShifted calculate(final int neq,
						 final long currenttime,
						 final long tau,
						 final Trade [] tb,
						 final int tsize,
						 final IStateLegendreShifted ref)
{
    final int npm=4,nr=0;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1+nr,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new IStateLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}

static class IStateLegendreShiftedTest extends IStateTest<QVMDataP> {
IStateLegendreShiftedTest(final long initrandom)
{
    super("IStateLegendreShifted",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
IStateLegendreShifted getIState(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class IStateLegendreShiftedTest

public static void main(String [] args)
{
    new IStateLegendreShiftedTest(7163L).runTests(2,7);
} // END main



} // END OF class IStateLegendreShifted
