package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.EVXData;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: IStateMonomials.java,v 1.2 2018/06/01 08:16:08 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class IStateMonomials extends IState<QVMData> {
IStateMonomials(final int neq,final QVMData odata,final StateSaver2<PS> rst){super(neq,odata,rst);}


public static IStateMonomials calculate(final int neq,
					   final long currenttime,
					   final long tau,
					   final Trade [] tb,
					   final int tsize,
					   final IStateMonomials ref)
{
    final int nvm=1,npm=4,nr=0;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     2*(neq-1)+1+nr,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new IStateMonomials(neq,o,ref!=null?ref.sst:null);
}
QVMDataDirectAccess getAccess(){return new QVMDataDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}

static class IStateMonomialsTest extends IStateTest<QVMData> {
IStateMonomialsTest(final long initrandom)
{
    super("IStateMonomials",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}



@Override
void test_Extra(){
    // These to be identical
    final IStateMonomials q=getIState();
    final IStateLaguerre s=getIStateLaguerre();

    EVXData.matchEVXData(q.I,s.I,false,eps);

    System.err.println(name+":IStateMonomialsTest:test_Extra(): test IStateLaguerre OK neq="+neq+" eps="+eps);
}


IStateMonomials getIState(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
IStateLaguerre getIStateLaguerre(){return IStateLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class IStateMonomialsTest

public static void main(String [] args)
{
    new IStateMonomialsTest(11127L).runTests(2,5);
} // END main



} // END OF class IStateMonomials
