package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.EVXData;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.utils.Skewness;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: IState_pi.java,v 1.2 2018/06/01 08:16:08 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class IState_pi extends IState<QVMDataL> {
IState_pi(final int neq,final QVMDataL odata,final StateSaver2<PS> rst){super(neq,odata,rst);}

public static IState_pi calculate(final int neq,
					   final long currenttime,
					   final long tau,
					   final Trade [] tb,
					   final int tsize,
					   final IState_pi ref)
{
    final int ntm=1,npm=2*neq+2;
    final QVMDataL o=QVMDataL.calculateQVMDataL(ntm,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new IState_pi(neq,o,ref!=null?ref.sst:null);
}
@Override
protected JMomentsData getJMomentsData(final int n){return JMomentsData.get_PriceMonomials_JMomentsData(n,odata,getAccess());}
QVMDataLDirectAccess getAccess(){return new QVMDataLDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){
    return new OrthogonalPolynomialsMonomialsBasisX(1,-getAccess().getPLast(odata)); // getPLast does have p_offset included
}

static class IState_piTest extends IStateTest<QVMDataL> {
IState_piTest(final long initrandom)
{
    super("IState_pi",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}

@Override
void test_Extra(){
    final IState_pi q=getIState();
    final QkPnLpi_PBasis s=getQkPnLpi_PBasis();
    EVXData.matchEVXData(q.I,s.ist.eI,false,true,eps);
    System.err.println(name+":IState_piTest:test_Extra(): test IState_pi OK neq="+neq+" eps="+eps);
}

QkPnLpi_PBasis getQkPnLpi_PBasis(){return QkPnLpi_PBasis.calculate(neq,currenttime,tau,tb,tb.length,null);}
IState_pi getIState(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class IState_piTest

public static void main(String [] args)
{
    new IState_piTest(1274L).runTests(2,5);
} // END main



} // END OF class IState_pi
