package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: ImpactQVMMuseLegendreShifted.java,v 1.5 2022/07/10 10:41:21 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class ImpactQVMMuseLegendreShifted extends ImpactQVMMuse<QVMDataP> {

ImpactQVMMuseLegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}

public static ImpactQVMMuseLegendreShifted calculate(final int neq,
						 final long currenttime,
						 final long tau,
						 final Trade [] tb,
						 final int tsize,
						 final ImpactQVMMuseLegendreShifted ref)
{
    final int npm=4,nr=0;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1+nr,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new ImpactQVMMuseLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}

static class ImpactQVMMuseLegendreShiftedTest extends ImpactQVMMuseTest<QVMDataP> {
ImpactQVMMuseLegendreShiftedTest(final long initrandom)
{
    super("ImpactQVMMuseLegendreShifted",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
ImpactQVMLegendreShifted getImpactQVM(){return ImpactQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}
ImpactQVMMuseLegendreShifted getImpactQVMMuse(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class ImpactQVMMuseLegendreShiftedTest

public static void main(String [] args)
{
    new ImpactQVMMuseLegendreShiftedTest(914873L).runTests(2,7);
} // END main



} // END OF class ImpactQVMMuseLegendreShifted
