package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.realtimebook.*;

public class JkQVMMonomials extends JkQVM<QVMData> {
JkQVMMonomials(final int neq,final QVMData odata){super(neq,odata);}

public static JkQVMMonomials calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final JkQVMMonomials ref)
{
    final int nvm=1,npm=3,nmoms=2*neq-1+4;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     nmoms,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new JkQVMMonomials(neq,o);
}
DeprecatedHelperQVMDataDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataDirectAccessWithBasis();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis();}
double getX0(){return 0;}
double getPOffset(){return odata.p_offset;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}

static class JkQVMMonomialsTest extends JkQVMTest<QVMData> {
JkQVMMonomialsTest(final long initrandom)
{
    super("JkQVMMonomials",new java.util.Random(initrandom),1e-3);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}

JkQVMMonomials getJkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DkQVMLaguerre getDkQVM(){return DkQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class JkQVMMonomialsTest

public static void main(String [] args)
{
    new JkQVMMonomialsTest(16117L).runTests(3);
} // END main



} // END OF class JkQVMMonomials
