package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */

/** Save state.
 *  @version $Id: MMaxStateSaver.java,v 1.3 2014/11/15 18:37:49 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class MMaxStateSaver {

    public static class S {
	public final double Ic,Pc,Fc,FL,FH,a,b;
	public final long Tc,volume;
	S(final double Ic,final double Pc,final long Tc,final double Fc,final double FL,final double FH,final long volume,final double a,final double b)
	{this.Ic=Ic;this.Pc=Pc;this.Tc=Tc;this.Fc=Fc;this.FL=FL;this.FH=FH;this.volume=volume;this.a=a;this.b=b;}
	static final S EMPTY=new S(Double.NaN,Double.NaN,0,Double.NaN,Double.NaN,Double.NaN,0L,Double.NaN,Double.NaN);
    }


    public final S Max;

    final int from;
    static final int F_MAX=872,F_NONE=873;

    private boolean flag_tainted=false;
    MMaxStateSaver(final S Max,final int from)
    {
	this.Max=Max;
	this.from=from;
    }


    public static MMaxStateSaver getMaxUpdate(final double I,final double p,final long t,final double F,final double FL,final double FH,final long volume,final double a,final double b,final MMaxStateSaver rr)
    {
	final MMaxStateSaver r=getNothingUpdate(rr);
	if(r.from!=F_MAX || r.flag_tainted || (r.from==F_MAX && !(I<r.Max.Ic)))
	    return new MMaxStateSaver(new S(I,p,t,F,FL,FH,volume,a,b),F_MAX);
	return r;
    }

    public static MMaxStateSaver getTaintedUpdate(final MMaxStateSaver rr)
    {
	final MMaxStateSaver r=getNothingUpdate(rr);
	r.flag_tainted=true;
	return r;
    }

    public static MMaxStateSaver getNothingUpdate(final MMaxStateSaver rr)
    {
	if(rr!=null) return rr;
	return new MMaxStateSaver(S.EMPTY,F_NONE);
    }

    boolean isTainted(){return flag_tainted;}
}
