package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */

/** Save state.
 *  @version $Id: MaxStateSaver.java,v 1.3 2014/08/06 17:29:31 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class MaxStateSaver {

    public final StateSaver.S Max;

    final int from;
    static final int F_MAX=872,F_NONE=873;

    private boolean flag_tainted=false;
    MaxStateSaver(final StateSaver.S Max,final int from)
    {
	this.Max=Max;
	this.from=from;
    }


    public static MaxStateSaver getMaxUpdate(final double I,final double p,final long t,final double F,final long U,final long V,final MaxStateSaver rr)
    {
	final MaxStateSaver r=getNothingUpdate(rr);
	if(r.from!=F_MAX || r.flag_tainted || (r.from==F_MAX && !(I<r.Max.Ic)))
	    return new MaxStateSaver(new StateSaver.S(I,p,t,F,0,0),F_MAX);
	return r;
    }

    public static MaxStateSaver getTaintedUpdate(final MaxStateSaver rr)
    {
	final MaxStateSaver r=getNothingUpdate(rr);
	r.flag_tainted=true;
	return r;
    }

    public static MaxStateSaver getNothingUpdate(final MaxStateSaver rr)
    {
	if(rr!=null) return rr;
	return new MaxStateSaver(StateSaver.S.EMPTY,F_NONE);
    }
}
