package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */

/** Save state.
 *  @version $Id: MinMaxStateSaver.java,v 1.3 2014/07/27 18:50:45 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class MinMaxStateSaver {

    public final StateSaver.S Min,Max;

    final int from;
    static final int F_MIN=881,F_MAX=882,F_NONE=883;

    MinMaxStateSaver(final StateSaver.S Min,final StateSaver.S Max,final int from)
    {
	this.Min=Min;
	this.Max=Max;
	this.from=from;
    }

    public static MinMaxStateSaver getMinUpdate(final double I,final double p,final long t,final double F,final MinMaxStateSaver rr)
    {
	final MinMaxStateSaver r=getNothingUpdate(rr);
	if(r.from!=F_MIN || (r.from==F_MIN && !(I>r.Min.Ic)))
	    return new MinMaxStateSaver(new StateSaver.S(I,p,t,F,0,0),r.Max,F_MIN);
	return r;
    }

    public static MinMaxStateSaver getMaxUpdate(final double I,final double p,final long t,final double F,final MinMaxStateSaver rr)
    {
	final MinMaxStateSaver r=getNothingUpdate(rr);
	if(r.from!=F_MAX || (r.from==F_MAX && !(I<r.Max.Ic)))
	    return new MinMaxStateSaver(r.Min,new StateSaver.S(I,p,t,F,0,0),F_MAX);
	return r;
    }

    public static MinMaxStateSaver getNothingUpdate(final MinMaxStateSaver rr)
    {
	if(rr!=null) return rr;
	final StateSaver.S s=StateSaver.S.EMPTY;
	return new MinMaxStateSaver(s,s,F_NONE);
    }
}
