package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;
import com.polytechnik.utils.VolMatrix;
import com.polytechnik.utils.Skewness;
import com.polytechnik.utils.ProbabilityCorrelation;

/**
 * Try dmu measure dmu=dv-lam^[IL]dt.
 * @version $Id: Mu2IAroots.java,v 1.3 2020/09/27 20:33:17 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public class Mu2IAroots extends Mu2PsiRoots {
final double dir;
Mu2IAroots(final double [] psi,final double lam,
	   final double [] QQi,final double [] QQt,
	   final double [] QQp0i_sample,final double [] QQp1i_sample,final double [] QQp2i_sample,
	   final double [] QQp0t_sample,final double [] QQp1t_sample,final double [] QQp2t_sample,
	   final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> _M,final double eps)
{
    super(psi,lam,QQi,QQt,QQp0i_sample,QQp1i_sample,QQp2i_sample,
	  QQp0t_sample,QQp1t_sample,QQp2t_sample,_M,eps);
    final Mu2F [] mpx=new Mu2F [x.length];
    double sdir=0;
    for(int k=0;k<x.length;k++)
    {
	mpx[k]=new Mu2F(p0b[k],p1b[k],p2b[k],p0a[k],p1a[k],p2a[k],eps);
	sdir+=wmu[k]*mpx[k].pc.corr;
    }
    dir=sdir/TMatr.sumElements(wmu);
}
}
