package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;
import com.polytechnik.utils.VolMatrix;
import com.polytechnik.utils.Skewness;
import com.polytechnik.utils.ProbabilityCorrelation;

/**
 * Try dmu measure dmu=dv-lam^[IL]dt.
 * @version $Id: Mu2IArootsA.java,v 1.5 2020/09/27 20:33:17 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public class Mu2IArootsA extends Mu2PsiRootsA {
final Mu2F [] mu2it,mu2at;
final double dp_IA,p_I,p_A,dir;
Mu2IArootsA(final double [] psi,final double lam,
	    final double [] QQi,final double [] QQt,
	    final double [] QQp0t,final double [] QQp1t,final double [] QQp2t,
	    final double [] QQp0i,final double [] QQp1i,final double [] QQp2i,
	    final double [] QQp0a,final double [] QQp1a,final double [] QQp2a,
	    final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> _M,final double eps)
{
    super(psi,lam,QQi,QQt,new double [][]{
	    QQp0t,QQp1t,QQp2t,
	    QQp0i,QQp1i,QQp2i,
	    QQp0a,QQp1a,QQp2a
	},_M,eps);
    mu2it=new Mu2F[x.length];
    mu2at=new Mu2F[x.length];
    double sdp=0,spi=0,spa=0,sdir=0;
    for(int k=0;k<x.length;k++)
    {
	mu2it[k]=new Mu2F(moms[0][k],moms[1][k],moms[2][k],moms[3][k],moms[4][k],moms[5][k],eps);
	mu2at[k]=new Mu2F(moms[0][k],moms[1][k],moms[2][k],moms[6][k],moms[7][k],moms[8][k],eps);
	sdp+=(mu2it[k].root_psiL-mu2at[k].root_psiL)*wmu[k];
	spi+=mu2it[k].root_psiL*wmu[k];
	spa+=mu2at[k].root_psiL*wmu[k];
	final Mu2IA.Mu2IAdir mu2iad=new Mu2IA.Mu2IAdir(
	    moms[0][k],moms[1][k],moms[2][k],
	    moms[3][k],moms[4][k],moms[5][k],
	    moms[6][k],moms[7][k],moms[8][k],
	    eps);
	sdir+=mu2iad.dir*wmu[k];
	if(eps>0)
	{
	    System.err.println("mu2it[k].pc.corr="+mu2it[k].pc.corr+" mu2at[k].pc.corr="+mu2at[k].pc.corr);
	}
    }
    dp_IA=sdp/TMatr.sumElements(wmu);
    p_I=spi/TMatr.sumElements(wmu);
    p_A=spa/TMatr.sumElements(wmu);
    dir=sdir/TMatr.sumElements(wmu);
}
}
