package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: NkQVMLegendreShifted.java,v 1.14 2022/07/10 10:41:21 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class NkQVMLegendreShifted extends NkQVM<QVMDataP> {
NkQVMLegendreShifted(final int neq,final QVMDataP [] idata){super(neq,idata);}

public static NkQVMLegendreShifted calculate(final int neq,
					     final long currenttime,
					     final long tau,
					     final Trade [][] itb,
					     final int [] itbsize,
					     final NkQVMLegendreShifted ref)
{
    final int npm=3,nmoms=2*neq-1;
    final QVMDataP [] o=new QVMDataP [itb.length];
    for(int k=0;k<itb.length;k++)
    {
	o[k]=QVMDataP.calculateQVMDataP(nmoms,
					npm,
					currenttime,
					tau,
					itb[k],
					itbsize[k],
					ref!=null?ref.idata[k]:null);
    }
    return new NkQVMLegendreShifted(neq,o);
}

public static NkQVMLegendreShifted calculate1(final int neq,
					      final long currenttime,
					      final long tau,
					      final Trade [] tb,
					      final int tsize,
					      final NkQVMLegendreShifted ref)
{
    return calculate(neq,currenttime,tau,new Trade [][]{tb},new int []{tsize},ref);
}


DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
double getPOffset(final QVMDataP odata){return odata.p_offset;}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}

static class NkQVMLegendreShiftedTest extends NkQVMTest<QVMDataP> {
NkQVMLegendreShiftedTest(final long initrandom)
{
    super("NkQVMLegendreShifted",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
NkQVMLegendreShifted getNkQVM1(){return calculate(neq,currenttime,tau,new Trade [][]{tdata[0]},new int []{tdata[0].length},null);}
MkQVMLegendreShifted getMkQVM(){return MkQVMLegendreShifted.calculate(neq,currenttime,tau,tdata[0],tdata[0].length,null);}

} // END of class NkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new NkQVMLegendreShiftedTest(62287L).runTests(4);
} // END main



} // END OF class NkQVMLegendreShifted
