package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: NkQVMMonomials.java,v 1.9 2019/01/06 23:39:12 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class NkQVMMonomials extends NkQVM<QVMData> {
NkQVMMonomials(final int neq,final QVMData [] idata){super(neq,idata);}


public static NkQVMMonomials calculate(final int neq,
				       final long currenttime,
				       final long tau,
				       final Trade [][] itb,
				       final int [] itbsize,
				       final NkQVMMonomials ref)
{
    final int nvm=1,npm=3,nmoms=2*neq-1;
    final QVMData [] o=new QVMData [itb.length];
    for(int k=0;k<itb.length;k++)
    {
	o[k]=QVMData.calculateQVMData(nvm,
				      nmoms,
				      npm,
				      currenttime,
				      tau,
				      itb[k],
				      itbsize[k],
				      ref!=null?ref.idata[k]:null);
    }
    return new NkQVMMonomials(neq,o);
}

public static NkQVMMonomials calculate1(final int neq,
				       final long currenttime,
				       final long tau,
				       final Trade [] tb,
				       final int tsize,
				       final NkQVMMonomials ref)
{
    return calculate(neq,currenttime,tau,new Trade [][]{tb},new int []{tsize},ref);
}

@Override
boolean isDiagQQt(){return false;}
DeprecatedHelperQVMDataDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataDirectAccessWithBasis();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}
double getPOffset(final QVMData odata){return odata.p_offset;}


static class NkQVMMonomialsTest extends NkQVMTest<QVMData> {
NkQVMMonomialsTest(final long initrandom)
{
    super("NkQVMMonomials",new java.util.Random(initrandom),1e-3);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
NkQVMMonomials getNkQVM1(){return calculate(neq,currenttime,tau,new Trade [][]{tdata[0]},new int []{tdata[0].length},null);}
MkQVMMonomials getMkQVM(){return MkQVMMonomials.calculate(neq,currenttime,tau,tdata[0],tdata[0].length,null);}

} // END of class NkQVMMonomialsTest

public static void main(String [] args)
{
    new NkQVMMonomialsTest(9082900L).runTests(4);
} // END main



} // END OF class NkQVMMonomials
