package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLaguerreBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: OkQVMLaguerre.java,v 1.10 2022/07/10 10:41:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class OkQVMLaguerre extends OkQVM<QVMDataL> {
OkQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}


public static OkQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final OkQVMLaguerre ref)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new OkQVMLaguerre(neq,o);
}
@Override
boolean isEdgeAtRight(){return false;}
QVMDataLDirectAccess getAccess(){return new QVMDataLDirectAccess();}
OrthogonalPolynomialsLaguerreBasis getABasis(){return new OrthogonalPolynomialsLaguerreBasis();}
double getX0(){return 0;}
double [] getEDPsi(final double [] psi){return WIntegratorLaguerre.getEDPsi(psi);}

static class OkQVMLaguerreTest extends OkQVMTest<QVMDataL> {
OkQVMLaguerreTest(final long initrandom)
{
    super("OkQVMLaguerre",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLaguerre.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
OkQVMLaguerre getOkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class OkQVMLaguerreTest

public static void main(String [] args)
{
    new OkQVMLaguerreTest(1951117L).runTests(5);
} // END main



} // END OF class OkQVMLaguerre
