package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: OkQVMLegendreShifted.java,v 1.9 2022/07/10 10:41:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class OkQVMLegendreShifted extends OkQVM<QVMDataP> {
OkQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static OkQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final OkQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new OkQVMLegendreShifted(neq,o);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getX0(){return 1;}
double [] getEDPsi(final double [] psi){return WIntegratorLegendreShifted.getEDPsi(psi);}

static class OkQVMLegendreShiftedTest extends OkQVMTest<QVMDataP> {
OkQVMLegendreShiftedTest(final long initrandom)
{
    super("OkQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
OkQVMLegendreShifted getOkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class OkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new OkQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class OkQVMLegendreShifted
