package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: OkQVMMonomials.java,v 1.8 2022/07/10 10:41:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class OkQVMMonomials extends OkQVM<QVMData> {
OkQVMMonomials(final int neq,final QVMData odata){super(neq,odata);}


public static OkQVMMonomials calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final OkQVMMonomials ref)
{
    final int nvm=1,npm=3;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     2*(neq-1)+1,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new OkQVMMonomials(neq,o);
}
QVMDataDirectAccess getAccess(){return new QVMDataDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}
double getX0(){return 0;}
double [] getEDPsi(final double [] psi){return WIntegratorMonomials.getEDPsi(psi);}

static class OkQVMMonomialsTest extends OkQVMTest<QVMData> {
OkQVMMonomialsTest(final long initrandom)
{
    super("OkQVMMonomials",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
OkQVMMonomials getOkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class OkQVMMonomialsTest

public static void main(String [] args)
{
    new OkQVMMonomialsTest(1117L).runTests(5);
} // END main



} // END OF class OkQVMMonomials
