package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: PkQVMLegendreShifted.java,v 1.8 2022/07/10 10:41:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class PkQVMLegendreShifted extends PkQVM<QVMDataP> {
PkQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static PkQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final PkQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new PkQVMLegendreShifted(neq,o);
}
DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getX0(){return 1;}
double getPOffset(){return odata.p_offset;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
double getK2(final double [] a,final double [] aa,final double [] b,final double [] bb){return KkQVMLegendreShifted._getK2(a,aa,b,bb);}

static class PkQVMLegendreShiftedTest extends PkQVMTest<QVMDataP> {
PkQVMLegendreShiftedTest(final long initrandom)
{
    super("PkQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
PkQVMLegendreShifted getPkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
DkQVMLegendreShifted getDkQVM(){return DkQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class PkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new PkQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class PkQVMLegendreShifted
