package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.EVXData;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;

/** Volatility variation and infinitesimal shit.
 *  @version $Id: PkxVol.java,v 1.11 2020/09/27 20:33:17 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class PkxVol {
final EVXData P2;
final double x,varX;

PkxVol(final int n,final double [] p0mom,final double [] p1mom,final double [] p2mom,final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M)
{
    //System.err.println("p0mom="+java.util.Arrays.toString(p0mom));
    //System.err.println("p2mom="+java.util.Arrays.toString(p2mom));
    final double [] QQp0=M.B.getQQMatr(n,p0mom),QQp1=M.B.getQQMatr(n,p1mom),QQp2=M.B.getQQMatr(n,p2mom),QQp0x=M.B.getQQMatr(n,M.B.getXQkMomentsFromQkMoments(p0mom));
    this.P2=EVXData.getEVXDataFromQQ(n,QQp2,QQp0,M);
    final double [] psi=this.P2.getPsi(0),pert=DeprecatedHelperEVXData.getPsiPertr(P2,0,QQp1);
    this.x=TMatr.getAMatrA(psi,QQp0x,n);
    this.varX=TMatr.getAMatrB(psi,pert,QQp0x,n);
}

static void match2(final PkxVol a,final PkxVol b,final double signtox,final double eps)
{
    EVXData.matchEVXData(a.P2,b.P2,false,true,eps);
    UnitTests.checkDoubleRel(a.varX,"a.varX",b.varX*signtox,"b.varX*signtox",eps);
    UnitTests.checkDoubleRel(a.x,"a.x",b.x*signtox,"b.x*signtox",eps);

    System.err.println("PkxVol:match2(): test OK n="+a.P2.neq+" eps="+eps);
}

} // END OF class PkxVol
