package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLaguerreBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: PnLImpactALaguerre.java,v 1.2 2018/04/30 19:15:46 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class PnLImpactALaguerre extends PnLImpactA<QVMDataL> {
PnLImpactALaguerre(final int neq,final QVMDataL odata,final State rst){super(neq,odata,rst);}


public static PnLImpactALaguerre calculate(final int neq,
					  final long currenttime,
					  final long tau,
					  final Trade [] tb,
					  final int tsize,
					  final PnLImpactALaguerre ref)
{
    final int npm=4,nr=0;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*(neq-1)+1+nr,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new PnLImpactALaguerre(neq,o,ref!=null?ref.sst:null);
}
QVMDataLDirectAccess getAccess(){return new QVMDataLDirectAccess();}
OrthogonalPolynomialsLaguerreBasis getABasis(){return new OrthogonalPolynomialsLaguerreBasis();}



} // END OF class PnLImpactALaguerre
