package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: PnLImpactALegendreShifted.java,v 1.2 2018/04/30 19:15:46 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class PnLImpactALegendreShifted extends PnLImpactA<QVMDataP> {

PnLImpactALegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}

public static PnLImpactALegendreShifted calculate(final int neq,
						 final long currenttime,
						 final long tau,
						 final Trade [] tb,
						 final int tsize,
						 final PnLImpactALegendreShifted ref)
{
    final int npm=4,nr=0;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1+nr,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new PnLImpactALegendreShifted(neq,o,ref!=null?ref.sst:null);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}

} // END OF class PnLImpactALegendreShifted
