package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: PnLImpactAMonomials.java,v 1.2 2018/04/30 19:15:46 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class PnLImpactAMonomials extends PnLImpactA<QVMData> {
PnLImpactAMonomials(final int neq,final QVMData odata,final State rst){super(neq,odata,rst);}


public static PnLImpactAMonomials calculate(final int neq,
					   final long currenttime,
					   final long tau,
					   final Trade [] tb,
					   final int tsize,
					   final PnLImpactAMonomials ref)
{
    final int nvm=1,npm=4,nr=0;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     2*(neq-1)+1+nr,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new PnLImpactAMonomials(neq,o,ref!=null?ref.sst:null);
}
QVMDataDirectAccess getAccess(){return new QVMDataDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}


} // END OF class PnLImpactAMonomials
