package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2016
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: PnLImpactA_pi.java,v 1.2 2018/04/30 19:15:46 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class PnLImpactA_pi extends PnLImpactA<QVMDataL> {
PnLImpactA_pi(final int neq,final QVMDataL odata,final State rst){super(neq,odata,rst);}

public static PnLImpactA_pi calculate(final int neq,
					   final long currenttime,
					   final long tau,
					   final Trade [] tb,
					   final int tsize,
					   final PnLImpactA_pi ref)
{
    final int ntm=1,npm=2*neq+2;
    final QVMDataL o=QVMDataL.calculateQVMDataL(ntm,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new PnLImpactA_pi(neq,o,ref!=null?ref.sst:null);
}
@Override
protected JMomentsData getJMomentsData(final int n){return JMomentsData.get_PriceMonomials_JMomentsData(n,odata,getAccess());}
QVMDataLDirectAccess getAccess(){return new QVMDataLDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){
    return new OrthogonalPolynomialsMonomialsBasisX(1,-getAccess().getPLast(odata)); // getPLast does have p_offset included
}



} // END OF class PnLImpactA_pi
