package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */

import com.polytechnik.utils.UnitTests;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: QVMDLegendreShifted.java,v 1.5 2019/01/06 23:50:31 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class QVMDLegendreShifted extends QVMD {

private final DeprecatedHelperLegendreShiftedBasis odata;
QVMDLegendreShifted(final DeprecatedHelperLegendreShiftedBasis basis)
{
    super(basis);
    this.odata=basis;
}

public static QVMDLegendreShifted calculate(final int neq_t,
				     final long currenttime,
				     final long tau,
				     final Trade [] tb,
				     final int tsize,
				     final QVMDLegendreShifted ref)
{
    final DeprecatedHelperLegendreShiftedBasis o=
	DeprecatedHelperLegendreShiftedBasis.calculateBasis(neq_t,
					    3,
					    currenttime,
					    tau,
					    tb,
					    tsize,
					    ref!=null?ref.odata:null);
    return new QVMDLegendreShifted(o);
}
public static QVMDLegendreShifted calculateBS(final int neq_t,
					      final long currenttime,
					      final long tau,
					      final Trade [] tb,
					      final int tsize,
					      final QVMDLegendreShifted ref)
{
    final DeprecatedHelperLegendreShiftedBasis o=
	DeprecatedHelperLegendreShiftedBasis.calculateBasis(neq_t,
					    3,
					    currenttime,
					    tau,
					    tb,
					    tsize,
					    ref!=null?ref.odata:null);
    return new QVMDLegendreShifted(getBS(o));
}
private static DeprecatedHelperLegendreShiftedBasis getBS(final DeprecatedHelperLegendreShiftedBasis o)
{
    return new DeprecatedHelperLegendreShiftedBasis(o.odata){
	public void setI(final double [] i){super.setIBS(i);}
	public void setIPn(final double [] i,final int n){if(n>0) throw new RuntimeException();this.setI(i);}};
}



public static void main(String [] args)
{
  for(int t=0;t<2;t++)
  {
      final int f=t;
      new QVMDTest("QVMDLegendreShifted:"+(f==0?"V":"BS"),1e-6,1e-3){
	QVMDLegendreShifted getQVMD(final int tsize,final int ntm,final int npm,final java.util.Random r)
	{
	    final Trade [] tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
	    final long currenttime=tb[tb.length-1].time+1000;
	    final long tau=(tb[tb.length-1].time-tb[0].time)/15;
	    if(f<=0) return QVMDLegendreShifted.calculate(ntm,currenttime,tau,tb,tsize,null);
	    else return QVMDLegendreShifted.calculateBS(ntm,currenttime,tau,tb,tsize,null);
	}
    }.runTests();
  }
}

}


