package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */

/** Polynomail access basis in price space.
 *  @version $Id: QVMDataBMPDirectAccessBook.java,v 1.8 2019/04/04 16:50:52 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class QVMDataBMPDirectAccessBook implements DataInterfaceDirectBookPrices<QVMDataBMP> {

public void setM(final double [] m,final int neq_t,final int mom,final QVMDataBMP odata,final int nmoms)
{
    if(nmoms>odata.npm||neq_t>1) throw new IllegalArgumentException("nmoms="+nmoms+" odata.npm="+odata.npm+" neq_t="+neq_t);


    final double [] abc;
    if((mom==M_V||mom==M_EV) && neq_t==0) abc=odata.vmoments_x_p;
    else if(mom==M_V && neq_t==1) abc=odata.tvmoments_x_p;
    else if(mom==M_EV && neq_t==1) abc=odata.etvmoments_x_p;
    else throw new RuntimeException("mom="+mom+" is not allowed for neq_t="+neq_t);
    for(int k=0;k<nmoms;k++){m[k]=abc[k];}
}

public double getPOffset(final QVMDataBMP odata){return odata.p_offset;}
public double getPLast(final QVMDataBMP odata){return Double.NaN;}
public long getTLast(final QVMDataBMP odata){return odata.currenttime;}
public long getTau(final QVMDataBMP odata){return odata.tau;}
public long getTotalVolume(final QVMDataBMP odata){return odata.vol;}


public void setMT(final double [] m,final int nmoms)
{
    throw new IllegalArgumentException("Make no sense for book");
}

public OrthogonalPolynomialsMonomialsBasisX getABasis(){
    return new OrthogonalPolynomialsMonomialsBasisX(1,0);
}

}
