package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.realtimebook.*;
import com.polytechnik.utils.UnitTests;

/** Book in price space.
 *  @version $Id: QVMFQVMDataBL.java,v 1.6 2019/01/06 23:56:14 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class QVMFQVMDataBL extends QVMF<QVMDataBL> {

QVMFQVMDataBL(final int neq,final QVMDataBL odata_buy,final QVMDataBL odata_sell){super(neq,odata_buy,odata_sell);}

double getPOffset(final QVMDataBL odata){return odata.p_offset;}
double getPEdge(final QVMDataBL odata){return odata.edge!=null?odata.edge.price:Double.NaN;}
DeprecatedHelperQVMDataBLpDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataBLpDirectAccessWithBasis();}

public static QVMFQVMDataBL calculate(final int neq,
				      final long currenttime,
				      final long tau,
				      final BookItem [] buy,
				      final int buysize,
				      final BookItem [] sell,
				      final int sellsize)
{
    final int ntm=1,npm=2*neq-1;
    final QVMDataBL obuy=QVMDataBL.calculateQVMDataBL(ntm,npm,
						      currenttime,
						      tau,
						      buy,
						      buysize),
	osell=QVMDataBL.calculateQVMDataBL(ntm,npm,
					   currenttime,
					   tau,
					   sell,
					   sellsize);
    return new QVMFQVMDataBL(neq,obuy,osell);
}


static class QVMFQVMDataBLTest extends QVMFTest<QVMDataBL> {
QVMFQVMDataBLTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
long getTau()
{
    final long a=(tbuy[tbuy.length-1].time-tbuy[0].time)/24,
	b=(tsell[tsell.length-1].time-tsell[0].time)/24;
    return Math.max(a,b);
}
QVMFQVMDataBL getQVMF(){return calculate(neq,currenttime,tau,tbuy_byp,tbuy_byp.length,tsell_byp,tsell_byp.length);}

} // END of class QVMFQVMDataBLTest

public static void main(String [] args)
{
    new QVMFQVMDataBLTest("QVMFQVMDataBL").runTests(5);
} // END main



} // END of class QVMFQVMDataBL
