package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: RkQVMLegendreShifted.java,v 1.7 2022/07/10 10:41:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class RkQVMLegendreShifted extends RkQVM<QVMDataP> {
RkQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static RkQVMLegendreShifted calculate(final int neq,
					     final long currenttime,
					     final long tau,
					     final Trade [] tb,
					     final int tsize,
					     final RkQVMLegendreShifted ref)
{
    final int npm=4;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new RkQVMLegendreShifted(neq,o);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getPOffset(){return odata.p_offset;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}


static class RkQVMLegendreShiftedTest extends RkQVMTest<QVMDataP> {
RkQVMLegendreShiftedTest(final long initrandom)
{
    super("RkQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
RkQVMLegendreShifted getRkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class RkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new RkQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class RkQVMLegendreShifted
