package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: RkQVMMonomials.java,v 1.2 2015/07/23 06:31:28 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class RkQVMMonomials extends RkQVM<QVMData> {
RkQVMMonomials(final int neq,final QVMData odata){super(neq,odata);}


public static RkQVMMonomials calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final RkQVMMonomials ref)
{
    final int nvm=1,npm=4;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     2*(neq-1)+1,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new RkQVMMonomials(neq,o);
}
QVMDataDirectAccess getAccess(){return new QVMDataDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}
double getPOffset(){return odata.p_offset;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}

static class RkQVMMonomialsTest extends RkQVMTest<QVMData> {
RkQVMMonomialsTest(final long initrandom)
{
    super("RkQVMMonomials",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
RkQVMMonomials getRkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class RkQVMMonomialsTest

public static void main(String [] args)
{
    new RkQVMMonomialsTest(1117L).runTests(5);
} // END main



} // END OF class RkQVMMonomials
