package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: RkiQVMLegendreShifted.java,v 1.9 2022/07/10 10:41:22 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class RkiQVMLegendreShifted extends RkiQVM<QVMDataP> {

RkiQVMLegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}

public static RkiQVMLegendreShifted calculate(final int neq,
					      final long currenttime,
					      final long tau,
					      final Trade [] tb,
					      final int tsize,
					      final RkiQVMLegendreShifted ref)
{
    final int npm=4;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1+2,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new RkiQVMLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double [] getEDPsi(final double [] psi){return WIntegratorLegendreShifted.getEDPsi(psi);}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
double getPOffset(){return odata.p_offset;}


static class RkiQVMLegendreShiftedTest extends RkiQVMTest<QVMDataP> {
RkiQVMLegendreShiftedTest(final long initrandom)
{
    super("RkiQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
RkiQVMLegendreShifted getRkiQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
YpnlQVMLegendreShifted getYpnlQVM(){return YpnlQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class RkiQVMLegendreShiftedTest

public static void main(String [] args)
{
    new RkiQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class RkiQVMLegendreShifted
