package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */

/** Save state.
 *  @version $Id: SMMXStateSaver.java,v 1.2 2014/07/29 20:45:41 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class SMMXStateSaver {

    public final SMMStateSaver.SMM L,H;
    private final int from;

    private static final int F_LOW=3891,F_HIGH=3892,F_NONE=3893;

    SMMXStateSaver(final SMMStateSaver.SMM L,final SMMStateSaver.SMM H,final int from)
    {
	this.L=L;
	this.H=H;
	this.from=from;
    }

    public static SMMXStateSaver getHighUpdate(final double I,final double p,final long t,final double F,final long U,final long V,final SMMXStateSaver rr)
    {
	final SMMXStateSaver r=getNothingUpdate(p,rr);
	if(r.from!=F_HIGH || (r.from==F_HIGH && !(I<r.H.Ic)))
	{
	    final SMMStateSaver.SMM h=new SMMStateSaver.SMM(I,p,t,F,U,V);
	    h.updatePcMM(r.L.PcMin);
	    h.updatePcMM(r.L.PcMax);
	    return new SMMXStateSaver(r.L,h,F_HIGH);
	}
	return r;
    }

    public static SMMXStateSaver getLowUpdate(final double I,final double p,final long t,final double F,final long U,final long V,final SMMXStateSaver rr)
    {
	final SMMXStateSaver r=getNothingUpdate(p,rr);
	if(r.from!=F_LOW || (r.from==F_LOW && !(I>r.L.Ic)))
	    return new SMMXStateSaver(new SMMStateSaver.SMM(I,p,t,F,U,V),r.H,F_LOW); // also resets min/max for L
	return r;
    }

    public static SMMXStateSaver getNothingUpdate(final double p,final SMMXStateSaver rr)
    {
	final SMMXStateSaver r=rr!=null?rr:new SMMXStateSaver(SMMStateSaver.SMM.EMPTY,SMMStateSaver.SMM.EMPTY,F_NONE);
	r.L.updatePcMM(p);
	return r;
    }
}
