package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */

import com.polytechnik.utils.UnitTests;
import com.polytechnik.realtimebook.*;

/** SPIMin in Laguerre basis.
 *  @version $Id: SPIMinLaguerre.java,v 1.10 2019/01/06 23:50:31 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class SPIMinLaguerre extends SPIMin {

SPIMinLaguerre(final int neq_t,final int neq_p,final QVMDataL odata)
{
    super(neq_t,neq_p,new DeprecatedHelperLaguerreBasis(odata));
}


public static void main(String [] args)
{
    new SPIMinTest<QVMDataL>("SPIMinLaguerre",1e-6,1e-3){
	QVMDataL getData(final int tsize,final int ntm,final int npm,final java.util.Random r)
	{
	    final Trade [] tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
	    final long currenttime=tb[tb.length-1].time+1000;
	    final long tau=(tb[tb.length-1].time-tb[0].time)/24;
	    final QVMDataL o=QVMDataL.calculateQVMDataL(ntm,
							npm,
							currenttime,
							tau,
							tb,
							tsize,
							null);
	    return o;
	}
	SPIMinLaguerre getSPIMin(final int neq_t,final int neq_p,final QVMDataL o)
	{
	    return new SPIMinLaguerre(neq_t,neq_p,o);
	}
    }.runTests();
}

}


