package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */

import com.polytechnik.utils.UnitTests;
import com.polytechnik.realtimebook.*;

/** SPIMin in LegendreShifted basis.
 *  @version $Id: SPIMinLegendreShifted.java,v 1.6 2019/01/06 23:50:31 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class SPIMinLegendreShifted extends SPIMin {

SPIMinLegendreShifted(final int neq_t,final int neq_p,final QVMDataP odata)
{
    super(neq_t,neq_p,new DeprecatedHelperLegendreShiftedBasis(odata));
}


public static void main(String [] args)
{
    new SPIMinTest<QVMDataP>("SPIMinLegendreShifted",1e-6,1e-3){
	QVMDataP getData(final int tsize,final int ntm,final int npm,final java.util.Random r)
	{
	    final Trade [] tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
	    final long currenttime=tb[tb.length-1].time+1000;
	    final long tau=(tb[tb.length-1].time-tb[0].time)/15;
	    final QVMDataP o=QVMDataP.calculateQVMDataP(ntm,
							npm,
							currenttime,
							tau,
							tb,
							tsize,
							null);
	    return o;
	}
	SPIMinLegendreShifted getSPIMin(final int neq_t,final int neq_p,final QVMDataP o)
	{

	    return new SPIMinLegendreShifted(neq_t,neq_p,o);
	}
    }.runTests();
}

}


