package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2020
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.OrthogonalPolynomialsLaguerreBasis;
import com.polytechnik.freemoney.*;

/**
 * @version $Id: SimpleSupportPriceLaguerre.java,v 1.5 2022/07/28 07:29:40 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
*/
public class SimpleSupportPriceLaguerre extends SimpleSupportPrice {


public SimpleSupportPriceLaguerre(final int n,final long tau){super(n,tau);}


// ========= Basis hooks
@Override OrthogonalPolynomialsLaguerreBasis getABasis(){return new OrthogonalPolynomialsLaguerreBasis();}
@Override double [] getTMoments(final int nmoms){
    final double [] tmom=new double [nmoms];
    // One may copy a one line method from QVMDataLDirectAccess.java to avoid dependency.
    //tmom[0]=1;
    new QVMDataLDirectAccess().setMT(tmom,nmoms);
    return tmom;
}
@Override double [] getPsi2WIntegratedDt(final double [] psi){return WIntegratorLaguerre.getPsi2WIntegratedDt(psi);}
@Override WIntegratorLaguerre getEmptyWIntegrator(final int nfields){return new WIntegratorLaguerre(2*n-1,tau,nfields);}
}
