package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2020
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.freemoney.*;

/**
 * @version $Id: SimpleSupportPriceLegendreShifted.java,v 1.5 2022/07/28 07:29:40 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
*/
public class SimpleSupportPriceLegendreShifted extends SimpleSupportPrice {


public SimpleSupportPriceLegendreShifted(final int n,final long tau){super(n,tau);}


// ========= Basis hooks
@Override OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
@Override double [] getTMoments(final int nmoms){
    final double [] tmom=new double [nmoms];
    // One may copy a one line method from QVMDataPDirectAccess.java to avoid dependency.
    //tmom[0]=1;
    new QVMDataPDirectAccess().setMT(tmom,nmoms);
    return tmom;
}
@Override double [] getPsi2WIntegratedDt(final double [] psi){return WIntegratorLegendreShifted.getPsi2WIntegratedDt(psi);}
@Override WIntegratorLegendreShifted getEmptyWIntegrator(final int nfields){return new WIntegratorLegendreShifted(2*n-1,tau,nfields);}
}
