package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2020
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.freemoney.*;

/**
 * @version $Id: SimpleSupportPriceMonomials.java,v 1.5 2022/07/28 07:29:40 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
*/
public class SimpleSupportPriceMonomials extends SimpleSupportPrice {


public SimpleSupportPriceMonomials(final int n,final long tau){super(n,tau);}


// ========= Basis hooks
@Override OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}
@Override double [] getTMoments(final int nmoms){
    final double [] tmom=new double [nmoms];
    // One may copy a one line method from QVMDataDirectAccess.java to avoid dependency.
    //double f=1;for(int k=0;k<nmoms;++k,f*=(-k))tmom[k]=f;
    new QVMDataDirectAccess().setMT(tmom,nmoms);
    return tmom;
}
@Override double [] getPsi2WIntegratedDt(final double [] psi){return WIntegratorMonomials.getPsi2WIntegratedDt(psi);}
@Override WIntegratorMonomials getEmptyWIntegrator(final int nfields){return new WIntegratorMonomials(2*n-1,tau,nfields);}
}
