package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLaguerreBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: SkQVMLaguerre.java,v 1.6 2022/07/10 10:41:23 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class SkQVMLaguerre extends SkQVM<QVMDataL> {
SkQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}


public static SkQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final SkQVMLaguerre ref)
{
    final int npm=4;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new SkQVMLaguerre(neq,o);
}
DeprecatedHelperQVMDataLDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataLDirectAccessWithBasis();}
OrthogonalPolynomialsLaguerreBasis getABasis(){return new OrthogonalPolynomialsLaguerreBasis();}


static class SkQVMLaguerreTest extends SkQVMTest<QVMDataL> {
SkQVMLaguerreTest(final long initrandom)
{
    super("SkQVMLaguerre",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLaguerre.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
SkQVMLaguerre getSkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class SkQVMLaguerreTest

public static void main(String [] args)
{
    new SkQVMLaguerreTest(1951117L).runTests(5);
} // END main



} // END OF class SkQVMLaguerre
