package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: SkQVMLegendreShifted.java,v 1.6 2022/07/10 10:41:23 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class SkQVMLegendreShifted extends SkQVM<QVMDataP> {
SkQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static SkQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final SkQVMLegendreShifted ref)
{
    final int npm=4;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new SkQVMLegendreShifted(neq,o);
}
DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}


static class SkQVMLegendreShiftedTest extends SkQVMTest<QVMDataP> {
SkQVMLegendreShiftedTest(final long initrandom)
{
    super("SkQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
SkQVMLegendreShifted getSkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class SkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new SkQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class SkQVMLegendreShifted
