package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: SkQVMMonomials.java,v 1.2 2019/01/06 23:39:13 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class SkQVMMonomials extends SkQVM<QVMData> {
SkQVMMonomials(final int neq,final QVMData odata){super(neq,odata);}


public static SkQVMMonomials calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final SkQVMMonomials ref)
{
    final int nvm=1,npm=4;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     2*(neq-1)+1,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new SkQVMMonomials(neq,o);
}
DeprecatedHelperQVMDataDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataDirectAccessWithBasis();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}

static class SkQVMMonomialsTest extends SkQVMTest<QVMData> {
SkQVMMonomialsTest(final long initrandom)
{
    super("SkQVMMonomials",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
SkQVMMonomials getSkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class SkQVMMonomialsTest

public static void main(String [] args)
{
    new SkQVMMonomialsTest(1117L).runTests(5);
} // END main



} // END OF class SkQVMMonomials
