package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2014
 * This file is under GPL version 3.
 *
 */

/** Save state.
 *  @version $Id: StateSaver2.java,v 1.7 2018/03/14 14:35:15 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class StateSaver2<T extends State2> {
    public static final int CALLF_H=88,CALLF_L=89,CALLF_NONE=90;

    public final long seq;
    public final T s_IL,s_IH,s_IL_before_IH;
    public final int callFrom;
    public StateSaver2(final long seq,
		       final T s_IL,final T s_IH,final T s_IL_before_IH,
		       final int callFrom)
    {
	this.seq=seq;
	this.s_IL=s_IL;this.s_IH=s_IH;this.s_IL_before_IH=s_IL_before_IH;
	this.callFrom=callFrom;
    }
    public StateSaver2<T> getUpdatedIH(T s)
    {
	final T sH;
	if(s_IH==null||callFrom!=CALLF_H) sH=s;
	else if(s.I>=s_IH.I) sH=s;
	else if(s_IL!=null) sH=s; // was IL event
	else sH=s_IH;
	return new StateSaver2<T>(1+seq,null,sH,s_IL!=null?s_IL:s_IL_before_IH,CALLF_H);
    }
    public StateSaver2<T> getUpdatedIL(T s)
    {
	final T prev,sL;
	if(s_IH==null) prev=null;
	else if(s_IL!=null && s_IH.t>=s_IL.t) prev=s_IL;
	else if(s_IL_before_IH!=null && s_IH.t>=s_IL_before_IH.t) prev=s_IL_before_IH;
	else prev=null;

	if(s_IL==null||callFrom!=CALLF_L) sL=s;
	else if(s.I<=s_IL.I) sL=s;
	else if(false) sL=s;
	else sL=s_IL;
	return new StateSaver2<T>(1+seq,sL,s_IH,prev,CALLF_L);
    }
    public StateSaver2<T> getUpdatedNothing()
    {
	return new StateSaver2<T>(1+seq,s_IL,s_IH,s_IL_before_IH,CALLF_NONE);
    }
    public static <T extends State2> StateSaver2<T> getDefault(){
	return new StateSaver2<T>(0,null,null,null,CALLF_NONE);
    }

}
