package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** An attribute for ML program.
 *  @version $Id: StringAttributes.java,v 1.12 2009/05/24 09:54:03 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class StringAttributes {
    private static final boolean PRG_DEBUG=false;

    private int n_values=0;
    private String [] attribute_values=new String [100];

    void clearData()
    {
	if(PRG_DEBUG)
	{
	    System.err.println("StringAttributes::cleared="+this.n_values);
	}
	this.n_values=0;
	java.util.Arrays.fill(this.attribute_values,null);
    }

    static String [] ensureArrCapacity(final int n,final String [] arr,final int s)
    {
	if(s<=arr.length)
	{
	    throw new IllegalArgumentException("Try to catch wrong usage");
	}
	//final int s=1+2*arr.length;
	final String [] newvalues=new String [s];
	System.arraycopy(arr,0,newvalues,0,n);
	if(PRG_DEBUG)
	{
	    System.err.println("StringAttributes::NEWSIZE="+s);
	}
	return newvalues;
    }

    int getNValues()
    {
	return this.n_values;
    }

    void addValue(final String n)
    {
	if(this.n_values>=this.attribute_values.length)
	{
	    this.attribute_values=ensureArrCapacity(this.n_values,this.attribute_values,1+2*this.attribute_values.length);
	}
	this.attribute_values[this.n_values++]=n;
    }

    String [] getDataCopy()
    {
	final String [] dcpy=new String [this.n_values];
	System.arraycopy(this.attribute_values,0,dcpy,0,this.n_values);
	return dcpy;
    }

    String [] getInternalBuffer()
    {
	return this.attribute_values;
    }

}
