package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2008
 * This file is under GPL version 3.
 *
 */


/** An attribute for ML program.
 *  @version $Id: StringAttributesWithDescription.java,v 1.3 2009/05/24 09:54:03 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class StringAttributesWithDescription extends StringAttributes {

    private final String default_descr;
    private String [] attribute_descrs;
    private String [] attribute_tag;
    StringAttributesWithDescription(final String default_descr)
    {
	this.default_descr=default_descr;
	this.attribute_descrs=new String [getInternalBuffer().length];
	this.attribute_tag=new String [this.attribute_descrs.length];
    }

    void clearData()
    {
	super.clearData();
	java.util.Arrays.fill(this.attribute_descrs,null);
	java.util.Arrays.fill(this.attribute_tag,null);
    }

    void addValue(final String n)
    {
	addValue(n,"",this.default_descr);
    }


    void addValue(final String prefix,final String suffix,final String descr)
    {
	final int p=getNValues();
	super.addValue(prefix+suffix);
	if(p>=this.attribute_descrs.length)
	{
	    this.attribute_descrs=ensureArrCapacity(p,this.attribute_descrs,1+2*this.attribute_descrs.length);
	    this.attribute_tag=ensureArrCapacity(p,this.attribute_tag,1+2*this.attribute_tag.length);
	}
	if(descr!=null)
	{
	    this.attribute_descrs[p]=descr;
	}
	else
	{
	    this.attribute_descrs[p]=this.default_descr;
	}
	this.attribute_tag[p]=prefix;
    }

    String [] getDescriptionBuffer()
    {
	return this.attribute_descrs;
    }
}
