package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.OrthogonalPolynomialsLaguerreBasis;
import com.polytechnik.realtimebook.*;

public class TQVMLaguerre extends TQVM<QVMDataL> {

TQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}

public static TQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final TQVMLaguerre ref)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*neq-1+2,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new TQVMLaguerre(neq,o);
}

QVMDataLDirectAccess getAccess(){return new QVMDataLDirectAccess();}
OrthogonalPolynomialsLaguerreBasis getABasis(){return new OrthogonalPolynomialsLaguerreBasis();}


static class TQVMLaguerreTest extends TQVMTest<QVMDataL> {
TQVMLaguerreTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
void setData(final int tsize,final int neq)
{
    this.neq=neq;
    this.tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
    this.currenttime=tb[tb.length-1].time+1000;
    this.tau=(tb[tb.length-1].time-tb[0].time)/24;
}
TQVMLaguerre getTQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
ZQVMLaguerre getZQVM(){return ZQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}
ZVQVMLaguerre getZVQVM(){return ZVQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class TQVMLaguerreTest

public static void main(String [] args)
{
    new TQVMLaguerreTest("TQVMLaguerre").runTests(5);
} // END main



} // END OF class TQVMLaguerre
