package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.realtimebook.*;

public class TQVMLegendreShifted extends TQVM<QVMDataP> {

TQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static TQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final TQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*neq-1+2,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new TQVMLegendreShifted(neq,o);
}

QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}


static class TQVMLegendreShiftedTest extends TQVMTest<QVMDataP> {
TQVMLegendreShiftedTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
void setData(final int tsize,final int neq)
{
    this.neq=neq;
    this.tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
    this.currenttime=tb[tb.length-1].time+1;
    this.tau=((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8*11)*(9*5*7*8*11);
    //System.err.println("tau="+tau);
}
TQVMLegendreShifted getTQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
ZQVMLegendreShifted getZQVM(){return ZQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}
ZVQVMLegendreShifted getZVQVM(){return ZVQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class TQVMLegendreShiftedTest

public static void main(String [] args)
{
    new TQVMLegendreShiftedTest("TQVMLegendreShifted").runTests(5);
} // END main



} // END OF class TQVMLegendreShifted
