package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2017
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;
import com.polytechnik.utils.DiffSkewness;
import com.polytechnik.utils.DerivativesCalculateable;

/** A class to be used with SimpleRootsFinder.java
 * for calculating the point of given skewness.
 *  @version $Id: TargetSkewness.java,v 1.6 2020/09/27 20:33:21 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class TargetSkewness implements com.polytechnik.outils.DerivativesAtCalculateable {
public final double sk_target;
final DerivativesCalculateable skewness_calculator;
public TargetSkewness(final DiffSkewness skewness_calculator,final double sk_target)
{
    this.skewness_calculator=skewness_calculator.getGamma();
    this.sk_target=sk_target;
}
private double x;
public void calculateAt(final double x){this.x=x;}
public double getF(){return skewness_calculator.getF(x)-sk_target;}
public double getDF(){return skewness_calculator.getDF(x);}
}
