package com.polytechnik.trading;

import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;

/** Some unit test for DataInterfaceToMoments.
 *  @version $Id: Test_DataInterfaceToMoments.java,v 1.7 2019/03/17 10:42:43 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class Test_DataInterfaceToMoments {

    static void test_data(final int nmoms,final java.util.Random r,final int ntests,final double eps)
    {
      final java.util.ArrayList<DataInterfaceToMoments<?>> b=new java.util.ArrayList<>();
      b.add(new QVMDataDirectAccess());
      b.add(new QVMDataLDirectAccess());
      b.add(new QVMDataPDirectAccess());
      for(DataInterfaceToMoments<?> q:b)
      {
	final double [] v=new double [nmoms];
	final double [] v1=new double [nmoms];
	final double [] v2=new double [nmoms];
	for(int nt=0;nt<ntests;nt++)
	{
	for(int k=nmoms;--k>=0;)
	{
	    v[k]=r.nextDouble();
	}
	q.setFMoments(v1,v,nmoms);
	// historivcally DF has opposite sign
	q.setDFMoments(v2,v1,nmoms);
	UnitTests.checkDoubleArrayRel1(v,"v",TMatr.getVectorScaled(v2,-1),"-v2",eps);
	q.setDFMoments(v1,v,nmoms);
	q.setFMoments(v2,v1,nmoms);
	UnitTests.checkDoubleArrayRel1(v,"v",TMatr.getVectorScaled(v2,-1),"-v2",eps);
	}
	System.err.println("nmoms="+nmoms+" ntests="+ntests+" OK q="+q);
      }
    }




    public static void main(String [] args)
    {
	System.err.println("Test_DataInterfaceToMoments: starting tests; ver=$Id: Test_DataInterfaceToMoments.java,v 1.7 2019/03/17 10:42:43 mal Exp $");
	final long t0=System.currentTimeMillis();

	final double eps=1e-5;
	final java.util.Random r=new java.util.Random(123);
	for(int t=0;t<14;t++)
	{
	    test_data(t,r,10000,eps);
	}
	final long t1=System.currentTimeMillis();
	System.err.println("Test_DataInterfaceToMoments: tests OK done in "+(t1-t0)+" milliseconds. ver=$Id: Test_DataInterfaceToMoments.java,v 1.7 2019/03/17 10:42:43 mal Exp $");
    }
}
