package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: TkQVMLegendreShifted.java,v 1.12 2022/07/10 10:41:23 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class TkQVMLegendreShifted extends TkQVM<QVMDataP> {

TkQVMLegendreShifted(final int neq,final QVMDataP odata,final SState rst){super(neq,odata,rst);}

public static TkQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final TkQVMLegendreShifted ref)
{
    final int npm=4;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new TkQVMLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
long getTLast(){return odata.currenttime;}
long getSVol(){return odata.svol;}
long getVol(){return odata.vol;}
double getPOffset(){return odata.p_offset;}

static class TkQVMLegendreShiftedTest extends TkQVMTest<QVMDataP> {
TkQVMLegendreShiftedTest(final long initrandom)
{
    super("TkQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
TkQVMLegendreShifted getTkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class TkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new TkQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class TkQVMLegendreShifted
