package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2018
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: TstPnLILowIHighLegendreShifted.java,v 1.11 2022/07/28 07:29:40 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class TstPnLILowIHighLegendreShifted extends TstPnLILowIHigh<QVMDataP> {
TstPnLILowIHighLegendreShifted(final int neq,final QVMDataP odata,final TstPnLILowIHighStateSaverWithWI rst){super(neq,odata,rst);}


public static TstPnLILowIHighLegendreShifted calculate(final int neq,
					  final long currenttime,
					  final long tau,
					  final Trade [] tb,
					  final int tsize,
					  final TstPnLILowIHighLegendreShifted ref)
{

    final int npm=4,nmoms=2*neq-1;
    final QVMDataP o=QVMDataP.calculateQVMDataP(nmoms,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new TstPnLILowIHighLegendreShifted(neq,o,ref!=null?ref.sst:null);
}

@Override QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
@Override OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
@Override double [] getPsi2WIntegratedDt(final double [] psi){return WIntegratorLegendreShifted.getPsi2WIntegratedDt(psi);}
@Override WIntegratorLegendreShifted getEmptyWIntegrator(int dim){return new WIntegratorLegendreShifted(odata.ntm,odata.tau,dim);}
@Override double [] getEDPsi(final double [] psi){return WIntegratorLegendreShifted.getEDPsi(psi);}

static class TstPnLILowIHighLegendreShiftedTest extends PnLILowIHighTest<QVMDataP,TstPnLILowIHighLegendreShifted> {
TstPnLILowIHighLegendreShiftedTest(final long initrandom)
{
    super("TstPnLILowIHighLegendreShifted",new java.util.Random(initrandom),1e-6);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}

    TstPnLILowIHighLegendreShifted getTstPnLILowIHighWithThisRef(final int tsize_to,final long currenttime,final TstPnLILowIHighLegendreShifted ref){return calculate(neq,currenttime,tau,tb,tsize_to,ref);}

    PnLILowIHighTPVFactoryLegendreShifted getTPVFactory(){
	return new PnLILowIHighTPVFactoryLegendreShifted(neq,tau);
    }

} // END of class TstPnLILowIHighLegendreShiftedTest


public static void main(String [] args)
{
    new TstPnLILowIHighLegendreShiftedTest(7163L).runTests(2,7);
} // END main


}


