package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */

import com.polytechnik.utils.PolynomialsRatio;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;

/** Two Roots finder.
 *  @version $Id: TwoRootsNoDiv0.java,v 1.5 2020/09/27 20:33:21 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
class TwoRootsNoDiv0 extends PolynomialsRatio {
    TwoRootsNoDiv0(final double [] kt,final double [] f,final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M)
    {
	super(kt,f,M.B);
    }

    public double getF(final double x)
    {
	return Double.NaN;
    }
    public double getDF(final double x)
    {
	return super.getF(x);
    }
    public double getD2F(final double x)
    {
	return super.getDF(x);
    }
}
