package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: UMnQVMLegendreShifted.java,v 1.9 2022/07/10 10:41:23 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class UMnQVMLegendreShifted extends UMnQVM<QVMDataP> {
UMnQVMLegendreShifted(final int neq,final QVMDataP [] idata,final State rst){super(neq,idata,rst);}

public static UMnQVMLegendreShifted calculate(final int neq,
					      final long currenttime,
					      final long tau,
					      final Trade [][] itb,
					      final int [] itbsize,
					      final UMnQVMLegendreShifted ref)
{
    final int npm=2,nmoms=2*neq-1;
    final QVMDataP [] o=new QVMDataP [itb.length];
    for(int k=0;k<itb.length;k++)
    {
	o[k]=QVMDataP.calculateQVMDataP(nmoms,
					npm,
					currenttime,
					tau,
					itb[k],
					itbsize[k],
					ref!=null?ref.idata[k]:null);
    }
    return new UMnQVMLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
public static UMnQVMLegendreShifted calculate1(final int neq,
					       final long currenttime,
					       final long tau,
					       final Trade [] tb,
					       final int tsize,
					       final UMnQVMLegendreShifted ref)
{
    return calculate(neq,currenttime,tau,new Trade [][]{tb},new int []{tsize},ref);
}

QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getPOffset(final QVMDataP odata){return odata.p_offset;}
double getPLast(final QVMDataP odata){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
long getVolume(final QVMDataP odata){return odata.vol;}
long getTEnd(final QVMDataP odata){return odata.currenttime;}

static class UMnQVMLegendreShiftedTest extends UMnQVMTest<QVMDataP> {
UMnQVMLegendreShiftedTest(final long initrandom)
{
    super("UMnQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
UMnQVMLegendreShifted getUMnQVM(){return calculate(neq,currenttime,tau,tdata,tdata_size,null);}
NkQVMLegendreShifted getNkQVM(){return NkQVMLegendreShifted.calculate(neq,currenttime,tau,tdata,tdata_size,null);}

} // END of class UMnQVMLegendreShiftedTest

public static void main(String [] args)
{
    new UMnQVMLegendreShiftedTest(6221287L).runTests(5);
} // END main



} // END OF class UMnQVMLegendreShifted
