package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: UkQVMLegendreShifted.java,v 1.10 2022/07/10 10:41:23 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class UkQVMLegendreShifted extends UkQVM<QVMDataP> {

UkQVMLegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}

public static UkQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final UkQVMLegendreShifted ref)
{
    final int npm=2;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new UkQVMLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
long getTLast(){return odata.currenttime;}
long getSVol(){return odata.svol;}
long getVol(){return odata.vol;}
double getPOffset(){return odata.p_offset;}
double getK2(final double [] a,final double [] aa,final double [] b,final double [] bb){return KkQVMLegendreShifted._getK2(a,aa,b,bb);}
double [] getEDPsi(final double [] psi){return WIntegratorLegendreShifted.getEDPsi(psi);}

static class UkQVMLegendreShiftedTest extends UkQVMTest<QVMDataP> {
UkQVMLegendreShiftedTest(final long initrandom)
{
    super("UkQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
UkQVMLegendreShifted getUkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
TkQVMLegendreShifted getTkQVM(){return TkQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class UkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new UkQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class UkQVMLegendreShifted
