package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLaguerreBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: VkQVMLaguerre.java,v 1.8 2022/07/10 10:41:24 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class VkQVMLaguerre extends VkQVM<QVMDataL> {
VkQVMLaguerre(final int neq,final QVMDataL odata,final State rst){super(neq,odata,rst);}


public static VkQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final VkQVMLaguerre ref)
{
    final int npm=2;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new VkQVMLaguerre(neq,o,ref!=null?ref.sst:null);
}
QVMDataLDirectAccess getAccess(){return new QVMDataLDirectAccess();}
OrthogonalPolynomialsLaguerreBasis getABasis(){return new OrthogonalPolynomialsLaguerreBasis();}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
double getPOffset(){return odata.p_offset;}

static class VkQVMLaguerreTest extends VkQVMTest<QVMDataL> {
VkQVMLaguerreTest(final long initrandom)
{
    super("VkQVMLaguerre",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return WIntegratorLaguerre.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}
VkQVMLaguerre getVkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
double [] getEDPsi(final double [] psi){return WIntegratorLaguerre.getEDPsi(psi);}

} // END of class VkQVMLaguerreTest

public static void main(String [] args)
{
    new VkQVMLaguerreTest(1951117L).runTests(6);
} // END main



} // END OF class VkQVMLaguerre
