package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.OrthogonalPolynomialsMonomialsBasis;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: XkQVMMonomials.java,v 1.6 2022/07/10 10:41:24 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class XkQVMMonomials extends XkQVM<QVMData> {
XkQVMMonomials(final int neq,final QVMData odata,final State rst){super(neq,odata,rst);}


public static XkQVMMonomials calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final XkQVMMonomials ref)
{
    final int nvm=1,npm=2;
    final QVMData o=QVMData.calculateQVMData(nvm,
					     2*(neq-1)+1,
					     npm,
					     currenttime,
					     tau,
					     tb,
					     tsize,
					     ref!=null?ref.odata:null);
    return new XkQVMMonomials(neq,o,ref!=null?ref.sst:null);
}
QVMDataDirectAccess getAccess(){return new QVMDataDirectAccess();}
OrthogonalPolynomialsMonomialsBasis getABasis(){return new OrthogonalPolynomialsMonomialsBasis0();}
double getPOffset(){return odata.p_offset;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
double [] getEDPsi(final double [] psi){return WIntegratorMonomials.getEDPsi(psi);}

static class XkQVMMonomialsTest extends XkQVMTest<QVMData> {
XkQVMMonomialsTest(final long initrandom)
{
    super("XkQVMMonomials",new java.util.Random(initrandom),1e-4);
}
double [] convertToMonomials(final double [] p){return p;}

long getTau()
{
    return (tb[tb.length-1].time-tb[0].time)/24;
}


@Override
void test_Extra(){
    final XkQVMMonomials q=getXkQVM();
    final XkQVMLaguerre s=getXkQVMLaguerre();

    // FIXME

    System.err.println(name+":XkQVMMonomialsTest:test_Extra(): test XkQVMLaguerre OK neq="+neq+" eps="+eps);
}

XkQVMLaguerre getXkQVMLaguerre(){return XkQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}
XkQVMMonomials getXkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
UkQVMMonomials getUkQVM(){return UkQVMMonomials.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class XkQVMMonomialsTest

public static void main(String [] args)
{
    new XkQVMMonomialsTest(1117L).runTests(5);
} // END main



} // END OF class XkQVMMonomials
