package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.Laguerre;
import com.polytechnik.realtimebook.*;

public class YQVMLaguerre extends YQVM<QVMDataL> {

YQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}

public static YQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final YQVMLaguerre ref)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new YQVMLaguerre(neq,o);
}

DeprecatedHelperQVMDataLAccess getAccess(final int n){return new DeprecatedHelperQVMDataLAccess(n);}
double getTSL(){return XQVM.getTSL(odata.trade_last,odata.trade_last!=null?odata.trade_last.best_buy:null,odata.trade_last!=null?odata.trade_last.best_sell:null);}

static class YQVMLaguerreTest extends YQVMTest<QVMDataL> {
YQVMLaguerreTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
void setData(final int tsize,final int neq)
{
    this.neq=neq;
    this.tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
    this.currenttime=tb[tb.length-1].time+1000;
    this.tau=(tb[tb.length-1].time-tb[0].time)/24;
}
YQVMLaguerre getYQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
XQVMLaguerre getXQVM(){return XQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class YQVMLaguerreTest

public static void main(String [] args)
{
    new YQVMLaguerreTest("YQVMLaguerre").runTests(5);
} // END main



} // END OF class YQVMLaguerre
