package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.realtimebook.*;

public class YQVMLegendreShifted extends YQVM<QVMDataP> {

YQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static YQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final YQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new YQVMLegendreShifted(neq,o);
}

DeprecatedHelperQVMDataPAccess getAccess(final int n){return new DeprecatedHelperQVMDataPAccess(n);}
double getTSL(){return XQVM.getTSL(odata.trade_last,odata.trade_last!=null?odata.trade_last.best_buy:null,odata.trade_last!=null?odata.trade_last.best_sell:null);}


static class YQVMLegendreShiftedTest extends YQVMTest<QVMDataP> {
YQVMLegendreShiftedTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
void setData(final int tsize,final int neq)
{
    this.neq=neq;
    this.tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
    this.currenttime=tb[tb.length-1].time+1;
    this.tau=((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8*11)*(9*5*7*8*11);
    //System.err.println("tau="+tau);
}
YQVMLegendreShifted getYQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
XQVMLegendreShifted getXQVM(){return XQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class YQVMLegendreShiftedTest

public static void main(String [] args)
{
    new YQVMLegendreShiftedTest("YQVMLegendreShifted").runTests(5);
} // END main



} // END OF class YQVMLegendreShifted
