package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: YkDpILegendreShifted.java,v 1.5 2022/07/10 10:41:24 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class YkDpILegendreShifted extends YkDpI<QVMDataP> {

YkDpILegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}

public static YkDpILegendreShifted calculate(final int neq,
					     final long currenttime,
					     final long tau,
					     final Trade [] tb,
					     final int tsize,
					     final YkDpILegendreShifted ref)
{
    final int npm=2,nmoms=2*(2*(neq-1)+1)-1;
    final QVMDataP o=QVMDataP.calculateQVMDataP(nmoms,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new YkDpILegendreShifted(neq,o,ref!=null?ref.sst:null);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}
double getPOffset(){return odata.p_offset;}


static class YkDpILegendreShiftedTest extends YkDpITest<QVMDataP> {
YkDpILegendreShiftedTest(final long initrandom)
{
    super("YkDpILegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
YkDpILegendreShifted getYkDpI(){return calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class YkDpILegendreShiftedTest

public static void main(String [] args)
{
    new YkDpILegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class YkDpILegendreShifted
