package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.OrthogonalPolynomialsLegendreShiftedBasis;
import com.polytechnik.utils.TMatr;
import com.polytechnik.freemoney.*;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: YkQVMLegendreShifted.java,v 1.11 2022/07/10 10:41:24 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class YkQVMLegendreShifted extends YkQVM<QVMDataP> {

YkQVMLegendreShifted(final int neq,final QVMDataP odata,final State rst){super(neq,odata,rst);}

public static YkQVMLegendreShifted calculate(final int neq,
					     final long currenttime,
					     final long tau,
					     final Trade [] tb,
					     final int tsize,
					     final YkQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*(neq-1)+1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new YkQVMLegendreShifted(neq,o,ref!=null?ref.sst:null);
}
QVMDataPDirectAccess getAccess(){return new QVMDataPDirectAccess();}
OrthogonalPolynomialsLegendreShiftedBasis getABasis(){return new OrthogonalPolynomialsLegendreShiftedBasis();}
K2Distance getK2Distance(){return KkQVMLegendreShifted.K2DISTANCE;}
double getPLast(){return odata.trade_last!=null?odata.trade_last.price:Double.NaN;}

static class YkQVMLegendreShiftedTest extends YkQVMTest<QVMDataP> {
YkQVMLegendreShiftedTest(final long initrandom)
{
    super("YkQVMLegendreShifted",new java.util.Random(initrandom),1e-5);
}
double [] convertToMonomials(final double [] p){return WIntegratorLegendreShifted.B.convertFunctionTo_Monomials_from_Basis(p);}

long getTau()
{
    return ((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8)*(9*5*7*8);
}
YkQVMLegendreShifted getYkQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
UkQVMLegendreShifted getUkQVM(){return UkQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}
VkQVMLegendreShifted getVkQVM(){return VkQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class YkQVMLegendreShiftedTest

public static void main(String [] args)
{
    new YkQVMLegendreShiftedTest(162146L).runTests(7);
} // END main



} // END OF class YkQVMLegendreShifted
