package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2013
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.EVXData;
import com.polytechnik.utils.OrthogonalPolynomialsBasisFunctionsCalculatable;
import com.polytechnik.utils.BasisFunctionsCalculatable;
import com.polytechnik.utils.VolMatrix;
import com.polytechnik.realtimebook.*;

/**
 *  @version $Id: YpnlQVM.java,v 1.315 2022/11/19 11:08:58 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public abstract class YpnlQVM<DTYPE> {

static class State {
}
final State sst;

final DTYPE odata;
final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M=getABasis();
PsiIntegratedByInterval INTRV=getINTRV();
final VolMatrix VOLATILITY_EDPsi=this::getEDPsi;
final K2Distance DISTANCE2=getK2Distance();

final EVXData I,Iadp,IDpi;
final EVXSpectrum Pt,Pi;
final EVX2Data dI_dp,dI_d2p,I_dp,I_d2p;
final Var2I pv_IL,pv_IH;
final DynVarPnL xpi,xpV,xpt,xvS,xstaui,xSTaui,xdiipi,xditpi,xdiiDpi,xditDpi,xid2tpi,xdid2tDpi;
final DynVar1PnL it_EE,it_NEE,id2t_EE,id2t_NEE;
final DynEHPnL piEH;
final K3Distance k3;
final DynEHbPnL piEHb;
final DynVHPnL piVH,pvVH,pVVH,piXVH,piXiVH,piVVH,piDiVH;
final DynDVHPnL piId;
final DynMPnL piMD;
final DynM0PnL piM0;
final DynTIPnL piTI,piTI0,piTIH,piTIH0,piTIDH,piTID0;
final DynDVarPnL dII,_dII;
final TryD2 d2_psi_IH,Rd2_psi_IH;
final Dyn3PnL Rpnl3;
final DynSPnL DSpnl,DSOpnl,DPpnl;
final DynVTPnL vt,_vt;
final DynIVT ivt0,ivt;
final DynVT0PnL vt0;
final DynRPnL rpi;
final DynRPnLlast rpiR;
final DynRPnLI rpnli,rpnli0,rpnl,rpnl0;
final DynMUPnL pnlmuR,pnlmu0;
final DREVXData rdit,rdit0,rdii;
final DynRXPnL vrit,vrDit;
final DynVarIPnL varpiED,varpiEI;
final DynFVarPnL fvarpi;
final DynpIV pIV0,pIVR;
final DynVarXk piXk_IL,RpiXk_IL,piXk_IH,RpiXk_IH;
final DynVarX piMu,piI,piMut,piIt;
final DynVarXi pXiMu,pXiI,RpXiMu,RpXiI;
final DynVarC vc_IL,Rvc_IL,vc_IH,Rvc_IH,vcpnl_IL,Rvcpnl_IL,vcpnl_IH,Rvcpnl_IH,vc0_PnL_IH,vc0_PnLX_IH,vc_PnLX_IH,VC_PnL_IH0;
final DynVar2C var2pIH,var2pIS;
final DynVar2Ca var2ca;
final DynVarIC varic;
final DynVarIC2 varic2,varic2_0;
final DynVarFiniteC finC_pV,finC_pI,finC_RpI;
final DynCPnL cpnl0,cpnlR,cpnl;
final DynVarFiniteD finD_0Is,finD_0Im,finD_0Ip,finD_0Ip1,finD_0Iw,finD_0Vs,finD_0Vm,finD_0Vp,finD_0Vp1,finD_0Vw,finD_hIs,finD_hIm,finD_hIp,finD_hIp1,finD_hIw,finD_hVs,finD_hVm,finD_hVp,finD_hVp1,finD_hVw;
final DynVarFiniteD1 finD1_pI;
final DynVarFiniteE finEi,finEV,RfinEi,RfinEV,fin0Ei,fin0EV,finD0Ei,finD0EV;
final DynVarFiniteF finFJ;
final DynVarFiniteFV finFJV_TOT,finFJV_PLUS,finFJV_MINUS,finFJV_REL_IH,finFJV_REL_IL,finFJV_rI_IH;
final DynVarCD piCDipsi,piCDtpsi,piCDVpsi,pCCDVpsi;
final DynVarCDV piCDV0,piCDV,piDt0,piDi0,
    v_V_C,v_V_pI,v_V_DpI,v_DI_C,v_DI_pI,v_DI_DpI;
final DynSDPnL sd;
final DynSD2PnL sd2;
final DynVar2I v2I,v2Io,v2I0,v2I0o,v2DI;
final DynDI dI;
final DynR dR;
final DynVar2Ia dIa;
final DynV edV,edI;
final DynIndPnL indPnL;
final DynVarSP0 sp0,spl;
final DynRVarSP0 Rsp0;
final double Pt_average,Pi_average;
final DynVarY vY;
final DynVarMu dvmuIL,dvmuIH;
final DynVarMuX dvmuXIH,dvmuXX,dvmuXW,dvmuXW_SUM;
final DynVarV dvV;
final DynVar2PiPt vPiPt;
final DynVar2Proj v2Proj;
final DynVar2DynImpact dimpact;
final DynVar2DIDynImpact DIdimpact;
final DynVH2PnL dvh2pnl;
final DynVarPnLSpur dvh2pnlSpur;
final DynVarJPMorgan dmorgan;
final DynVar2DiagProj dvardiagproj;
final DynVar2DynImpactDI dynimpactDI;
final ImpactExample iex;

YpnlQVM(final int n,final DTYPE odata,final State rst)
{
    if(n<=1) throw new RuntimeException("n="+n+" must be >1");

    this.odata=odata;

    final int nmoms=2*n-1,nd=n-1;

    final double [][] mm=getMoments(nmoms);
    final double [] QQt=M.B.getQQMatr(n,mm[0]),QQi=M.B.getQQMatr(n,mm[1]),QQpi=M.B.getQQMatr(n,mm[2]),QQdp=M.B.getQQMatr(n,mm[3]),QQpt=M.B.getQQMatr(n,mm[5]),
	QQdi=M.B.getQQMatr(n,mm[6]),QQd2i=M.B.getQQMatr(n,mm[7]),
	QQdpi=M.B.getQQMatr(n,mm[8]),QQd2pi=M.B.getQQMatr(n,mm[9]),
	QQT=M.B.getQQMatr(n,mm[10]),QQV=M.B.getQQMatr(n,mm[11]),QQpV=M.B.getQQMatr(n,mm[12]),QQX=M.B.getQQMatr(n,mm[13]),QQXi=M.B.getQQMatr(n,mm[14]),QQXpi=M.B.getQQMatr(n,mm[15]),
	QQVr=M.B.getQQMatr(n,getFFromDFMatchRadau().apply(mm[17])),QQpVr=M.B.getQQMatr(n,getFFromDFMatchRadau().apply(mm[18])),
	QQaXt=M.B.getQQMatr(n,M.B.getXQkMomentsFromQkMoments(mm[16])),
	QQaXi=M.B.getQQMatr(n,M.B.getXQkMomentsFromQkMoments(mm[17])),
	QQvS=M.B.getQQMatr(n,mm[20]),
	QQadp=M.B.getQQMatr(n,mm[21]),
	QQc=M.B.getQQMatr(n,mm[22]),
	QQtaui=M.B.getQQMatr(n,mm[23]),
	QQstaui=M.B.getQQMatr(n,mm[24]),
	QQSTaui=M.B.getQQMatr(n,mm[25]),
	D=VOLATILITY_EDPsi.getDMatrix(n),
	In=com.polytechnik.utils.Linsystems.getInvertedMatrix(n,n,D),
	QQd2iPart=VOLATILITY_EDPsi.getDiff2PartMatrix(n,QQi),
	QQd2piPart=VOLATILITY_EDPsi.getDiff2PartMatrix(n,QQpi),
	QQd2p=VOLATILITY_EDPsi.getDiffMatrix(n,QQdp),
	QQDi=VOLATILITY_EDPsi.getDiffMatrix(n,QQi),
	QQiInt=VolMatrix.getHAB(n,QQi,In),
	QQDt=VOLATILITY_EDPsi.getDiffMatrix(n,QQt),
	QQDpi=VOLATILITY_EDPsi.getDiffMatrix(n,QQpi),
	DQQD=VOLATILITY_EDPsi.getVolMatrix(n,QQt),
	DQQiD=VOLATILITY_EDPsi.getVolMatrix(n,QQi),
	IQQt=com.polytechnik.utils.Linsystems.getInvertedMatrix(n,n,QQt),
	QQdpI=TMatr.scaleVectorInPlace(TMatr.mulMatrices(n,new double [][]{QQdp,IQQt,QQi}),0.5);
    TMatr.scaleVectorInPlace(TMatr.selectHermitianPartInPlace(n,QQdpI),2); // factor of 2 is here

    final double [] RQQi=M.B.getQQMatr(nd,M.getRadauMomentsFromMoments(mm[1])),
	RQQt=M.B.getQQMatr(nd,M.getRadauMomentsFromMoments(mm[0])),
	RQQpi=M.B.getQQMatr(nd,M.getRadauMomentsFromMoments(mm[2])),
	RQQpt=M.B.getQQMatr(nd,M.getRadauMomentsFromMoments(mm[5])),
	iQQD=TMatr.mulMM(n,QQi,D),tQQD=TMatr.mulMM(n,QQt,D);

    Pt_average=QQpt[0]/QQt[0];
    Pi_average=QQpi[0]/QQi[0];
    Pt=EVXSpectrum.getEVXSpectrumFromQQ(n,QQpt,QQt,M);
    Pi=EVXSpectrum.getEVXSpectrumFromQQ(n,QQpi,QQi,M);
    DSpnl=DynSPnL.get_DynSPnL(n,QQi,QQt,QQpi,false,VOLATILITY_EDPsi,M);
    DSOpnl=DynSPnL.get_DynSPnL(n,QQi,QQt,QQpi,true,VOLATILITY_EDPsi,M);
    DPpnl=DynSPnL.get_fromDP_DynSPnL(n,QQi,QQt,QQpi,QQdp,M);
    vt=new DynVTPnL(n,QQi,QQt,QQpi,QQV,QQT,QQpV,M,-1);
    _vt=new DynVTPnL(n,QQV,QQT,QQpV,VOLATILITY_EDPsi,M);
    vt0=new DynVT0PnL(n,QQV,QQT,QQpV,VOLATILITY_EDPsi,M);
    ivt0=new DynIVT(n,QQi,QQt,QQpi,QQV,QQT,QQpV,M,true,getPLast()); // offset always p_last
    ivt=new DynIVT(n,QQi,QQt,QQpi,QQV,QQT,QQpV,M,false,getPLast());
    rpi=DynRPnL.get_DynRPnL(n,QQi,QQt,QQpi,QQdp,VOLATILITY_EDPsi,M);
    rdit=DREVXData.get_DREVXData(n,QQi,QQt,QQpi,QQdp,QQt,VOLATILITY_EDPsi,M);
    rdit0=DREVXData.get0_DREVXData(n,QQi,QQt,QQpi,QQdp,QQt,VOLATILITY_EDPsi,M);
    rdii=DREVXData.get_DREVXData(n,QQi,QQi,QQpi,QQdp,QQt,VOLATILITY_EDPsi,M);
    vrit=DynRXPnL.get_DynRXPnL(n,QQi,QQt,QQpi,false,VOLATILITY_EDPsi,M);
    vrDit=DynRXPnL.get_DynRXPnL(n,QQi,QQt,QQpi,true,VOLATILITY_EDPsi,M);
    rpiR=DynRPnLlast.get_frommoments_DynRPnLlast(n,mm[1],mm[0],mm[2],M);
    rpnli=DynRPnLI.get_DynRPnLI(nd,RQQi,RQQt,RQQpi,M);
    rpnl=DynRPnLI.get_DynPnL(nd,RQQi,RQQt,RQQpi,M);
    rpnli0=DynRPnLI.get0_DynRPnLI(n,QQi,QQt,QQpi,M);
    rpnl0=DynRPnLI.get0_DynPnL(n,QQi,QQt,QQpi,M);
    pnlmuR=new DynMUPnL(nd,RQQi,RQQt,RQQpi,RQQpt,M,false);
    pnlmu0=new DynMUPnL(n,QQi,QQt,QQpi,QQpt,M,true);

    pIV0=DynpIV.get0_DynpIV(n,mm[1],mm[0],mm[2],M,getAccess());
    pIVR=DynpIV.getR_DynpIV(n,mm[1],mm[0],mm[2],M,getAccess());

    dII=new DynDVarPnL(n,QQt,QQi,QQpi,QQDi,QQDpi,M);
    _dII=new DynDVarPnL(n,QQt,QQi,QQpi,QQdi,QQdpi,M);
    varpiED=new DynVarIPnL(n,QQi,QQt,QQpi,D,M);
    varpiEI=new DynVarIPnL(n,QQi,QQt,QQpi,In,M);
    fvarpi=new DynFVarPnL(n,QQi,QQt,QQpi,0,VOLATILITY_EDPsi,M);

    xpi=new DynVarPnL(n,QQi,QQt,QQpi,QQi,M,VOLATILITY_EDPsi);
    xpV=new DynVarPnL(n,QQi,QQt,QQpV,QQV,M,VOLATILITY_EDPsi);
    xditDpi=new DynVarPnL(n,QQDi,QQt,QQDpi,QQDi,M,VOLATILITY_EDPsi);
    xdiiDpi=new DynVarPnL(n,QQDi,QQi,QQDpi,QQDi,M,VOLATILITY_EDPsi);
    xid2tpi=new DynVarPnL(n,QQi,DQQD,QQpi,QQi,M,VOLATILITY_EDPsi);
    xdid2tDpi=new DynVarPnL(n,QQDi,DQQD,QQDpi,QQDi,M,VOLATILITY_EDPsi);

    xpt=new DynVarPnL(n,QQi,QQt,QQpt,QQt,M,VOLATILITY_EDPsi);
    xvS=new DynVarPnL(n,QQi,QQt,QQvS,QQt,M,VOLATILITY_EDPsi);
    xstaui=new DynVarPnL(n,QQi,QQt,QQstaui,QQt,M,VOLATILITY_EDPsi);
    xSTaui=new DynVarPnL(n,QQi,QQt,QQSTaui,QQt,M,VOLATILITY_EDPsi);
    xdiipi=new DynVarPnL(n,QQDi,QQi,QQpi,QQi,M,VOLATILITY_EDPsi);
    xditpi=new DynVarPnL(n,QQDi,QQt,QQpi,QQi,M,VOLATILITY_EDPsi);
    it_EE=new DynVar1PnL(n,QQi,QQt,QQpi,QQt,M,VOLATILITY_EDPsi,true);
    it_NEE=new DynVar1PnL(n,QQi,QQt,QQpi,QQt,M,VOLATILITY_EDPsi,false);
    id2t_EE=new DynVar1PnL(n,QQi,DQQD,QQpi,QQt,M,VOLATILITY_EDPsi,true);
    id2t_NEE=new DynVar1PnL(n,QQi,DQQD,QQpi,QQt,M,VOLATILITY_EDPsi,false);
    piEH=new DynEHPnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    this.k3=getK3Distance(piEH.psiPnlL,piEH.psiPnlH,piEH.psiE);
    piEHb=new DynEHbPnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    piId=new DynDVHPnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    piVH=DynVHPnL.get_DynVHPnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    pvVH=DynVHPnL.get_DynVHPnL(n,QQV,QQt,QQpV,M,VOLATILITY_EDPsi);
    pVVH=DynVHPnL.get_DynVHPnL(n,QQV,QQT,QQpV,M,VOLATILITY_EDPsi);
    piXVH=DynVHPnL.getme_DynVHPnL(n,QQi,QQt,QQpi,QQX,M);
    piXiVH=DynVHPnL.getme_DynVHPnL(n,QQi,QQt,QQpi,QQXi,M);
    piVVH=DynVHPnL.getme_DynVHPnL(n,QQi,QQt,QQpi,QQV,M);
    piDiVH=DynVHPnL.getme_DynVHPnL(n,QQi,QQt,QQpi,iQQD,M);
    piMD=DynMPnL.get_DynMPnL(n,QQi,QQt,QQpi,M);
    piM0=DynM0PnL.get_DynM0PnL(n,QQi,QQt,QQpi,M);
    piTI=DynTIPnL.get_DynTIPnL(n,QQi,QQt,QQpi,M);
    piTI0=DynTIPnL.get0_DynTIPnL(n,0,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    piTIH=DynTIPnL.get0_DynTIPnL(n,n-1,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    piTIH0=DynTIPnL.getH0_DynTIPnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    piTIDH=DynTIPnL.getD_DynTIPnL(n,n-1,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    piTID0=DynTIPnL.getD_DynTIPnL(n,0,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);


    dI_dp=EVX2Data.getEVX2DataPsi0FromQQ(n,QQDi,QQt,QQdp,M);
    dI_d2p=EVX2Data.getEVX2DataPsi0FromQQ(n,QQDi,QQt,QQd2p,M);
    I_dp=EVX2Data.getEVX2DataPsi0FromQQ(n,QQi,QQt,QQdp,M);
    I_d2p=EVX2Data.getEVX2DataPsi0FromQQ(n,QQi,QQt,QQd2p,M);

    piXk_IL=new DynVarXk(n,QQi,QQt,QQpi,QQpt,true,M);
    RpiXk_IL=new DynVarXk(nd,RQQi,RQQt,RQQpi,RQQpt,true,M);
    piXk_IH=new DynVarXk(n,QQi,QQt,QQpi,QQpt,false,M);
    RpiXk_IH=new DynVarXk(nd,RQQi,RQQt,RQQpi,RQQpt,false,M);
    piMu=DynVarX.get_DynVarX(n,QQi,QQt,QQpi,null,M,true);
    piI=DynVarX.get_DynVarX(n,QQi,QQt,QQpi,null,M,false);
    piMut=DynVarX.get_DynVarX(n,QQi,QQt,QQpi,QQpt,M,true);
    piIt=DynVarX.get_DynVarX(n,QQi,QQt,QQpi,QQpt,M,false);
    pXiMu=DynVarXi.get_DynVarXi(n,QQi,QQt,QQpi,M,true);
    pXiI=DynVarXi.get_DynVarXi(n,QQi,QQt,QQpi,M,false);
    RpXiMu=DynVarXi.getR_DynVarXi(n,QQi,QQt,QQpi,M,0.0/* p_last=p_offset */,true);
    RpXiI=DynVarXi.getR_DynVarXi(n,QQi,QQt,QQpi,M,0.0/* p_last=p_offset */,false);

    vc_IL=DynVarC.get_DynVarC(n,QQi,QQt,QQpi,M,true);
    Rvc_IL=nd<2?vc_IL:DynVarC.get_DynVarC(nd,RQQi,RQQt,RQQpi,M,true);
    vc_IH=DynVarC.get_DynVarC(n,QQi,QQt,QQpi,M,false);
    Rvc_IH=nd<2?vc_IH:DynVarC.get_DynVarC(nd,RQQi,RQQt,RQQpi,M,false);
    vcpnl_IL=DynVarC.get_PnL_DynVarC(n,QQi,QQt,QQpi,M,0,true);
    Rvcpnl_IL=nd<2?vcpnl_IL:DynVarC.get_PnL_DynVarC(nd,RQQi,RQQt,RQQpi,M,0,true);
    vcpnl_IH=DynVarC.get_PnL_DynVarC(n,QQi,QQt,QQpi,M,0,false);
    Rvcpnl_IH=nd<2?vcpnl_IH:DynVarC.get_PnL_DynVarC(nd,RQQi,RQQt,RQQpi,M,0,false);
    vc0_PnL_IH=DynVarC.get0_PnL_DynVarC(n,QQi,QQt,QQpi,M,0);
    vc0_PnLX_IH=DynVarC.get0_PnLX_DynVarC(n,QQi,QQt,QQpi,M);
    vc_PnLX_IH=DynVarC.get_PnLX_DynVarC(n,QQi,QQt,QQpi,M);
    VC_PnL_IH0=DynVarC.get_PnLCV_DynVarC(n,QQi,QQt,QQpi,QQV,QQpV,M);
    var2pIH=DynVar2C.get_DynVar2C(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,DynVar2C.SELECTION_IH);
    var2pIS=DynVar2C.get_DynVar2C(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,DynVar2C.SELECTION_IPSIX02);
    var2ca=DynVar2Ca.get_DynVar2Ca(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    varic=DynVarIC.get_DynVarIC(n,QQi,QQt,QQc,M,VOLATILITY_EDPsi,-1);
    varic2=DynVarIC2.get_DynVarIC2(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,false,-1);
    varic2_0=DynVarIC2.get_DynVarIC2(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,true,-1);
    finC_pV=DynVarFiniteC.get_PnLCV_DynVarFiniteC(n,QQi,QQt,QQpi,QQV,QQpV,M,VOLATILITY_EDPsi,DISTANCE2);
    finC_pI=DynVarFiniteC.get_PnLX_DynVarFiniteC(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,DISTANCE2);
    finC_RpI=DynVarFiniteC.getR_PnLX_DynVarFiniteC(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,DISTANCE2);
    finD_0Is=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_CLOSE0);
    finD_0Im=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_MINMAX);
    finD_0Ip=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_CLOSEPSIH);
    finD_0Ip1=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH);
    finD_0Iw=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_CLOSEWPSIH);
    finD_0Vs=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_CLOSE0);
    finD_0Vm=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_MINMAX);
    finD_0Vp=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_CLOSEPSIH);
    finD_0Vp1=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH);
    finD_0Vw=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_CLOSEWPSIH);
    finD_hIs=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_CLOSE0);
    finD_hIm=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_MINMAX);
    finD_hIp=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_CLOSEPSIH);
    finD_hIp1=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH);
    finD_hIw=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_CLOSEWPSIH);
    finD_hVs=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_CLOSE0);
    finD_hVm=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_MINMAX);
    finD_hVp=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_CLOSEPSIH);
    finD_hVp1=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH);
    finD_hVw=DynVarFiniteD.get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,M,DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_CLOSEWPSIH);
    finD1_pI=DynVarFiniteD1.get_DynVarFiniteD1(n,QQi,QQt,QQpi,M,DISTANCE2);
    finFJ=DynVarFiniteF.get_PnLX_DynVarFiniteF(n,QQi,QQt,QQpi,QQXi,QQXpi,QQVr,QQpVr,M,VOLATILITY_EDPsi);
    finFJV_TOT=DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(
	n,mm[17],mm[16],mm[18],M,getFFromDFMatchRadau(),DynVarFiniteFV.M_VTOTAL,true,-1,VOLATILITY_EDPsi);
    finFJV_PLUS=DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(
	n,mm[17],mm[16],mm[18],M,getFFromDFMatchRadau(),DynVarFiniteFV.M_PLUS_V_VIH,true,-1,VOLATILITY_EDPsi);
    finFJV_MINUS=DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(
	n,mm[17],mm[16],mm[18],M,getFFromDFMatchRadau(),DynVarFiniteFV.M_MINUS_V_VIH,true,-1,VOLATILITY_EDPsi);
    finFJV_REL_IH=DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(
	n,mm[17],mm[16],mm[18],M,getFFromDFMatchRadau(),DynVarFiniteFV.M_REL_V_I,true,-1,VOLATILITY_EDPsi);
    finFJV_REL_IL=DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(
	n,mm[17],mm[16],mm[18],M,getFFromDFMatchRadau(),DynVarFiniteFV.M_REL_V_I,false,-1,VOLATILITY_EDPsi);
    finFJV_rI_IH=DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(
	n,mm[17],mm[16],mm[18],M,getFFromDFMatchRadau(),DynVarFiniteFV.M_rI,true,-1,VOLATILITY_EDPsi);
    finEi=DynVarFiniteE.get_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,M,DISTANCE2);
    finEV=DynVarFiniteE.get_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,M,DISTANCE2);
    RfinEi=DynVarFiniteE.getR_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,M,DISTANCE2);
    RfinEV=DynVarFiniteE.getR_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,M,DISTANCE2);
    fin0Ei=DynVarFiniteE.get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,M,null,DISTANCE2);
    finD0Ei=DynVarFiniteE.get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,M,VOLATILITY_EDPsi,DISTANCE2);
    fin0EV=DynVarFiniteE.get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,M,null,DISTANCE2);
    finD0EV=DynVarFiniteE.get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,M,VOLATILITY_EDPsi,DISTANCE2);

    piCDipsi=DynVarCD.getDp_DynVarCD(n,QQi,QQt,QQpi,true,M,VOLATILITY_EDPsi);
    piCDtpsi=DynVarCD.getDp_DynVarCD(n,QQi,QQt,QQpi,false,M,VOLATILITY_EDPsi);
    piCDVpsi=DynVarCD.getXp_DynVarCD(n,QQi,QQt,QQpi,QQV,M);
    pCCDVpsi=DynVarCD.getCV_DynVarCD(n,QQi,QQt,QQpi,QQV,QQpV,M);
    piCDV0=DynVarCDV.get0_DynVarCDVCV(n,QQi,QQt,QQpi,QQV,QQV,QQpV,M);
    piDt0=DynVarCDV.get0_DynVarCDVCV(n,QQi,QQt,QQpi,tQQD,QQi,QQpi,M);
    piDi0=DynVarCDV.get0_DynVarCDVCV(n,QQi,QQt,QQpi,iQQD,QQi,QQpi,M);
    piCDV=DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQV,QQV,QQpV,M);
    v_V_C=DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQV,QQV,QQpV,M);
    v_V_pI=DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQV,QQi,QQpi,M);
    v_V_DpI=DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQV,QQDi,QQDpi,M);
    v_DI_C=DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQDi,QQV,QQpV,M);
    v_DI_pI=DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQDi,QQi,QQpi,M);
    v_DI_DpI=DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQDi,QQDi,QQDpi,M);
    cpnl0=DynCPnL.get0_DynCPnL(n,QQV,QQt,QQpV,VOLATILITY_EDPsi,M);
    cpnlR=DynCPnL.getR_DynCPnL(n,QQV,QQt,QQpV,VOLATILITY_EDPsi,M);
    cpnl=DynCPnL.get_DynCPnL(n,QQV,QQt,QQpV,VOLATILITY_EDPsi,M);
    sd=DynSDPnL.get_DynSDPnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,DISTANCE2);
    sd2=DynSD2PnL.get_DynSD2PnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,DISTANCE2);
    v2DI=DynVar2I.getD_DynVar2I(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    v2I=DynVar2I.get_DynVar2I(n,QQi,QQt,QQpi,Double.NaN,false,M,VOLATILITY_EDPsi);
    v2Io=DynVar2I.get_DynVar2I(n,QQi,QQt,QQpi,0/* p_last=p_offset */,true,M,VOLATILITY_EDPsi);
    v2I0=DynVar2I.get0_DynVar2I(n,QQi,QQt,QQpi,Double.NaN,false,M,VOLATILITY_EDPsi);
    v2I0o=DynVar2I.get0_DynVar2I(n,QQi,QQt,QQpi,0/* p_last=p_offset */,true,M,VOLATILITY_EDPsi);
    dI=DynDI.get_DynDI(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,0);
    dR=DynR.get_DynR(n,QQi,QQt,QQpi,VOLATILITY_EDPsi,M);
    dIa=DynVar2Ia.get_DynVar2Ia(n,QQi,QQt,QQpi,0.0,M,VOLATILITY_EDPsi);
    edV=DynV.get_DynV(n,QQV,QQt,QQpV,M,VOLATILITY_EDPsi,0);
    edI=DynV.get_DynV(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,0);
    indPnL=DynIndPnL.get_DynIndPnL(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    sp0=DynVarSP0.get_DynVarSP0(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    spl=DynVarSP0.get_pl_DynVarSP0(n,QQi,QQt,QQpi,M,0.0); // p_last=p_offset here
    Rsp0=DynRVarSP0.geRt_DynRVarSP0(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);

    vY=DynVarY.get_DynVarY(n,QQi,QQt,QQpi,VOLATILITY_EDPsi,M,-1);
    dvmuIL=DynVarMu.get_DynVarMu(n,QQi,QQt,QQpi,M,true);
    dvmuIH=DynVarMu.get_DynVarMu(n,QQi,QQt,QQpi,M,false);
    dvmuXIH=DynVarMuX.get_DynVarMuX(n,QQi,QQt,QQpi,QQaXi,/*QQaXt,*/M,false,0);
    dvmuXX=DynVarMuX.get_DynVarMuXX(n,QQi,QQt,QQpi,M,0);
    dvmuXW=DynVarMuX.get_DynVarMuX(n,QQi,QQt,QQpi,INTRV,0);
    dvmuXW_SUM=DynVarMuX.get_DynVarMuX_SUM(n,QQi,QQt,QQpi,INTRV,0);
    if(false)
    {
	System.err.println("DynVarMuX.momi="+java.util.Arrays.toString(mm[17]));
	System.err.println("DynVarMuX.momXi="+java.util.Arrays.toString(M.B.getXQkMomentsFromQkMoments(mm[17])));
    }
    dvV=DynVarV.get_DynVarV(n,QQV,QQt,QQpV,
			    null,null,0, // disable self-test
			    M,VOLATILITY_EDPsi);
    vPiPt=DynVar2PiPt.get_DynVar2PiPt(n,QQi,QQt,QQpi,QQpt,M,VOLATILITY_EDPsi);
    v2Proj=DynVar2Proj.get_DynVar2Proj(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,0);
    dimpact=DynVar2DynImpact.get_DynVar2DynImpact(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    DIdimpact=DynVar2DIDynImpact.get_DynVar2DIDynImpact(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    dvh2pnl=DynVH2PnL.get_DynVH2PnL(n,QQi,QQt,QQpi,VOLATILITY_EDPsi,M,0);
    dvh2pnlSpur=DynVarPnLSpur.get_DynVarPnLSpur(n,QQi,QQt,QQpi,VOLATILITY_EDPsi,M,0);
    dmorgan=DynVarJPMorgan.get_DynVarJPMorgan(n,QQi,QQt,QQpi,VOLATILITY_EDPsi,M,0);
    dvardiagproj=DynVar2DiagProj.get_DynVar2DiagProj(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi,0);
    dynimpactDI=DynVar2DynImpactDI.get_DynVar2DynImpactDI(n,QQi,QQt,QQpi,M,VOLATILITY_EDPsi);
    iex=ImpactExample.get_ImpactExample(n,QQi,QQt,QQpi,QQdp,QQpt,M,VOLATILITY_EDPsi,getPOffset(),0);

    this.IDpi=EVXData.getEVXDataFromQQ(n,QQDpi,QQt,M);
    this.I=EVXData.getEVXDataFromQQ(n,QQi,QQt,M);
    this.Iadp=EVXData.getEVXDataFromQQ(n,QQadp,QQt,M);
    this.pv_IL=new Var2I(0,I,QQi,QQt,QQpi,0/* pL is converted to 0 */,M,VOLATILITY_EDPsi);
    this.pv_IH=new Var2I(n-1,I,QQi,QQt,QQpi,0/* pL is converted to 0 */,M,VOLATILITY_EDPsi);
    this.w_IDpi_L_I_H=TMatr.getAMatrB(IDpi.psiL,I.psiH,QQt,n);
    this.w_IDpi_H_I_H=TMatr.getAMatrB(IDpi.psiH,I.psiH,QQt,n);


    this.dp_I_psiH=2*TMatr.getAMatrB(I.psiH,getEDPsi(I.psiH),QQpi,n);
    this.px_I_psiH=2*TMatr.getAMatrB(I.psiH,getEDPsi(I.psiH),QQpi,n)/(I.sH*Math.pow(M.B.getD0(I.psiH,I.x0),2));
    this.px_I_psiL=2*TMatr.getAMatrB(I.psiL,getEDPsi(I.psiL),QQpi,n)/(I.sL*Math.pow(M.B.getD0(I.psiL,I.x0),2));

    final int i0=0,iL=1,iH=n-1;
    final double [] basis=EdComm.getIRadauBasisPsi0FromQQ(n,QQi,QQt,M),
	rpsi_H=EVXData.getPsiFromBasis(iH,basis,n),Drpsi_H=getEDPsi(rpsi_H),DDrpsi_H=getEDPsi(Drpsi_H);
    this.p_IH=TMatr.getAMatrA(rpsi_H,QQpi,n)/basis[iH];
    this.pV_IH=TMatr.getAMatrA(rpsi_H,QQpV,n)/TMatr.getAMatrA(rpsi_H,QQV,n);

    this.dp_IH=TMatr.getAMatrA(rpsi_H,QQdp,n);
    this.d2p_IH=2*TMatr.getAMatrB(rpsi_H,Drpsi_H,QQdp,n);
    {
	final double [] d2pbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQd2p,QQt,M),
	    d2p_psiL=EVXData.getPsiFromBasis(iL,d2pbasis,n),d2p_psiH=EVXData.getPsiFromBasis(iH,d2pbasis,n);
	this.d2p_L=d2pbasis[iL];
	this.d2p_H=d2pbasis[iH];
	this.xd2p_IH=TMatr.getAMatrA(rpsi_H,QQd2p,n);
	this.w_IH_d2pL=TMatr.getAMatrB(rpsi_H,d2p_psiL,QQt,n);
	this.w_IH_d2pH=TMatr.getAMatrB(rpsi_H,d2p_psiH,QQt,n);
    }

    this.pt_IH=TMatr.getAMatrA(rpsi_H,QQpt,n);
    this.pD2_IH=TMatr.getAMatrA(Drpsi_H,QQpi,n)/TMatr.getAMatrA(Drpsi_H,QQi,n);
    this.ptD2_IH=TMatr.getAMatrA(Drpsi_H,QQpt,n)/TMatr.getAMatrA(Drpsi_H,QQt,n);
    this.pD2a_IH=TMatr.getAMatrB(rpsi_H,DDrpsi_H,QQpi,n)/TMatr.getAMatrB(rpsi_H,DDrpsi_H,QQi,n);
    this.ptD2a_IH=TMatr.getAMatrB(rpsi_H,DDrpsi_H,QQpt,n)/TMatr.getAMatrB(rpsi_H,DDrpsi_H,QQt,n);

    this.d2_psi_IH=new TryD2(I.psiH,QQi,QQt,QQpi,VOLATILITY_EDPsi);
    this.Rd2_psi_IH=new TryD2(rpsi_H,QQi,QQt,QQpi,VOLATILITY_EDPsi);
    this.Rpnl3=new Dyn3PnL(n,QQi,QQt,QQpi,M);

    if(true)
    {
	{
	final double [] d2iPartbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQd2iPart,DQQD,M);
	this.p_d2iPartD_L=TMatr.getAMatrA(n,d2iPartbasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,d2iPartbasis,n+iL*n,QQi,n);
	this.p_d2iPartD_H=TMatr.getAMatrA(n,d2iPartbasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,d2iPartbasis,n+iH*n,QQi,n);
	this.pd_d2iPartD_L=TMatr.getAMatrA(n,d2iPartbasis,n+iL*n,QQd2piPart,n)/d2iPartbasis[iL];
	this.pd_d2iPartD_H=TMatr.getAMatrA(n,d2iPartbasis,n+iH*n,QQd2piPart,n)/d2iPartbasis[iH];
	}
	{
	final double [] d2iPartbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQd2iPart,QQt,M);
	this.p_d2iPart_L=TMatr.getAMatrA(n,d2iPartbasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,d2iPartbasis,n+iL*n,QQi,n);
	this.p_d2iPart_H=TMatr.getAMatrA(n,d2iPartbasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,d2iPartbasis,n+iH*n,QQi,n);
	this.pd_d2iPart_L=TMatr.getAMatrA(n,d2iPartbasis,n+iL*n,QQd2piPart,n)/d2iPartbasis[iL];
	this.pd_d2iPart_H=TMatr.getAMatrA(n,d2iPartbasis,n+iH*n,QQd2piPart,n)/d2iPartbasis[iH];
	if(false)
	{
	    System.err.println("d2iPartbasis[iL]="+d2iPartbasis[iL]+" <psiL|QQd2iPart|psiL>="+TMatr.getAMatrA(n,d2iPartbasis,n+iL*n,QQd2iPart,n));
	    System.err.println("d2iPartbasis[iH]="+d2iPartbasis[iH]+" <psiH|QQd2iPart|psiH>="+TMatr.getAMatrA(n,d2iPartbasis,n+iH*n,QQd2iPart,n));
	}
	}
	{
	final double [] dibasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQDi,QQt,M);
	this.p_DiDt_L=TMatr.getAMatrA(n,dibasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,dibasis,n+iL*n,QQi,n);
	this.p_DiDt_H=TMatr.getAMatrA(n,dibasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,dibasis,n+iH*n,QQi,n);
	}
	{
	final double [] iVolbasis=EdComm.getIRadauBasisPsi0FromQQ(n,DQQiD,QQt,M);
	this.p_iVol_L=TMatr.getAMatrA(n,iVolbasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,iVolbasis,n+iL*n,QQi,n);
	this.p_iVol_H=TMatr.getAMatrA(n,iVolbasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,iVolbasis,n+iH*n,QQi,n);
	}
	{
	final double [] d2ibasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQd2i,QQt,M);
	this.p_d2I_L=TMatr.getAMatrA(n,d2ibasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,d2ibasis,n+iL*n,QQi,n);
	this.p_d2I_H=TMatr.getAMatrA(n,d2ibasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,d2ibasis,n+iH*n,QQi,n);
	}
	{
	final double [] d2iDbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQd2i,DQQD,M);
	this.p_d2ID_L=TMatr.getAMatrA(n,d2iDbasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,d2iDbasis,n+iL*n,QQi,n);
	this.p_d2ID_H=TMatr.getAMatrA(n,d2iDbasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,d2iDbasis,n+iH*n,QQi,n);
	}
    }

    if(true)
    {
	final double [] DDbasis=EdComm.getIRadauBasisPsi0FromQQ(n,DQQiD,DQQD,M);
	final double [] psiH=EVXData.getPsiFromBasis(iH,DDbasis,n),DpsiH=getEDPsi(psiH),
	    psiL=EVXData.getPsiFromBasis(iL,DDbasis,n),DpsiL=getEDPsi(psiL);
	this.p_dIdH=TMatr.getAMatrA(psiH,QQpi,n)/TMatr.getAMatrA(psiH,QQi,n);
	this.pd_dIdH=TMatr.getAMatrA(DpsiH,QQpi,n)/TMatr.getAMatrA(DpsiH,QQi,n);
	this.p_dIdL=TMatr.getAMatrA(psiL,QQpi,n)/TMatr.getAMatrA(psiL,QQi,n);
	this.pd_dIdL=TMatr.getAMatrA(DpsiL,QQpi,n)/TMatr.getAMatrA(DpsiL,QQi,n);

	if(false)
	{
	final double [] in=M.EV.getGEV_Generalized(nd,QQi,QQt,true);
	System.err.println("ev:in="+java.util.Arrays.toString(java.util.Arrays.copyOf(in,nd)));
	System.err.println("ev:DD="+java.util.Arrays.toString(DeprecatedHelperTMatr.remove0Element(java.util.Arrays.copyOf(DDbasis,n))));
	for(int k=0;k<n;k++)
	{
	    final double [] psik=EVXData.getPsiFromBasis(k,DDbasis,n),Dpsik=getEDPsi(psik);
	    System.err.println("DDbasis["+k+"]="+DDbasis[k]+" <Dpsi|QQi|Dpsi>="+TMatr.getAMatrA(Dpsik,QQi,n));
	    for(int l=0;l<n;l++)
	    {
		final double [] psil=EVXData.getPsiFromBasis(l,DDbasis,n),Dpsil=getEDPsi(psil);
		System.err.println("<psi"+k+"|Dpsi"+l+">="+TMatr.getAMatrB(psik,Dpsil,QQt,n)+"\t<psi"+k+"|I|Dpsi"+l+">="+TMatr.getAMatrB(psik,Dpsil,QQi,n)+"\t<Dpsi"+k+"|I|Dpsi"+l+">="+TMatr.getAMatrB(Dpsik,Dpsil,QQt,n));
	    }
	}
	final double [] evD=M.EV.getGEV_Generalized(n,QQDt,QQt,false);
	System.err.println("QQDt=lambda QQt evD="+java.util.Arrays.toString(evD)+" should be single non-zero eigenvalue");
	}
    }

    if(true)
    {
	final double [] Dtbasis=EdComm.getIRadauBasisPsi0FromQQ(n,DQQD,QQt,M),
	    psi_DL=EVXData.getPsiFromBasis(iL,Dtbasis,n),QQa=new double [n*n];
	final double hbar2m=TMatr.getAMatrA(psi_DL,QQi,n)/Dtbasis[iL];
	for(int k=QQi.length;--k>=0;) QQa[k]=hbar2m*DQQD[k]-QQi[k];
	final double [] Hbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQa,QQt,M);
	this.p_mH_L=TMatr.getAMatrA(n,Hbasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,Hbasis,n+iL*n,QQi,n);
	this.p_mH_H=TMatr.getAMatrA(n,Hbasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,Hbasis,n+iH*n,QQi,n);
	if(false)
	{
	    System.err.println("Hbasis[iL]="+Hbasis[iL]+"\t<psi_DL|I|psi_DL>="+TMatr.getAMatrA(psi_DL,QQi,n)+"\tpsi_DL="+java.util.Arrays.toString(psi_DL));
	    System.err.println("DQQD ev="+java.util.Arrays.toString(java.util.Arrays.copyOf(Dtbasis,n)));
	    System.err.println("H ev="+java.util.Arrays.toString(java.util.Arrays.copyOf(Hbasis,n)));
	    System.err.println("I ev="+java.util.Arrays.toString(java.util.Arrays.copyOf(basis,n)));
	    System.err.println("<psi_DL|H|psi_DL>="+TMatr.getAMatrA(psi_DL,QQa,n));
	    System.err.println("<psi_DL|I|psi_DL>="+TMatr.getAMatrA(psi_DL,QQi,n)+"\tQQi[0]="+QQi[0]);
	}
    }

    dpIbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQdpI,DQQD,M);
    this.pnl_L=dpIbasis[iL];
    this.pnl_H=dpIbasis[iH];

    dpbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQdp,DQQD,M);
    this.dp_L=dpbasis[iL];
    this.dp_H=dpbasis[iH];

    Ibasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQi,DQQD,M);
    this.Id_L=Ibasis[iL];
    this.Id_H=Ibasis[iH];
    this.pId_IL=TMatr.getAMatrA(n,Ibasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,Ibasis,n+iL*n,QQi,n);
    this.pId_IH=TMatr.getAMatrA(n,Ibasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,Ibasis,n+iH*n,QQi,n);

    DIbasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQDi,DQQD,M);
    this.p_Di_L=TMatr.getAMatrA(n,DIbasis,n+iL*n,QQpi,n)/TMatr.getAMatrA(n,DIbasis,n+iL*n,QQi,n);
    this.p_Di_H=TMatr.getAMatrA(n,DIbasis,n+iH*n,QQpi,n)/TMatr.getAMatrA(n,DIbasis,n+iH*n,QQi,n);


    if(false)
    {
	final double [] DiffQQi=VOLATILITY_EDPsi.getDiffMatrix(n,QQi);
	for(int k=0;k<n;k++)
	{
	    for(int l=0;l<n;l++)
	    {
		System.err.println("<psi_"+k+"|DQQi|psi_"+l+">="+TMatr.getAMatrB(n,basis,n+k*n,n,basis,n+l*n,DiffQQi,n));
		System.err.println("<Ib_psi_"+k+"|DQQi|Ib_psi_"+l+">="+TMatr.getAMatrB(n,Ibasis,n+k*n,n,Ibasis,n+l*n,DiffQQi,n));
		System.err.println("<Ib_psi_"+k+"|QQi|Ib_psi_"+l+">="+TMatr.getAMatrB(n,Ibasis,n+k*n,n,Ibasis,n+l*n,QQi,n));
	    }
	}
    }
    if(false)
    {
	final double [] dibasis=EdComm.getIRadauBasisPsi0FromQQ(n,QQDi,QQt,M);
	for(int k=0;k<n;k++)
	{
	    for(int l=0;l<n;l++)
	    {
		System.err.println("<psi_"+k+"|QQDi|psi_"+l+">="+TMatr.getAMatrB(n,dibasis,n+k*n,n,dibasis,n+l*n,QQDi,n)+(k==l?"\t"+dibasis[k]:""));
		System.err.println("<psi_"+k+"|QQd2i|psi_"+l+">="+TMatr.getAMatrB(n,dibasis,n+k*n,n,dibasis,n+l*n,QQd2i,n));
	    }
	}
    }

    this.w_pnl_L_Id_H=TMatr.getAMatrB(n,dpIbasis,n+iL*n,n,Ibasis,n+iH*n,DQQD,n);
    this.w_pnl_H_Id_H=TMatr.getAMatrB(n,dpIbasis,n+iH*n,n,Ibasis,n+iH*n,DQQD,n);
    this.w_dp_L_Id_H=TMatr.getAMatrB(n,dpbasis,n+iL*n,n,Ibasis,n+iH*n,DQQD,n);
    this.w_dp_H_Id_H=TMatr.getAMatrB(n,dpbasis,n+iH*n,n,Ibasis,n+iH*n,DQQD,n);

    this.sst=null;


}
final double p_IH,pV_IH,pt_IH,dp_IH,d2p_IH,pD2_IH,ptD2_IH,pD2a_IH,ptD2a_IH,pId_IH,pId_IL,pnl_L,pnl_H,dp_L,dp_H,Id_L,Id_H,w_pnl_L_Id_H,w_pnl_H_Id_H,w_dp_L_Id_H,w_dp_H_Id_H,dp_I_psiH,px_I_psiH,px_I_psiL;
final double p_Di_L,p_Di_H,p_mH_L,p_mH_H,p_dIdH,pd_dIdH,p_dIdL,pd_dIdL;
final double [] Ibasis,dpbasis,dpIbasis,DIbasis;
final double w_IDpi_L_I_H,w_IDpi_H_I_H;
final double p_d2I_L,p_d2I_H,p_d2ID_L,p_d2ID_H,p_iVol_L,p_iVol_H,p_DiDt_L,p_DiDt_H,
    p_d2iPart_L,p_d2iPart_H,pd_d2iPart_L,pd_d2iPart_H,
    p_d2iPartD_L,p_d2iPartD_H,pd_d2iPartD_L,pd_d2iPartD_H,
    d2p_L,d2p_H,xd2p_IH,w_IH_d2pL,w_IH_d2pH;

double [][] getMoments(final int nmoms)
{
    final DataInterfaceToMoments<DTYPE> access=getAccess();
    final double [] tmom=new double [nmoms],imom=new double [nmoms],pimom=new double [nmoms],dpmom=new double [nmoms],ptmom=new double [nmoms],dimom=new double [nmoms],d2imom=new double [nmoms],dpimom=new double [nmoms],d2pimom=new double [nmoms],d2pmom=new double [nmoms],_Xmom=new double [nmoms+1],_Ximom=new double [nmoms+1],_Xpimom=new double [nmoms+1],adpmom=new double [nmoms];

    access.setM(imom,0,access.M_I,odata,nmoms);
    access.setM(pimom,1,access.M_I,odata,nmoms);
    final double [] cmom=TMatr.sumAcB(pimom,getPOffset(),imom);
    TMatr.sumP1(pimom,imom,getPOffset()-getPLast());
    access.setMT(tmom,nmoms);
    access.setM(dpmom,1,access.M_DP,odata,nmoms);
    access.setM(adpmom,0,access.M_A,odata,nmoms);
    access.setFMoments(ptmom,dpmom,nmoms);

    access.setDFMoments(dimom,imom,nmoms);
    access.setDFMoments(d2imom,dimom,nmoms);
    access.setDFMoments(d2pmom,dpmom,nmoms);
    access.setDFMoments(dpimom,pimom,nmoms);
    access.setDFMoments(d2pimom,dpimom,nmoms);

    final double [] Tmom=new double [nmoms],Vmom=new double [nmoms],pVmom=new double [nmoms],vsmom=new double [nmoms],vSmom=new double [nmoms];
    access.setFMoments(Vmom,imom,nmoms);
    access.setFMoments(Tmom,tmom,nmoms);
    access.setFMoments(pVmom,pimom,nmoms);
    TMatr.scaleVectorInPlace(Tmom,-1);
    TMatr.scaleVectorInPlace(Vmom,-1);
    TMatr.scaleVectorInPlace(pVmom,-1);

    access.setMT(_Xmom,nmoms+1);
    access.setM(_Ximom,0,access.M_I,odata,nmoms+1);
    access.setM(_Xpimom,1,access.M_I,odata,nmoms+1);
    TMatr.sumP1(_Xpimom,_Ximom,getPOffset()-getPLast());

    access.setM(vsmom,0,access.M_VS /* access.M_RVS */,odata,nmoms);
    access.setFMoments(vSmom,vsmom,nmoms);
    TMatr.scaleVectorInPlace(vSmom,-1);

    final double [] mstau=new double [nmoms],mbtau=new double [nmoms];
    access.setM(mstau,0,access.M_TAUISELL,odata,nmoms);
    access.setM(mbtau,0,access.M_TAUIBUY,odata,nmoms);
    final double [] mtaui=TMatr.sumAcB(mstau,1,mbtau),mstaui=TMatr.sumAcB(mstau,-1,mbtau),
	mSTaui=new double [nmoms];
    access.setFMoments(mSTaui,mstaui,nmoms);
    TMatr.scaleVectorInPlace(mSTaui,-1);

    return new double [][]{tmom,imom,pimom,dpmom,d2pmom,ptmom,dimom,d2imom,dpimom,d2pimom,Tmom,Vmom,pVmom,M.getRadauMomentsFromMoments(_Xmom),M.getRadauMomentsFromMoments(_Ximom),M.getRadauMomentsFromMoments(_Xpimom),_Xmom,_Ximom,_Xpimom,vsmom,vSmom,adpmom,cmom,
			   mtaui, // mstau+mbtau (23)
			   mstaui,// mstau-mbtau (24)
			   mSTaui // (25)
		 };
}

abstract DataInterfaceToMoments<DTYPE> getAccess();
abstract OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> getABasis();
abstract PsiIntegratedByInterval getINTRV();
abstract double getPLast();
double getPOffset(){return getAccess().getPOffset(odata);}
abstract double [] getEDPsi(final double [] psi);
abstract double [] getEIntPsi(final double [] psi);
abstract K3Distance getK3Distance(final double [] a,final double [] b,final double [] c);
abstract double [] getPsi2WIntegrated(final double [] psi);
abstract K2Distance getK2Distance();
abstract java.util.function.Function<double [],double []> getFFromDFMatchRadau();

static double [] getYpnlDirectCalc(final int n,final double [] QQt,final double [] QQi,final double [] QQpi,final double [] QQdp,
				   final VolMatrix volatility,final OrthogonalPolynomialsBasisFunctionsCalculatable<? extends BasisFunctionsCalculatable> M,
				   final boolean usebasistransform)
{
    final double [] basis=EdComm.getIRadauBasisPsi0FromQQ(n,QQi,QQt,M);
    final double p_IH=TMatr.getAMatrA(n,basis,n+(n-1)*n,QQpi,n)/basis[n-1];
    final double [] bQQi,bQQpi,bQQdp,bDQQD,bQQDi;
    if(usebasistransform)
    {
	final double [] DQQD=volatility.getVolMatrix(n,QQt),
	    QQDi=volatility.getDiffMatrix(n,QQi);
	bQQi=EVXData.convertMatrFromQtoB_Basis(n,QQi,basis);
	bQQpi=EVXData.convertMatrFromQtoB_Basis(n,QQpi,basis);
	bQQdp=EVXData.convertMatrFromQtoB_Basis(n,QQdp,basis);
	bDQQD=EVXData.convertMatrFromQtoB_Basis(n,DQQD,basis);
	bQQDi=EVXData.convertMatrFromQtoB_Basis(n,QQDi,basis);
    }
    else
    {
	bQQi=new double [n*n];bQQpi=new double [n*n];bQQdp=new double [n*n];bDQQD=new double [n*n];bQQDi=new double [n*n];
	for(int k=0;k<n;k++)
	{
	    final double [] psik=EVXData.getPsiFromBasis(k,basis,n),
		Dpsik=volatility.getDPsi(psik);
	    for(int l=0;l<n;l++)
	    {
		final double [] psil=EVXData.getPsiFromBasis(l,basis,n),
		    Dpsil=volatility.getDPsi(psil);
		bQQi[l+k*n]=TMatr.getAMatrB(psik,psil,QQi,n);
		bQQpi[l+k*n]=TMatr.getAMatrB(psik,psil,QQpi,n);
		bQQdp[l+k*n]=TMatr.getAMatrB(psik,psil,QQdp,n);
		bDQQD[l+k*n]=TMatr.getAMatrB(Dpsik,Dpsil,QQt,n);
		bQQDi[l+k*n]=TMatr.getAMatrB(Dpsik,psil,QQi,n)+TMatr.getAMatrB(psik,Dpsil,QQi,n);
	    }
	}
    }
    final double [] bQQpnl=TMatr.scaleVectorInPlace(TMatr.mulMM(n,bQQdp,bQQi),0.5);
    TMatr.scaleVectorInPlace(TMatr.selectHermitianPartInPlace(n,bQQpnl),2); // factor of 2 is here
    final int nd=n-1,i0=0;
    final double []
	mbDQQD=DeprecatedHelperEVXData.getOneVectorRemovedFromMatrix(n,bDQQD,i0),
	mbQQDi=DeprecatedHelperEVXData.getOneVectorRemovedFromMatrix(n,bQQDi,i0),
	mbQQi=DeprecatedHelperEVXData.getOneVectorRemovedFromMatrix(n,bQQi,i0),
	mbQQpi=DeprecatedHelperEVXData.getOneVectorRemovedFromMatrix(n,bQQpi,i0),
	mbQQdp=DeprecatedHelperEVXData.getOneVectorRemovedFromMatrix(n,bQQdp,i0);
    System.err.println("spur(mbDQQd)="+TMatr.getSpurM(nd,mbDQQD)+"\tnd="+nd);
    System.err.println("spur(mbQQi)="+TMatr.getSpurM(nd,mbQQi)+"\tnd="+nd);
    final double [] Ibasis=M.EV.getGEV_Generalized(nd,mbQQi,mbDQQD,true);
    //final double [] psiId_IH=EVXData.getPsiFromBasis(nd-1,Ibasis,nd);
    //final double pId_IH=TMatr.getAMatrA(psiId_IH,mbQQpi,nd)/TMatr.getAMatrA(psiId_IH,mbQQi,nd);
    final double pId_IH=TMatr.getAMatrA(nd,Ibasis,nd+(nd-1)*nd,mbQQpi,nd)/TMatr.getAMatrA(nd,Ibasis,nd+(nd-1)*nd,mbQQi,nd),
	pId_IL=TMatr.getAMatrA(nd,Ibasis,nd+(0)*nd,mbQQpi,nd)/TMatr.getAMatrA(nd,Ibasis,nd+(0)*nd,mbQQi,nd);

    final double [] DIbasis=M.EV.getGEV_Generalized(nd,mbQQDi,mbDQQD,true);
    final double p_Di_L=TMatr.getAMatrA(nd,DIbasis,nd+(0)*nd,mbQQpi,nd)/TMatr.getAMatrA(nd,DIbasis,nd+(0)*nd,mbQQi,nd),
	p_Di_H=TMatr.getAMatrA(nd,DIbasis,nd+(nd-1)*nd,mbQQpi,nd)/TMatr.getAMatrA(nd,DIbasis,nd+(nd-1)*nd,mbQQi,nd);


    final double [] pmbQQpnl=EVXData.convertMatrFromQtoB_Basis(nd,DeprecatedHelperEVXData.getOneVectorRemovedFromMatrix(n,bQQpnl,i0),Ibasis);
    final double [] epnl=M.EV.getEV(nd,pmbQQpnl,true);
    final double w_pnl_L_Id_H=epnl[nd+(0   )*nd+(nd-1)],w_pnl_H_Id_H=epnl[nd+(nd-1)*nd+(nd-1)];

    final double [] pmbQQdp=EVXData.convertMatrFromQtoB_Basis(nd,DeprecatedHelperEVXData.getOneVectorRemovedFromMatrix(n,bQQdp,i0),Ibasis);
    final double [] edp=M.EV.getEV(nd,pmbQQdp,true);
    final double w_dp_L_Id_H=edp[nd+(0   )*nd+(nd-1)],w_dp_H_Id_H=edp[nd+(nd-1)*nd+(nd-1)];

    System.err.println("ev:epnl="+java.util.Arrays.toString(java.util.Arrays.copyOf(epnl,nd)));
    System.err.println("ev:edp="+java.util.Arrays.toString(java.util.Arrays.copyOf(edp,nd)));
    System.err.println("ev:Ibasis="+java.util.Arrays.toString(java.util.Arrays.copyOf(Ibasis,nd)));

    return new double []{w_pnl_L_Id_H,w_pnl_H_Id_H,w_dp_L_Id_H,w_dp_H_Id_H,
			 p_IH,pId_IL,pId_IH,p_Di_L,p_Di_H};
}

static abstract class YpnlQVMTest<DTYPE> extends QTest {

abstract YpnlQVM<DTYPE> getYpnlQVM();


YpnlQVMTest(final String name,
	  final java.util.Random r,final double eps)
{
    super(name,r,eps);
}


void test_Extra(){}

void test_EVX2()
{
    final int n=neq,nmoms=2*n-1;
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    UnitTests.checkDoubleRel(q.d2p_IH,"q.d2p_IH",q.xd2p_IH,"q.xd2p_IH",eps);

    UnitTests.checkDoubleRel(q.d2p_L,"q.d2p_L",q.I_d2p.sfL,"q.sfL",eps);
    UnitTests.checkDoubleRel(q.d2p_H,"q.d2p_H",q.I_d2p.sfH,"q.sfH",eps);
    UnitTests.checkDoubleRel(Math.abs(q.w_IH_d2pL),"q.w_IH_d2pL",Math.abs(q.I_d2p.w_IH_fL),"q.I_d2p.w_IH_fL",eps);
    UnitTests.checkDoubleRel(Math.abs(q.w_IH_d2pH),"q.w_IH_d2pH",Math.abs(q.I_d2p.w_IH_fH),"q.I_d2p.w_IH_fH",eps);

    // matrch ACorr
    final double [][] mm=q.getMoments(nmoms);
    final double [] tmom=mm[0],imom=mm[1],dpmom=mm[3],d2pmom=mm[4],dimom=mm[6];
    ACorr.matchACorr(q.I_dp.a,
		     ACorr.getACorr_SPUR(n-1,q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(imom)),
					 q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(dpmom)),
					 q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(tmom)),q.M),eps);
    ACorr.matchACorr(q.dI_dp.a,
		     ACorr.getACorr_SPUR(n-1,q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(dimom)),
					 q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(dpmom)),
					 q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(tmom)),q.M),eps);
    ACorr.matchACorr(EVX2Data.getEVX2DataFromQQ(n,q.M.B.getQQMatr(n,imom),q.M.B.getQQMatr(n,tmom),q.M.B.getQQMatr(n,dpmom),q.M.EV).a,
		     ACorr.getACorr_SPUR(n,imom,dpmom,tmom,q.M),eps);


    final EVX2Data d=EVX2Data.getEVX2DataFromQQ(n-1,q.M.B.getQQMatr(n-1,q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(dimom))),q.M.B.getQQMatr(n-1,q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(tmom))),q.M.B.getQQMatr(n-1,q.M.getRadauMomentsFromMoments(q.M.getRadauMomentsFromMoments(d2pmom))),q.M.EV);

    EVX2Data.matchEVX2Data(d,q.dI_d2p,false,false,eps);

    System.err.println(name+":YpnlQVMTest:test_EVX2(): test OK n="+n+" eps="+eps);

}

void test_DI()
{
    final int n=neq,nmoms=2*n-1;
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    final double [][] mm=q.getMoments(nmoms);
    final double [] QQt=q.M.B.getQQMatr(n,mm[0]),QQi=q.M.B.getQQMatr(n,mm[1]),QQpi=q.M.B.getQQMatr(n,mm[2]),QQdp=q.M.B.getQQMatr(n,mm[3]),
	QQDi=q.VOLATILITY_EDPsi.getDiffMatrix(n,QQi),
	QQDpi=q.VOLATILITY_EDPsi.getDiffMatrix(n,QQpi);

    for(int k=0;k<q.I.neq;k++)
    {
	final double [] psi=q.I.getPsi(k);
	final double je=q.I.ev[k]*Math.pow(q.M.B.getD0(psi,q.I.x0),2),
	    jee=TMatr.getAMatrA(psi,QQDi,n),
	    jeee=2*TMatr.getAMatrB(psi,q.getEDPsi(psi),QQi,n);
	UnitTests.checkDoubleRel(je,"je",jee,"jee",eps);
	UnitTests.checkDoubleRel(je,"je",jeee,"jeee",eps);
	final double px=TMatr.getAMatrA(psi,QQDpi,n)/jee;
	if(k==0) UnitTests.checkDoubleRel(px,"px",q.px_I_psiL,"q.px_I_psiL",eps);
	if(k==(q.I.neq-1)) UnitTests.checkDoubleRel(px,"px",q.px_I_psiH,"q.px_I_psiH",eps);
    }
    UnitTests.checkDoubleRel(TMatr.getAMatrB(q.I.psiL,q.getEDPsi(q.I.psiL),QQpi,n)/TMatr.getAMatrB(q.I.psiL,q.getEDPsi(q.I.psiL),QQi,n),"test px_I_psiL",q.px_I_psiL,"q.px_I_psiL",eps);
    UnitTests.checkDoubleRel(TMatr.getAMatrB(q.I.psiH,q.getEDPsi(q.I.psiH),QQpi,n)/TMatr.getAMatrB(q.I.psiH,q.getEDPsi(q.I.psiH),QQi,n),"test px_I_psiH",q.px_I_psiH,"q.px_I_psiH",eps);


    System.err.println(name+":YpnlQVMTest:test_DI(): test OK n="+n+" eps="+eps);
}


void test_D2I()
{
    final int n=neq,nmoms=2*n-1;
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    final double [][] mm=q.getMoments(nmoms);
    final double [] QQt=q.M.B.getQQMatr(n,mm[0]),QQi=q.M.B.getQQMatr(n,mm[1]),QQpi=q.M.B.getQQMatr(n,mm[2]),
	QQX=q.M.B.getQQMatr(n,mm[13]),
	QQd2i=q.VOLATILITY_EDPsi.getDiff2Matrix(n,QQi),
	DQQD=q.VOLATILITY_EDPsi.getVolMatrix(n,QQt),
	QQdp=q.M.B.getQQMatr(n,mm[3]),
	QQpt=q.M.B.getQQMatr(n,mm[5]);
    final int i0=0,iL=1,iH=n-1;
    for(double [][] b:new double [][][]{{QQd2i,QQt,{q.p_d2I_L,q.p_d2I_H}},
					{QQd2i,DQQD,{q.p_d2ID_L,q.p_d2ID_H}}})
    {
	final double sL=b[2][0],sH=b[2][1];
	final double [] basis=EdComm.getIRadauBasisPsi0FromQQ(n,b[0],b[1],q.M);
	final double [] psiL=EVXData.getPsiFromBasis(iL,basis,n),psiH=EVXData.getPsiFromBasis(iH,basis,n);
	final double p_L=TMatr.getAMatrA(psiL,QQpi,n)/TMatr.getAMatrA(psiL,QQi,n),
	p_H=TMatr.getAMatrA(psiH,QQpi,n)/TMatr.getAMatrA(psiH,QQi,n);
	UnitTests.checkDoubleRel(sL,"sL",p_L,"p_L",eps);
	UnitTests.checkDoubleRel(sH,"sH",p_H,"p_H",eps);
    }

    Var2I.test_Var2I(n,QQi,QQt,QQpi,0,q.M,q.VOLATILITY_EDPsi,eps);

    DynVar1PnL.test_DynVar1PnL(n,QQi,QQt,QQpi,QQt,q.M,q.VOLATILITY_EDPsi,eps);
    UnitTests.checkDoubleRel(q.it_EE.p_IL,"qq.it_EE.p_IL",q.xpi.p_IL,"q.xpi.p_IL",eps);
    UnitTests.checkDoubleRel(q.it_EE.dif_IL,"qq.it_EE.dif_IL",q.xpi.dif_IL,"q.xpi.dif_IL",eps);
    UnitTests.checkDoubleRel(q.it_EE.p_IH,"qq.it_EE.p_IH",q.xpi.p_IH,"q.xpi.p_IH",eps);
    UnitTests.checkDoubleRel(q.it_EE.dif_IH,"qq.it_EE.dif_IH",q.xpi.dif_IH,"q.xpi.dif_IH",eps);
    UnitTests.checkDoubleRel(q.it_EE.pDiff,"qq.it_EE.pDiff",q.xpi.pDiff,"q.xpi.pDiff",eps);
    UnitTests.checkDoubleRel(q.id2t_EE.pDiff,"qq.id2t_EE.pDiff",q.xid2tpi.pDiff,"q.xid2tpi.pDiff",eps);
    UnitTests.checkDoubleRel(q.it_EE.p_IH,"qq.it_EE.p_IH",q.rpnli0.p_IH,"q.rpnli0.p_IH",eps);

    UnitTests.checkDoubleRel(q.piVH.p_IH,"q.piVH.p_IH",q.piEH.p_IH,"q.piEH.p_IH",eps);
    UnitTests.checkDoubleRel(q.piVH.var_p_IH,"q.piVH.var_p_IH",q.piEH.var_p_IH,"q.piEH.var_p_IH",eps);

    UnitTests.checkDoubleRel(q.piVH.p_IH,"q.piVH.p_IH",q.varpiED.p_IH,"q.varpiED.p_IH",eps);
    UnitTests.checkDoubleRel(q.piVH.var_p_IH,"q.piVH.var_p_IH",q.varpiED.var_p_IH,"q.varpiED.var_p_IH",eps);
     UnitTests.checkDoubleRel(q.piVH.p_IH,"q.piVH.p_IH",q.var2pIH.p_IX,"q.var2pIH.p_IX",eps);
     UnitTests.checkDoubleRel(q.piVH.var_p_IH,"q.piVH.var_p_IH",0.5*q.var2pIH.var_pI_IX,"0.5*q.var2pIH.var_pI_IX",eps);

    DynVar1PnL.test_DynVar1PnL(n,QQi,DQQD,QQpi,QQt,q.M,q.VOLATILITY_EDPsi,eps);
    UnitTests.checkDoubleRel(q.id2t_EE.var2_pI_L,"q.id2t_EE.var2_pI_L",0,"0",eps);
    UnitTests.checkDoubleRel(q.id2t_EE.var2_pI_H,"q.id2t_EE.var2_pI_H",0,"0",eps);
    UnitTests.checkDoubleRel(q.id2t_NEE.var2_pI_L,"q.id2t_NEE.var2_pI_L",0,"0",eps);
    UnitTests.checkDoubleRel(q.id2t_NEE.var2_pI_H,"q.id2t_NEE.var2_pI_H",0,"0",eps);
    UnitTests.checkDoubleRel(q.id2t_EE.p_IL,"qq.id2t_EE.p_IL",q.pId_IL,"q.pId_IL",eps);
    UnitTests.checkDoubleRel(q.id2t_EE.p_IH,"qq.id2t_EE.p_IH",q.pId_IH,"q.pId_IH",eps);
    DynEHPnL.match_DynEHbPnL(q.piEH,q.piEHb,eps);
    final DynVHPnL l=DynVHPnL.get_DynVHPnL(n,QQi,QQt,QQi,q.M,q.VOLATILITY_EDPsi);
    UnitTests.checkDoubleRel(l.var_p_IH,"l.var_p_IH",0,"0",eps);
    //UnitTests.checkDoubleRel(l.var_p_IL,"l.var_p_IL",0,"0",eps);
    final double [] QQT=q.M.B.getQQMatr(n,mm[10]),QQV=q.M.B.getQQMatr(n,mm[11]),QQpV=q.M.B.getQQMatr(n,mm[12]);
    final DynVHPnL m=DynVHPnL.get_DynVHPnL(n,QQV,QQt,QQV,q.M,q.VOLATILITY_EDPsi);
    UnitTests.checkDoubleRel(m.var_p_IH,"m.var_p_IH",0,"0",eps);
    //UnitTests.checkDoubleRel(m.var_p_IL,"m.var_p_IL",0,"0",eps);
    DynVHPnL.matchDynVHPnL(q.piVH,DynVHPnL.get_v2_DynVHPnL(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi),eps);
    DynVHPnL.matchDynVHPnL(q.piVH,DynVHPnL.get_v3_DynVHPnL(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi),eps);
    DynVHPnL.matchDynVHPnL(q.pVVH,DynVHPnL.get_v2_DynVHPnL(n,QQV,QQT,QQpV,q.M,q.VOLATILITY_EDPsi),eps);
    DynVHPnL.matchDynVHPnL(q.pVVH,DynVHPnL.get_v3_DynVHPnL(n,QQV,QQT,QQpV,q.M,q.VOLATILITY_EDPsi),eps);
    DynVHPnL.matchDynVHPnL(q.piVH,DynVHPnL.getme_v2_DynVHPnL(n,QQi,QQt,QQpi,TMatr.mulMM(n,QQt,q.VOLATILITY_EDPsi.getDMatrix(n)),q.M),eps);
    DynVHPnL.matchDynVHPnL(q.piVH,DynVHPnL.getme_DynVHPnL(n,QQi,QQt,QQpi,TMatr.mulMM(n,QQt,q.VOLATILITY_EDPsi.getDMatrix(n)),q.M),eps);

    DynVHPnL.matchDynVHPnL(q.piXVH,DynVHPnL.getme_v2_DynVHPnL(n,QQi,QQt,QQpi,QQX,q.M),eps);
    DynVarCD.matchDynVHPnL(q.piCDtpsi,q.piVH,eps);
    DynVarCD.matchDynVHPnL(q.piCDVpsi,q.piVVH,eps);

    DynTIPnL.matchDynTIPnL(q.piTI,DynTIPnL.get_v2_DynTIPnL(n,QQi,QQt,QQpi,q.M),eps);

    UnitTests.checkDoubleRel(q.piVH.p_IH,"q.piVH.p_IH",q.piMD.p_IH,"q.piMD.p_IH",eps);
    UnitTests.checkDoubleRel(q.piVH.pb_IH,"q.piVH.pb_IH",q.piMD.pb_IH,"q.piMD.pb_IH",eps);
    UnitTests.checkDoubleRel(q.piVH.ib_IH,"q.piVH.ib_IH",q.piMD.ib_IH,"q.piMD.ib_IH",eps);
    UnitTests.checkDoubleRel(q.piVH.pd_IH,"q.piVH.pd_IH",q.piEH.pd_IH,"q.piEH.pd_IH",eps);
    UnitTests.checkDoubleRel(q.piVH.var_p_IH,"q.piVH.var_p_IH",q.piEH.var_p_IH,"q.piEH.var_p_IH",eps);

    DynMPnL.matchDynMPnL(q.piMD,DynMPnL.get_v2_DynMPnL(n,QQi,QQt,QQpi,q.M),eps);
    DynMPnL.matchDynMPnL(q.piMD,DynMPnL.get_v3_DynMPnL(n,QQi,QQt,QQpi,q.M),eps);
    DynMPnL.matchDynMPnL(q.piMD,DynMPnL.get_v4_DynMPnL(n,QQi,QQt,QQpi,q.M),eps);
    DynMPnL.matchDynMPnL(q.piMD,DynMPnL.get_v5_DynMPnL(n,QQi,QQt,QQpi,q.M),eps);

    DynM0PnL.matchDynM0PnL(q.piM0,DynM0PnL.get_v2_DynM0PnL(n,QQi,QQt,QQpi,q.M),eps);

    UnitTests.checkDoubleRel(q.dII.dII_L.rate,"q.dII.dII_L.rate",q.xdiipi.I_L,"q.xdiipi.I_L",eps);
    UnitTests.checkDoubleRel(q.dII.dII_L.p,"q.dII.dII_L.p",q.xdiipi.p_IL,"q.xdiipi.p_IL",eps);
    UnitTests.checkDoubleRel(q.dII.dII_L.pd,"q.dII.dII_L.pd",q.xdiiDpi.p_IL,"q.xdiiDpi.p_IL",eps);
    UnitTests.checkDoubleRel(q.dII.dII_H.rate,"q.dII.dII_H.rate",q.xdiipi.I_H,"q.xdiipi.I_H",eps);
    UnitTests.checkDoubleRel(q.dII.dII_H.p,"q.dII.dII_H.p",q.xdiipi.p_IH,"q.xdiipi.p_IH",eps);
    UnitTests.checkDoubleRel(q.dII.dII_H.pd,"q.dII.dII_H.pd",q.xdiiDpi.p_IH,"q.xdiiDpi.p_IH",eps);
    DynDVarPnL.matchDynDVarPnL(q.dII,q._dII,eps);

    if(testK3(n)) q.k3.test_Self(QQt,eps);

    if(true)
    {
	DynVTPnL.matchDynVTPnL(new DynVTPnL(n,QQi,QQt,QQpi,QQV,QQT,QQpV,q.M,eps),q._vt,eps);
	DynVTPnL.matchDynVTPnL(q.vt,q._vt,eps);
	final DynVTPnL vt0=new DynVTPnL(n,QQV,QQT,QQV,q.VOLATILITY_EDPsi,q.M);
	UnitTests.checkDoubleRel(vt0.varPnL,"vt0.varPnL",0,"0",eps);
	EVXData.matchEVXData(q.pVVH.I,q._vt.VT,eps);
	UnitTests.checkDoubleRel(q.pVVH.p_IH,"q.pVVH.p_IH",q._vt.p_V,"q._vt.p_V",eps);
	UnitTests.checkDoubleRel(q.pVVH.var_p_IH/(0.5*TMatr.getAMatrA(q.pVVH.I.psiH,QQt,n)),"q.pVVH.var_p_IH/norm",q._vt.varPnL,"q._vt.varPnL",eps);
    }
    if(true)
    {
	DynRPnL.matchDynRPnL(q.rpi,DynRPnL.get_frommoments_DynRPnL(n,mm[1],mm[0],mm[2],mm[3],q.VOLATILITY_EDPsi,q.M),eps);
	final int nd=n-1;
	final DynVar1 d1=new DynVar1(EVXData.getPsiFromBasis(nd-1,q.pIVR.eI,nd),
			     QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi);
	UnitTests.checkDoubleRel(d1.var_I,"d1.var_I",q.rpi.var_I_IH,"q.rpi.var_I_IH",eps);
    }
    if(true)
    {
	DREVXData.test_DREVXData(q.rdit,n,QQi,QQt,QQpi,q.VOLATILITY_EDPsi,q.M,eps);
	DREVXData.test_DREVXData(q.rdii,n,QQi,QQi,QQpi,q.VOLATILITY_EDPsi,q.M,eps);
    }

    if(true)
    {
	DynVarV.get_DynVarV(n,QQV,QQt,QQpV,
			    QQi,QQpi,eps, // only for self-test
			    q.M,q.VOLATILITY_EDPsi);
	DynVar2PiPt.matchDynVar2C(q.vPiPt,q.var2pIH,eps);
	DynVar2Proj.get_DynVar2Proj(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,eps);
	DynVar2DynImpact.matchDynVar2C(q.dimpact,q.var2pIH,eps);
	DynVar2DIDynImpact.matchDynVar2DynImpact(q.DIdimpact,q.dimpact,eps);
    }

    DynVH2PnL.get_DynVH2PnL(n,QQi,QQt,QQpi,q.VOLATILITY_EDPsi,q.M,eps);
    DynVH2PnL.matchDynVarPnLSpur(q.dvh2pnl,q.dvh2pnlSpur,eps);
    DynVarJPMorgan.get_DynVarJPMorgan(n,QQi,QQt,QQpi,q.VOLATILITY_EDPsi,q.M,eps);
    DynVarPnLSpur.get_DynVarPnLSpur(n,QQi,QQt,QQpi,q.VOLATILITY_EDPsi,q.M,eps);
    DynVar2DiagProj.get_DynVar2DiagProj(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,eps);
    DynVar2DynImpactDI.match(q.dynimpactDI,DynVar2DynImpactDI.test_get_DynVar2DynImpactDI(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,eps),eps);
    final ImpactExample tiex=ImpactExample.get_ImpactExample(n,QQi,QQt,QQpi,QQdp,QQpt,q.M,q.VOLATILITY_EDPsi,q.getPOffset(),eps);
    ImpactExample.matchDynVar2DynImpactDI(tiex,q.dynimpactDI,eps);
    ImpactExample.matchDynVar2DiagProj(tiex,q.dvardiagproj,eps);
    ImpactExample.matchImpactExample(tiex,q.iex,eps);

    System.err.println(name+":YpnlQVMTest:test_D2I(): test OK n="+n+" eps="+eps);
}

boolean testK3(final int n){return true;}

void test_w(final boolean usebasistransform)
{
    final int n=neq,nmoms=2*n-1;
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    final double [][] mm=q.getMoments(nmoms);
    final double [] QQt=q.M.B.getQQMatr(n,mm[0]),QQi=q.M.B.getQQMatr(n,mm[1]),QQpi=q.M.B.getQQMatr(n,mm[2]),QQdp=q.M.B.getQQMatr(n,mm[3]);
    final double [] w=getYpnlDirectCalc(n,QQt,QQi,QQpi,QQdp,q.VOLATILITY_EDPsi,q.M,usebasistransform);
    System.err.println("ev:dpIbasis="+java.util.Arrays.toString(java.util.Arrays.copyOf(q.dpIbasis,n)));
    System.err.println("ev:dpbasis="+java.util.Arrays.toString(java.util.Arrays.copyOf(q.dpbasis,n)));
    System.err.println("ev:Ibasis="+java.util.Arrays.toString(java.util.Arrays.copyOf(q.Ibasis,n)));
    UnitTests.checkDoubleRel(Math.abs(q.w_pnl_L_Id_H),"q.w_pnl_L_Id_H",Math.abs(w[0]),"w[0]",eps);
    UnitTests.checkDoubleRel(Math.abs(q.w_pnl_H_Id_H),"q.w_pnl_H_Id_H",Math.abs(w[1]),"w[1]",eps);
    UnitTests.checkDoubleRel(Math.abs(q.w_dp_L_Id_H),"q.w_dp_L_Id_H",Math.abs(w[2]),"w[2]",eps);
    UnitTests.checkDoubleRel(Math.abs(q.w_dp_H_Id_H),"q.w_dp_H_Id_H",Math.abs(w[3]),"w[3]",eps);
    UnitTests.checkDoubleRel(q.p_IH,"q.p_IH",w[4],"w[4]",eps);
    UnitTests.checkDoubleRel(q.pId_IL,"q.pId_IL",w[5],"w[5]",eps);
    UnitTests.checkDoubleRel(q.pId_IH,"q.pId_IH",w[6],"w[6]",eps);
    UnitTests.checkDoubleRel(q.p_Di_L,"q.p_Di_L",w[7],"w[7]",eps);
    UnitTests.checkDoubleRel(q.p_Di_H,"q.p_Di_H",w[8],"w[8]",eps);

    System.err.println(name+":YpnlQVMTest:test_w(): test OK n="+n+" usebasistransform="+usebasistransform+" eps="+eps);
}

void test2_DynVarXk_shift()
{
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    final int n=neq,nmoms=2*n-1,nd=n-1;
    final double [][] mm=q.getMoments(nmoms);
    DynVarXk.test_DynVarXk(n,mm[1],mm[0],mm[2],mm[5],q.M,eps);
    q.ivt0.test_Integration(n,mm[1],mm[0],mm[2],(double [] pp) ->q.getPsi2WIntegrated(pp),q.M,eps);
    q.ivt.test_Integration(n,mm[1],mm[0],mm[2],(double [] pp) ->q.getPsi2WIntegrated(pp),q.M,eps);
}

void test_DynVarC()
{
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    final int n=neq,nmoms=2*n-1,nd=n-1;
    final double [][] mm=q.getMoments(nmoms);

    final double [] QQt=q.M.B.getQQMatr(n,mm[0]),QQi=q.M.B.getQQMatr(n,mm[1]),QQpi=q.M.B.getQQMatr(n,mm[2]),
	QQV=q.M.B.getQQMatr(n,mm[11]),QQpV=q.M.B.getQQMatr(n,mm[12]),
	RQQi=q.M.B.getQQMatr(nd,q.M.getRadauMomentsFromMoments(mm[1])),
	RQQt=q.M.B.getQQMatr(nd,q.M.getRadauMomentsFromMoments(mm[0])),
	RQQpi=q.M.B.getQQMatr(nd,q.M.getRadauMomentsFromMoments(mm[2])),
	QQc=q.M.B.getQQMatr(n,mm[22]);

    DynVarC.matchDynVarC(q.vc_IL,DynVarC.test_get_DynVarC(n,QQi,QQt,QQpi,q.M,true),eps);
    if(!(nd<2)) DynVarC.matchDynVarC(q.Rvc_IL,DynVarC.test_get_DynVarC(nd,RQQi,RQQt,RQQpi,q.M,true),eps);
    DynVarC.matchDynVarC(q.vc_IH,DynVarC.test_get_DynVarC(n,QQi,QQt,QQpi,q.M,false),eps);
    if(!(nd<2)) DynVarC.matchDynVarC(q.Rvc_IH,DynVarC.test_get_DynVarC(nd,RQQi,RQQt,RQQpi,q.M,false),eps);

    DynVarC.matchDynVarC(q.vcpnl_IL,DynVarC.test_get_PnL_DynVarC(n,QQi,QQt,QQpi,q.M,0,true),eps);
    if(!(nd<2)) DynVarC.matchDynVarC(q.Rvcpnl_IL,DynVarC.test_get_PnL_DynVarC(nd,RQQi,RQQt,RQQpi,q.M,0,true),eps);
    DynVarC.matchDynVarC(q.vcpnl_IH,DynVarC.test_get_PnL_DynVarC(n,QQi,QQt,QQpi,q.M,0,false),eps);
    if(!(nd<2)) DynVarC.matchDynVarC(q.Rvcpnl_IH,DynVarC.test_get_PnL_DynVarC(nd,RQQi,RQQt,RQQpi,q.M,0,false),eps);

    DynVarC.matchDynVarC(q.vc0_PnL_IH,DynVarC.test_get0_PnL_DynVarC(n,QQi,QQt,QQpi,q.M,0),eps);
    DynVarC.matchDynVarC(q.vc0_PnL_IH,DynVarC.test2_get0_PnL_DynVarC(n,QQi,QQt,QQpi,q.M,0),eps);
    if(!(n<3)) DynVarC.matchDynVarC(q.vc0_PnLX_IH,DynVarC.test_get0_PnLX_DynVarC(n,QQi,QQt,QQpi,q.M),eps);
    DynVarC.matchDynVarC(q.vc_PnLX_IH,DynVarC.test_get_PnLX_DynVarC(n,QQi,QQt,QQpi,q.M),eps);
    if(!(n<3)) DynVarC.matchDynVarC(q.VC_PnL_IH0,DynVarC.test_get_PnLCV_DynVarC(n,QQi,QQt,QQpi,QQV,QQpV,q.M),eps);

    if(!(n<3)) DynVarFiniteC.matchDynVarFiniteC(q.finC_pV,DynVarFiniteC.test_get_PnLCV_DynVarFiniteC(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.VOLATILITY_EDPsi,q.DISTANCE2),eps);
    DynVarFiniteC.matchDynVarC(q.finC_pV,q.VC_PnL_IH0,eps);
    UnitTests.checkDoubleRel(q.finC_pV.var_pn_IX,"q.finC_pV.var_pn_IX",0,"0",eps);
    DynCPnL.matchDynVarFiniteC(q.cpnl0,q.finC_pV,eps);
    UnitTests.checkDoubleRel(q.cpnl.var_pI_IX,"q.cpnl.var_pI_IX",0.5*q.finC_pI.var_pn_IX,"0.5*q.finC_pI.var_pn_IX",eps);
    UnitTests.checkDoubleRel(q.cpnl.var_pI_IX,"q.cpnl.var_pI_IX",0.5*q.sp0.d[n-1],"0.5*q.sp0.d[n-1]",eps);
    //DynCPnL.matchDynVarFiniteC(q.cpnl,q.finC_pI,eps);
    DynCPnL.matchDynRPnL(q.cpnlR,q.rpi,eps);
    DynCPnL.matchDynVar2C(q.cpnl,q.var2pIH,eps);
    if(!(n<3)){
	DynVarFiniteD.matchDynVarFiniteC(q.finD_0Vm,q.finC_pV,true,eps);
	DynVarFiniteD.matchDynVarFiniteC(q.finD_hIm,q.finC_pI,false,eps);
    }

    if(!(n<3)) DynVarFiniteC.matchDynVarFiniteC(q.finC_pI,DynVarFiniteC.test_get_PnLX_DynVarFiniteC(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,q.DISTANCE2),eps);
    if(!(n<3)) DynVarFiniteC.matchDynVarFiniteC(q.finC_RpI,DynVarFiniteC.test_getR_PnLX_DynVarFiniteC(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,q.DISTANCE2),eps);

    if(!(n<3)){
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Is,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_CLOSE0),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Im,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_MINMAX),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Ip,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_CLOSEPSIH),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Ip1,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,false,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Vs,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_CLOSE0),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Vm,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_MINMAX),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Vp,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_CLOSEPSIH),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_0Vp1,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,true,true,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hIs,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_CLOSE0),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hIm,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_MINMAX),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hIp,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_CLOSEPSIH),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hIp1,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,false,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hVs,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_CLOSE0),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hVm,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_MINMAX),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hVp,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_CLOSEPSIH),eps);
	DynVarFiniteD.matchDynVarFiniteD(q.finD_hVp1,DynVarFiniteD.test_get_DynVarFiniteD(n,QQi,QQt,QQpi,QQV,QQpV,q.M,q.DISTANCE2,false,true,DynVarFiniteD.FLAG_SEL_CLOSE1PSIH),eps);
    }

    if(!(n<3)){
    final double [] iQQD=TMatr.mulMM(n,QQt,q.VOLATILITY_EDPsi.getDMatrix(n)),
	tQQD=TMatr.mulMM(n,QQi,q.VOLATILITY_EDPsi.getDMatrix(n));
    DynVarCDV.matchDynVarCDV(q.piCDV0,DynVarCDV.test_get0_DynVarCDVCV(n,QQi,QQt,QQpi,QQV,QQV,QQpV,q.M),eps);
    DynVarCDV.matchDynVarCDV(DynVarCDV.get0_DynVarCDVCV(n,QQi,QQt,QQpi,tQQD,QQi,QQpi,q.M),DynVarCDV.test_get0_DynVarCDVCV(n,QQi,QQt,QQpi,tQQD,QQi,QQpi,q.M),eps);
    DynVarCDV.matchDynVarCDV(DynVarCDV.get0_DynVarCDVCV(n,QQi,QQt,QQpi,iQQD,QQi,QQpi,q.M),DynVarCDV.test_get0_DynVarCDVCV(n,QQi,QQt,QQpi,iQQD,QQi,QQpi,q.M),eps);
    DynVarCDV.matchDynVarCDV(q.piDt0,DynVarCDV.test_get0D_DynVarCDVCV(n,QQi,QQt,QQpi,false,q.VOLATILITY_EDPsi,QQi,QQpi,q.M),eps);
    DynVarCDV.matchDynVarCDV(q.piDi0,DynVarCDV.test_get0D_DynVarCDVCV(n,QQi,QQt,QQpi,true,q.VOLATILITY_EDPsi,QQi,QQpi,q.M),eps);

    DynVarCDV.matchDynVarCD(q.piCDV,q.pCCDVpsi,eps);
    DynVarCDV.matchDynVarCD(DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,QQV,QQi,QQpi,q.M),q.piCDVpsi,eps);
    DynVarCDV.matchDynVarCD(DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,iQQD,QQi,QQpi,q.M),q.piCDtpsi,eps);
    DynVarCDV.matchDynVarCD(DynVarCDV.get_DynVarCDVCV(n,QQi,QQt,QQpi,tQQD,QQi,QQpi,q.M),q.piCDipsi,eps);
    }


    if(n>2) {
	DynVarFiniteF.matchDynVarFiniteF(q.finFJ,DynVarFiniteF.test_get_PnLX_DynVarFiniteF_frommoments(n,mm[17],mm[0],mm[18],q.M,q.VOLATILITY_EDPsi,q.getFFromDFMatchRadau(),eps),eps);
	DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(n,mm[17],mm[16],mm[18],q.M,q.getFFromDFMatchRadau(),DynVarFiniteFV.M_VTOTAL,true,eps,q.VOLATILITY_EDPsi);
	DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(n,mm[17],mm[16],mm[18],q.M,q.getFFromDFMatchRadau(),DynVarFiniteFV.M_PLUS_V_VIH,true,eps,q.VOLATILITY_EDPsi);
	DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(n,mm[17],mm[16],mm[18],q.M,q.getFFromDFMatchRadau(),DynVarFiniteFV.M_MINUS_V_VIH,true,eps,q.VOLATILITY_EDPsi);
	DynVarFiniteFV.test_get_PnLX_DynVarFiniteFV_frommoments(n,mm[17],mm[16],mm[18],q.M,q.getFFromDFMatchRadau(),DynVarFiniteFV.M_REL_V_I,true,eps,q.VOLATILITY_EDPsi);
	if(false)
	{ // Trmom & Rtmom should match exactly.
	    final double [] Trmom=q.getFFromDFMatchRadau().apply(mm[16]),Rtmom=mm[13];
	    System.err.println("Trmom="+java.util.Arrays.toString(Trmom));
	    System.err.println("Rtmom="+java.util.Arrays.toString(Rtmom));
	    UnitTests.checkDoubleArrayRel(Trmom,"Trmom",Rtmom,"Rtmom",eps);
	    final double [] IQQt=com.polytechnik.utils.Linsystems.getInvertedMatrix(n,n,QQt),
		PkT=TMatr.getMatr_x_A(n,IQQt,Trmom),PkR=TMatr.getMatr_x_A(n,IQQt,Rtmom);
	    final com.polytechnik.utils.PolynomialsRatio
		kT=new com.polytechnik.utils.PolynomialsRatio(q.M.B.getKK(n,IQQt),q.M.B.getKK(n,TMatr.mulMatrices(n,new double [][]{IQQt,q.M.B.getQQMatr(n,Trmom),IQQt})),q.M.B),
		kR=new com.polytechnik.utils.PolynomialsRatio(q.M.B.getKK(n,IQQt),q.M.B.getKK(n,TMatr.mulMatrices(n,new double [][]{IQQt,q.M.B.getQQMatr(n,Rtmom),IQQt})),q.M.B);
	    final double x0=q.M.getRadauRoot();
	    final double [] ONE=q.M.B.getONE();
	    final boolean flag_dir_right=q.M.B.getD1(q.M.getRadauMultiplied(ONE),0)<0;
	    final double e=(flag_dir_right?1:-1)*0.005;
	    for(double x=x0-e*20;flag_dir_right?(x<=x0+e/2):(x>=x0+e/2);x+=e)
	    {
		System.err.println("x="+x+" kT(x)="+kT.getF(x)+" kDT="+kT.getDF(x)+
				   " kR="+kR.getF(x)+" kDR="+kR.getDF(x)+
				   "\tPkR="+q.M.B.getD0(PkR,x)+" DPkR="+q.M.B.getD1(PkR,x)+" PkT="+q.M.B.getD0(PkT,x)+" DPkT="+q.M.B.getD1(PkT,x));
	    }
	}
	DynVarFiniteE.matchDynVarFiniteD(q.finEi,q.finD_hIw,eps);
	DynVarFiniteE.matchDynVarFiniteD(q.finEV,q.finD_hVw,eps);
	DynVarFiniteE.matchDynVarFiniteD(q.fin0Ei,q.finD_0Iw,eps);
	DynVarFiniteE.matchDynVarFiniteD(q.fin0EV,q.finD_0Vw,eps);

	DynVarFiniteE.matchDynVarFiniteE(q.finEi,DynVarFiniteE.test_get_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,q.M,q.DISTANCE2),eps);
	DynVarFiniteE.matchDynVarFiniteE(q.finEV,DynVarFiniteE.test_get_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,q.M,q.DISTANCE2),eps);

	DynVarFiniteE.matchDynVarFiniteE(q.RfinEi,DynVarFiniteE.test_getR_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,q.M,q.DISTANCE2),eps);
	DynVarFiniteE.matchDynVarFiniteE(q.RfinEV,DynVarFiniteE.test_getR_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,q.M,q.DISTANCE2),eps);

	DynVarFiniteE.matchDynVarFiniteE(q.fin0Ei,DynVarFiniteE.test_get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,q.M,null,q.DISTANCE2),eps);
	DynVarFiniteE.matchDynVarFiniteE(q.finD0Ei,DynVarFiniteE.test_get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,true,q.M,q.VOLATILITY_EDPsi,q.DISTANCE2),eps);
	DynVarFiniteE.matchDynVarFiniteE(q.fin0EV,DynVarFiniteE.test_get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,q.M,null,q.DISTANCE2),eps);
	DynVarFiniteE.matchDynVarFiniteE(q.finD0EV,DynVarFiniteE.test_get0_PnLX_DynVarFiniteE(n,QQi,QQt,QQpi,QQV,QQpV,false,q.M,q.VOLATILITY_EDPsi,q.DISTANCE2),eps);

	DynVarFiniteE.matchDynHPnL(q.fin0Ei,new DynHPnL(n,QQi,QQt,QQpi,QQi,QQV,QQpV,q.M,q.DISTANCE2),eps);
    }

    DynSDPnL.matchDynSDPnL(q.sd,DynSDPnL.test_get_DynSDPnL(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,q.DISTANCE2),eps);
    UnitTests.checkDoubleRel(0.5*q.sd.avar_p_IX,"0.5*q.sd.avar_p_IX",q.piEH.var_p_IH,"q.piEH.var_p_IH",eps);
    UnitTests.checkDoubleRel(q.sd.DI_IX,"q.sd.DI_IX",q.sd.I.sH*Math.pow(q.M.B.getD0(q.sd.I.psiH,q.sd.I.x0),2),"I_IX*psiX(x0)^2",eps);
    DynSDPnL.testVar1(q.sd,n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,eps);
    DynSD2PnL.testVar1(q.sd2,n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,eps);

    DynVar2I.matchDynVar2I(q.v2I,DynVar2I.test_get_DynVar2I(n,QQi,QQt,QQpi,Double.NaN,false,q.M,q.VOLATILITY_EDPsi,eps),eps);
    DynVar2I.matchDynVar2I(q.v2Io,DynVar2I.test_get_DynVar2I(n,QQi,QQt,QQpi,0,true,q.M,q.VOLATILITY_EDPsi,eps),eps);
    DynVar2I.matchDynVar2I(q.v2I0,DynVar2I.test_get0_DynVar2I(n,QQi,QQt,QQpi,Double.NaN,false,q.M,q.VOLATILITY_EDPsi,eps),eps);
    DynVar2I.matchDynVar2I(q.v2I0o,DynVar2I.test_get0_DynVar2I(n,QQi,QQt,QQpi,0,true,q.M,q.VOLATILITY_EDPsi,eps),eps);
    DynDI.matchDynVar2I(q.dI,q.v2I,eps);
    DynDI.get_DynDI(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,eps);
    DynV.get_DynV(n,QQV,QQt,QQpV,q.M,q.VOLATILITY_EDPsi,eps);
    DynV.matchV(n,QQV,QQt,q.M,q.VOLATILITY_EDPsi,eps);
    DynV.get_DynV(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,eps);
    DynV.matchV(n,QQi,QQt,q.M,q.VOLATILITY_EDPsi,eps);
    UnitTests.checkDoubleRel(q.edI.p_I,"q.edI.p_I",q.var2pIS.pd_IX,"q.var2pIS.pd_IX",eps);
    UnitTests.checkDoubleRel(q.edI.p_V,"q.edI.p_V",q.var2pIS.p_IX,"q.var2pIS.p_IX",eps);

    DynVar2Ca.matchDynVar2Ca(q.var2ca,DynVar2Ca.test_get_DynVar2Ca(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi),eps);
    DynVarIC.get_DynVarIC(n,QQi,QQt,QQc,q.M,q.VOLATILITY_EDPsi,eps);
    DynVarIC2.get_DynVarIC2(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,false,eps);
    DynVarIC2.get_DynVarIC2(n,QQi,QQt,QQpi,q.M,q.VOLATILITY_EDPsi,true,eps);

    DynVarY.get_DynVarY(n,QQi,QQt,QQpi,q.VOLATILITY_EDPsi,q.M,eps);

    // debug
    DynVarMuX.get_DynVarMuX(n,QQi,QQt,QQpi,q.M.B.getQQMatr(n,q.M.B.getXQkMomentsFromQkMoments(mm[17])),q.M,false,eps);
    DynVarMuX.get_DynVarMuXX(n,QQi,QQt,QQpi,q.M,eps);
    DynVarMuX.get_DynVarMuX(n,QQi,QQt,QQpi,q.INTRV,eps);
    DynVarMuX.get_DynVarMuX_SUM(n,QQi,QQt,QQpi,q.INTRV,eps);

    System.err.println(name+":YpnlQVMTest:test_DynVarC(): test OK n="+n+" eps="+eps);
}

void test_DynVarXk_shift()
{
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    final int n=neq,nmoms=2*n-1,nd=n-1;
    final double [][] mm=q.getMoments(nmoms);
    final double ra_shift=58*r.nextDouble();

    final double [] QQt=q.M.B.getQQMatr(n,mm[0]),QQi=q.M.B.getQQMatr(n,mm[1]),QQpi=q.M.B.getQQMatr(n,mm[2]),
	QQpt=q.M.B.getQQMatr(n,mm[5]);
    final double [] RQQi=q.M.B.getQQMatr(nd,q.M.getRadauMomentsFromMoments(mm[1])),
	RQQt=q.M.B.getQQMatr(nd,q.M.getRadauMomentsFromMoments(mm[0])),
	RQQpi=q.M.B.getQQMatr(nd,q.M.getRadauMomentsFromMoments(mm[2])),
	RQQpt=q.M.B.getQQMatr(nd,q.M.getRadauMomentsFromMoments(mm[5])),
	RQQXi=q.M.B.getQQMatr(nd,q.M.B.getXQkMomentsFromQkMoments(q.M.getRadauMomentsFromMoments(mm[1]))),
	RQQXt=q.M.B.getQQMatr(nd,q.M.B.getXQkMomentsFromQkMoments(q.M.getRadauMomentsFromMoments(mm[0])));

    for(int lh=0;lh<2;lh++)
    {
	for(int j=0;j<2;j++)
	{
	    final int nx;final boolean flag_L;
	    final double [] qqi,qqt,qqpi,qqpt;
	    final DynVarXk qj;
	    if(j<=0) {nx=n;qqi=QQi;qqt=QQt;qqpi=QQpi;qqpt=QQpt;if(lh<=0){qj=q.piXk_IL;flag_L=true;}else{qj=q.piXk_IH;flag_L=false;}}
	    else {nx=nd;qqi=RQQi;qqt=RQQt;qqpi=RQQpi;qqpt=RQQpt;if(lh<=0){qj=q.RpiXk_IL;flag_L=true;}else{qj=q.RpiXk_IH;flag_L=false;}}
	    final double [] sqqi=TMatr.sumAcB(qqi,ra_shift*qj.I_IX,qqt),
		sqqpi=TMatr.sumAcB(qqpi,ra_shift*qj.I_IX,qqpt);

	    final DynVarXk sj=new DynVarXk(nx,sqqi,qqt,sqqpi,qqpt,flag_L,q.M);
	    //UnitTests.checkDoubleRel(qj.varpIk,"qj.varpIk",sj.varpIk,"sj.varpIk",eps);
	    UnitTests.checkDoubleRel(qj.p_EQ,"qj.p_EQ",sj.p_EQ,"sj.p_EQ",eps);
	    UnitTests.checkDoubleRel(qj.pa_EQ,"qj.pa_EQ",sj.pa_EQ,"sj.pa_EQ",eps);
	    UnitTests.checkDoubleRel(qj.pm_EQ,"qj.pm_EQ",sj.pm_EQ,"sj.pm_EQ",eps);
	    UnitTests.checkDoubleRel(qj.x_EQ,"qj.x_EQ",sj.x_EQ,"sj.x_EQ",eps);
	    UnitTests.checkDoubleRel(qj.xa_EQ,"qj.xa_EQ",sj.xa_EQ,"sj.xa_EQ",eps);
	    UnitTests.checkDoubleRel(qj.xm_EQ,"qj.xm_EQ",sj.xm_EQ,"sj.xm_EQ",eps);
	    if(nx==nd)
	    { // make sure l_k is the eigenfunction of x with measure dmu.
		final DynVarXk sx=new DynVarXk(nx,qqi,qqt,RQQXi,RQQXt,flag_L,q.M);
		UnitTests.checkDoubleRel(sj.x_EQ,"sj.x_EQ",sx.p_EQ,"sx.p_EQ",eps);
		UnitTests.checkDoubleRel(sj.xa_EQ,"sj.xa_EQ",sx.pa_EQ,"sx.pa_EQ",eps);
		UnitTests.checkDoubleRel(sj.xm_EQ,"sj.xm_EQ",sx.pm_EQ,"sx.pm_EQ",eps);
	    }
	}
    }

    if(true)
    {
	 UnitTests.checkDoubleRel(q.piXk_IL.pm_EQ,"q.piXk_IL.pm_EQ",q.piIt.p_IX,"q.piIt.p_IX",eps);
	 UnitTests.checkDoubleRel(q.piXk_IL.pm_EQ,"q.piXk_IL.pm_EQ",q.piIt.p_IX,"q.piIt.p_IX",eps);
	 UnitTests.checkDoubleRel(q.piXk_IL.pax_MU,"q.piXk_IL.pax_MU",q.piIt.pax_MU,"q.piIt.pax_MU",eps);
    }

    System.err.println(name+":YpnlQVMTest:test_DynVarXk_shift(): test OK n="+n+" eps="+eps);
}

/** Unit test differentiation & intergagration of psi.
 */
void test_EintMatchDpsi()
{
    final YpnlQVM<DTYPE> q=getYpnlQVM();
    final int n=q.I.neq;
    final double x0=q.I.x0;
    final double [][] mm=q.getMoments(2*n-1);
    final VolMatrix vi=new VolMatrix(){public double [] getDPsi(final double [] psi){return q.getEIntPsi(psi);}};
    final double [] D=q.VOLATILITY_EDPsi.getDMatrix(n),Int=com.polytechnik.utils.Linsystems.getInvertedMatrix(n,n,D),QQt=q.M.B.getQQMatr(n,mm[0]),QQpi=q.M.B.getQQMatr(n,mm[2]),QQtIn=VolMatrix.getHAB(n,QQt,Int),QQtD=q.VOLATILITY_EDPsi.getDiffMatrix(n,QQt),QQtD_=VolMatrix.getHAB(n,QQt,D),DQQD=q.VOLATILITY_EDPsi.getVolMatrix(n,QQt),
	Int_=vi.getDMatrix(n),QQtIn_=vi.getDiffMatrix(n,QQt);
    UnitTests.checkDoubleArrayRel(QQtD,"QQtD",QQtD_,"QQtD_",eps);
    UnitTests.checkDoubleArrayRel(Int,"Int",Int_,"Int_",eps);
    UnitTests.checkDoubleArrayRel(QQtIn,"QQtIn",QQtIn_,"QQtIn_",eps);

    UnitTests.checkDoubleRel(q.varpiEI.var_p_IH,"q.varpiEI.var_p_IH",TMatr.getAMatrB(q.varpiEI.I.psiH,q.getEIntPsi(q.varpiEI.I.psiH),QQpi,n)-q.varpiEI.p_IH*q.varpiEI.I.sH*TMatr.getAMatrB(q.varpiEI.I.psiH,q.getEIntPsi(q.varpiEI.I.psiH),QQt,n),"var",eps);
    UnitTests.checkDoubleRel(q.varpiEI.var_p_IL,"q.varpiEI.var_p_IL",TMatr.getAMatrB(q.varpiEI.I.psiL,q.getEIntPsi(q.varpiEI.I.psiL),QQpi,n)-q.varpiEI.p_IL*q.varpiEI.I.sL*TMatr.getAMatrB(q.varpiEI.I.psiL,q.getEIntPsi(q.varpiEI.I.psiL),QQt,n),"var",eps);

    for(int k=0;k<n;k++)
    {
	final double [] Psi=q.I.getPsi(k),DPsi=q.getEDPsi(Psi),IntPsi=q.getEIntPsi(Psi);
	UnitTests.checkDoubleArrayRel(Psi,"Psi",q.getEIntPsi(DPsi),"Int(D(Psi))",eps);
	UnitTests.checkDoubleArrayRel(Psi,"Psi",q.getEDPsi(IntPsi),"D(Int(Psi))",eps);
	UnitTests.checkDoubleArrayRel(DPsi,"DPsi",TMatr.getMatr_x_A(n,D,Psi),"D Psi",eps);
	UnitTests.checkDoubleArrayRel(IntPsi,"IntPsi",TMatr.getMatr_x_A(n,Int,Psi),"Int Psi",eps);
	UnitTests.checkDoubleRel(2*TMatr.getAMatrB(Psi,IntPsi,QQt,n),"2<Psi|IntPsi>",Math.pow(q.M.B.getD0(IntPsi,x0),2),"IntPsi(x0)^2",eps);
	UnitTests.checkDoubleRel(TMatr.getAMatrA(Psi,QQtIn,n),"<Psi|QQtIn|Psi>",Math.pow(q.M.B.getD0(IntPsi,x0),2),"IntPsi(x0)^2",eps);
	UnitTests.checkDoubleRel(2*TMatr.getAMatrB(Psi,DPsi,QQt,n),"2<Psi|DPsi>",Math.pow(q.M.B.getD0(Psi,x0),2),"Psi(x0)^2",eps);
	UnitTests.checkDoubleRel(TMatr.getAMatrA(Psi,QQtD,n),"<Psi|QQtD|Psi>",Math.pow(q.M.B.getD0(Psi,x0),2),"Psi(x0)^2",eps);
	UnitTests.checkDoubleRel(TMatr.getAMatrA(Psi,QQtD_,n),"<Psi|QQtD_|Psi>",Math.pow(q.M.B.getD0(Psi,x0),2),"Psi(x0)^2",eps);
	UnitTests.checkDoubleRel(TMatr.getAMatrA(Psi,DQQD,n),"<Psi|DQQD|Psi>",TMatr.getAMatrA(DPsi,QQt,n),"<Dpsi|Dpsi>",eps);
	System.err.println("x0="+x0+" DPsi(x0)="+q.M.B.getD0(DPsi,x0)+" IntPsi(x0)="+q.M.B.getD0(IntPsi,x0));
    }
    System.err.println(name+":YpnlQVMTest:test_EintMatchDps(): test OK n="+n+" eps="+eps);
}

void test_Calculations(final int tsize,final int neq)
{
    System.err.println();
    System.err.println("------------------------------------------------------------------------");
    System.err.println(name+":YpnlQVMTest:test_Calculations(): test with N points="+tsize+
		       " neq="+neq+" eps="+eps);

    setData(tsize,neq);
    test_Extra();
    test_w(true);
    test_w(false);
    test_DI();
    test_D2I();
    test_EVX2();
    test_EintMatchDpsi();
    test_DynVarXk_shift();
    test2_DynVarXk_shift();
    test_DynVarC();

    System.err.println(name+":YpnlQVMTest:test_Calculations(): test OK with N points="+tsize+
		       " neq="+neq+" eps="+eps);
}
void runTests(final int neq_max)
{
    System.err.println(name+":YpnlQVMTest: starting tests; ver=$Id: YpnlQVM.java,v 1.315 2022/11/19 11:08:58 mal Exp $");
    final long t0=System.currentTimeMillis();
    for(int neq=2;neq<=neq_max;neq++)
    {
	for(int i=0;i<119;i++)
	{
	    test_Calculations(1950+r.nextInt(1850),neq);
	}
    }
    final long t1=System.currentTimeMillis();
    System.err.println(name+":YpnlQVMTest: tests OK done in "+(t1-t0)+" milliseconds. neq_max="+neq_max+" ver=$Id: YpnlQVM.java,v 1.315 2022/11/19 11:08:58 mal Exp $");
}
} // END OF class YpnlQVMTest




}// END OF class YpnlQVM
