package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.Laguerre;
import com.polytechnik.realtimebook.*;

public class ZVQVMLaguerre extends ZVQVM<QVMDataL> {

ZVQVMLaguerre(final int neq,final QVMDataL odata){super(neq,odata);}

public static ZVQVMLaguerre calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final ZVQVMLaguerre ref)
{
    final int npm=3;
    final QVMDataL o=QVMDataL.calculateQVMDataL(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new ZVQVMLaguerre(neq,o);
}

DeprecatedHelperQVMDataLDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataLDirectAccessWithBasis();}
double getX0(){return 0;}

static class ZVQVMLaguerreTest extends ZVQVMTest<QVMDataL> {
ZVQVMLaguerreTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
void setData(final int tsize,final int neq)
{
    this.neq=neq;
    this.tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
    this.currenttime=tb[tb.length-1].time+1000;
    this.tau=(tb[tb.length-1].time-tb[0].time)/24;
}
ZVQVMLaguerre getZVQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
XQVMLaguerre getXQVM(){return XQVMLaguerre.calculate(neq,currenttime,tau,tb,tb.length,null);}


} // END of class ZVQVMLaguerreTest

public static void main(String [] args)
{
    new ZVQVMLaguerreTest("ZVQVMLaguerre").runTests(5);
} // END main



} // END OF class ZVQVMLaguerre
