package com.polytechnik.trading;
/*
 * (C) Vladislav Malyshkin 2012
 * This file is under GPL version 3.
 *
 */
import com.polytechnik.utils.UnitTests;
import com.polytechnik.utils.TMatr;
import com.polytechnik.utils.Polynomials;
import com.polytechnik.utils.LegendreShifted;
import com.polytechnik.realtimebook.*;

public class ZVQVMLegendreShifted extends ZVQVM<QVMDataP> {

ZVQVMLegendreShifted(final int neq,final QVMDataP odata){super(neq,odata);}

public static ZVQVMLegendreShifted calculate(final int neq,
					    final long currenttime,
					    final long tau,
					    final Trade [] tb,
					    final int tsize,
					    final ZVQVMLegendreShifted ref)
{
    final int npm=3;
    final QVMDataP o=QVMDataP.calculateQVMDataP(2*neq-1,
						npm,
						currenttime,
						tau,
						tb,
						tsize,
						ref!=null?ref.odata:null);
    return new ZVQVMLegendreShifted(neq,o);
}

DeprecatedHelperQVMDataPDirectAccessWithBasis getAccess(){return new DeprecatedHelperQVMDataPDirectAccessWithBasis();}
double getX0(){return 1;}

static class ZVQVMLegendreShiftedTest extends ZVQVMTest<QVMDataP> {
ZVQVMLegendreShiftedTest(final String name)
{
    super(name,new java.util.Random(6871L),1e-4);
}
void setData(final int tsize,final int neq)
{
    this.neq=neq;
    this.tb=CalculateKendall.TradeEMoments.getRandomTrades(tsize,r);
    this.currenttime=tb[tb.length-1].time+1;
    this.tau=((tb[tb.length-1].time-tb[0].time)/3)/(9*5*7*8*11)*(9*5*7*8*11);
    //System.err.println("tau="+tau);
}
ZVQVMLegendreShifted getZVQVM(){return calculate(neq,currenttime,tau,tb,tb.length,null);}
XQVMLegendreShifted getXQVM(){return XQVMLegendreShifted.calculate(neq,currenttime,tau,tb,tb.length,null);}

} // END of class ZVQVMLegendreShiftedTest

public static void main(String [] args)
{
    new ZVQVMLegendreShiftedTest("ZVQVMLegendreShifted").runTests(5);
} // END main



} // END OF class ZVQVMLegendreShifted
