package com.polytechnik.utils;

/** Cache basis functions multiplication.
 *
 * @version $Id: BasisFunctionsMultiplicationCache.java,v 1.4 2019/10/10 08:16:41 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public class BasisFunctionsMultiplicationCache implements BasisFunctionsMultipliable {
    private final java.util.ArrayList<double [][]> cache=new java.util.ArrayList<>();
    private final BasisFunctionsMultipliable multiplier;

    public BasisFunctionsMultiplicationCache(final BasisFunctionsMultipliable multiplier){
	this.multiplier=multiplier;
    }

    public void setQlQmExpansionCoefs(final int l,final int m,final double [] s){
	if(false){ // set to true to disable cache
	    multiplier.setQlQmExpansionCoefs(l,m,s);return;
	}
	if(l>m){
	    setQlQmExpansionCoefs(m,l,s);
	    return;
	}
	for(int k=m-cache.size();k>=0;k--){
	    cache.add(null);
	}
	double [][] c=cache.get(m);
	if(c==null){
	    cache.set(m,c=new double [m+1][]);
	}
	double [] mul=c[l];
	if(mul==null){
	    this.multiplier.setQlQmExpansionCoefs(l,m,mul=c[l]=new double [l+m+1]);
	}
	System.arraycopy(mul,0,s,0,l+m+1);
    }

}
