package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2015
 * This file is under GPL version 3.
 *
 */

/**
 *  Calculate Nevai operator from moments.
 *  @version $Id: NevaiOperator.java,v 1.16 2022/08/08 20:10:48 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class NevaiOperator {

public static PolynomialsRatio getNevaiOperator_FromMoments(final int n,final double [] tmom,final double [] fmom, final BasisFunctionsCalculatable B)
{
    final double [] QQf=B.getQQMatr(n,fmom),QQt=B.getQQMatr(n,tmom),
	IQQt=com.polytechnik.utils.Linsystems.getInvertedMatrix(n,n,QQt),
	QQ_I_f_I=TMatr.mulMMM(n,IQQt,QQf,IQQt);
    return new PolynomialsRatio(B.getKK(n,IQQt),B.getKK(n,QQ_I_f_I),B);
}
}
