package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */

/** Manupulate orthogonal polynomials using shifted Legendre as basis.
 *  @version $Id: OrthogonalPolynomialsLegendreShiftedBasis.java,v 1.39 2020/09/27 20:14:06 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class OrthogonalPolynomialsLegendreShiftedBasis extends OrthogonalPolynomialsBasisFunctionsCalculatable<LegendreShifted> {

public OrthogonalPolynomialsLegendreShiftedBasis(){super(new LegendreShifted());}

public double [] getRadauMultiplied(final double [] nodes0)
{
    // multiply by 1-x
    return B.getaxbP(nodes0,-1,1);
}


/** A unit test.
 */
public static void main(String [] args)
{
    new TestOrthogonalPolynomialsBasisFunctionsCalculatable("BasisLegendreShifted",
		      new OrthogonalPolynomialsLegendreShiftedBasis(),
		      1e-6,
		      new java.util.Random(81311L),
		      0,1)
    {
	@Override void test_RadauMoments_directly_Bbasis(final double [] bnodes,final double [] rbnodes)
	{
	    final double [] res=LegendreShifted.get1mXPnMomentsFromPnMoments(bnodes);
	    UnitTests.checkDoubleArrayRel(res,"res",rbnodes,"rbnodes",eps);
	    System.err.println(name+":test_RadauMoments_directly_Bbasis test OK n="+bnodes.length+" eps="+eps);
	}
    }.runTests(7);
}

}
