package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2011
 * This file is under GPL version 3.
 *
 */

/** Manupulate orthogonal polynomials using Monomials as basis.
 *  @version $Id: OrthogonalPolynomialsMonomialsBasis.java,v 1.62 2020/09/27 20:14:06 mal Exp $
 *  @author Vladislav Malyshkin mal@gromco.com
 */
public class OrthogonalPolynomialsMonomialsBasis extends OrthogonalPolynomialsBasisFunctionsCalculatable<Monomials> {

public OrthogonalPolynomialsMonomialsBasis(){super(new Monomials());}

/** Multiply by (1-x).
 */
public double [] getRadauMultiplied(final double [] nodes0)
{
    return Polynomials.get1mxP(nodes0);
}


/** A unit test.
 */
public static void main(String [] args)
{
    new TestOrthogonalPolynomialsBasisFunctionsCalculatable("BasisMonomials",
		      new OrthogonalPolynomialsMonomialsBasis(),
		      1e-5,
		      new java.util.Random(8831L),
		      -0.9,1)
    {
	@Override void test_RadauMoments_directly_Bbasis(final double [] bnodes,final double [] rbnodes)
	{
	    final double [] res=O.B.getXQkMomentsFromQkMoments(bnodes);
	    for(int k=res.length;--k>=0;) {res[k]=bnodes[k]-res[k];}
	    UnitTests.checkDoubleArrayRel(res,"res",rbnodes,"rbnodes",eps);
	    System.err.println(name+":test_RadauMoments_directly_Bbasis test OK n="+bnodes.length+" eps="+eps);
	}
    }.runTests(6);
}

}
