package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2019
 * This file is under GPL version 3.
 *
 */

/** An interface to access a single calculated Radon-Nikodym point.
 * @version $Id: RNPointAccess.java,v 1.3 2019/10/27 13:07:44 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public interface RNPointAccess {
    /** An evaluation of Radon-Nikodym derivative.
     */
    double getRN();
    /** 1/K(x)= 1/ Christoffel function(x).
     */
    double getChristoffelOatX();
    /** Least Squares.
     */
    double getLS();
}
