% $Id: RNPointAccess.m,v 1.1 2020/02/11 09:45:12 mal Exp $

%/**
% * (C) Vladislav Malyshkin 2020
% * This file is under GPL version 3.
% *
% * Slow and simple test of Lebesgue quadratures.
% *
% * To simplify unit tests with java.
% *
% * @version $Id: RNPointAccess.m,v 1.1 2020/02/11 09:45:12 mal Exp $
% * @author Vladislav Malyshkin mal@gromco.com
% */

classdef RNPointAccess
  properties
    rn;ls;ochristoffel;
  endproperties
  methods
  % Lebesgue quadrature constructor.
  % See https://arxiv.org/abs/1807.06007 for details.
    function self = RNPointAccess(rn,ls,ochristoffel)
      self.ls=ls;
      self.rn=rn;
      self.ochristoffel=ochristoffel;
    endfunction

    function rn = getRN(self)
      rn=self.rn;
    endfunction
    function ls = getLS(self)
      ls=self.ls;
    endfunction
    function ochristoffel = getChristoffelOatX(self)
      ochristoffel=self.ochristoffel;
    endfunction

  endmethods

endclassdef
