package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2019
 * This file is under GPL version 3.
 *
 */

/** An interface to evaluate Radon-Nikodym at given point.
 * @version $Id: RNPointEvaluatable.java,v 1.3 2020/10/17 08:38:17 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
@FunctionalInterface
public interface RNPointEvaluatable {
    /** An evaluation of Radon-Nikodym derivative.
     */
    RNPointAccess getRNatXoriginal(final double [] xorig);

    default java.util.List<RNPointAccess> evaluateRNatSequence(final java.util.List<? extends ObservationVectorXF> data){
	final java.util.ArrayList<RNPointAccess> evaluations=new java.util.ArrayList<>();
	for(ObservationVectorXF o:data){
	    evaluations.add(getRNatXoriginal(o.x));
	}
	return evaluations;
    }
}
