package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2021
 * This file is under GPL version 3.
 *
 */

/** An interface to evaluate a vector-to-vector mapping at given point.
 * @version $Id: VectorXVectorFPointEvaluatable.java,v 1.6 2024/04/04 21:11:53 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 * @see VectorXVectorFPointAccess
 */
@FunctionalInterface
public interface VectorXVectorFPointEvaluatable {
    /** An evaluation of Vector X to Vector F model.
     */
    VectorXVectorFPointAccess evaluateAt(final double [] xorig);

    default java.util.List<VectorXVectorFPointAccess> evaluateAtSequence(final java.util.List<? extends ObservationVectorXVectorF> data){
	final java.util.ArrayList<VectorXVectorFPointAccess> evaluations=new java.util.ArrayList<>();
	for(ObservationVectorXVectorF o:data){
	    evaluations.add(evaluateAt(o.x));
	}
	return evaluations;
    }
}
