package com.polytechnik.utils;
/*
 * (C) Vladislav Malyshkin 2019
 * This file is under GPL version 3.
 *
 */

/** A class to store two matrices.
 * @version $Id: XXMatrs.java,v 1.4 2020/10/19 13:59:11 mal Exp $
 * @author Vladislav Malyshkin mal@gromco.com
 */
public class XXMatrs {
    public final int dim1,dim2;
    public final double [] XfX,XX;
    public XXMatrs(final int dim1,final int dim2,final double [] XfX,final double [] XX){
	this.dim1=dim1;this.dim2=dim2;this.XfX=XfX;this.XX=XX;
	final int s=dim1*dim2;
	if(s!=XX.length||s!=XfX.length) throw new IllegalArgumentException();
    }
    public double getXX(final int i,final int j){return XX[i*dim2+j];}
    public double getXfX(final int i,final int j){return XfX[i*dim2+j];}
    public double [][] getXXAsArrayOfArrays(){
	final double [][] a=new double [dim1][dim2];
	for(int k=0;k<dim1;k++){System.arraycopy(XX,k*dim2,a[k],0,dim2);}
	return a;
    }
    public double [][] getXfXAsArrayOfArrays(){
	final double [][] a=new double [dim1][dim2];
	for(int k=0;k<dim1;k++){System.arraycopy(XfX,k*dim2,a[k],0,dim2);}
	return a;
    }
} // END OF class XXMatrs
